      SUBROUTINE GRAF
C
C-----Deklarationen                            
      PARAMETER (NPRO=1600)  ! Anzahl Proben
      PARAMETER (NPAR=400)  ! Anzahl Parameter
      CHARACTER*1 M, M1, M2, M3, M4, M2A, M2B, M2C, M2D, SILTIG
      CHARACTER*30 FILIN, FILOUT, FOUT, TDAT, FIRD, FILNAM,
     *          PARA(NPAR)*40, KERN*6, KERN1*6, LLL*70, KKEN*4,
     *          FMT*45, NW*10, INCHAR*3, CVAR*3, CRES*3, AT*4,
     *          FSEDI*30, SSILT(5)*17, GFRAK(5)*17, CIN*4, CLS*10,
     *          KPTEXT(25)*50, XTEXT*25, TZ*1, 
     *          JN*1, JNN*1
      INTEGER   NS, NV, KEN(NPAR), VAROUT(NPAR), KPT, COL(3,150),
     *          REST, KTEST(NPAR), KENZ, IRD(2000), SUMIRD, FARB(2),
     *          ANTI(25), ANZGR,
     *          PF(50), PFZUS(50), PAR3(3), KOLOR(16), KOL2(2)
      REAL      FELD(NPAR,NPRO), XIN(NPRO,2), XOUT(NPRO*10,2), PT,
     *          TNEW, DUMMY, PINTE, GSF(6), FORM, SEDI(51),
     *          TIEF(25,NPRO),
     *     SPX(100), SPY(100), Y2(200), PROD(7), F(7), DATEN(15),
     *     GSUMX(101), GSUMY(101), SUMX(51), SUMY(51),
     *     MEAN, SKEW, KURT, SORT,
     *     AMIN(50), AMAX(50), XX(NPRO), YY(NPRO), TT(NPRO), 
     *     XBAR(2000), YBAR(2000), XX2(NPRO), YY2(NPRO)    !
      CHARACTER*2 PHIT(11), PROZ(7), PHI*3, WORT(16)*6, KN*7,
     * ENGL(NPAR)*20, TEXT*25, JN4*5, JUP*1, FAR*1, TAG*9, ZEIT*8   !
      CHARACTER*1 PROP, LITH, IRDR, SSTV, MICK, MAGN, MAGA, JNJ, JM
C
      COMMON /GRAF/ BOT, TOP, SMS
      COMMON / PA / PARA, ENGL, COL
      COMMON / MM / MMFLAG
      COMMON /FE/ FELD, TIEF, KPT, KEN, ANTI, KPTEXT, JSN
C 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1111 CONTINUE
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
      WRITE (6,1001)
 1001 FORMAT (//,
     *12X,' ********************************************************'/
     *12X,' ********************** G R A F *************************'/
     *12X,' ********************************************************'/
     *12X,'  grafische Korrelation mehrerer Parameter an einem Kern')
      WRITE (6, '(/,1A,12X,A)') '$', 'Kern-Nr.: '
C
C-----externen Datensatz oeffnen
      READ  (5, '(A)') KERN
      IF (KERN(1:1) .EQ. '0') KKEN = 'ODP '
      IF (KERN(1:1) .NE. '0') KKEN = '  PS'
      FILNAM = 'SYS$USER:[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'SED'
      OPEN (99, FILE=FILNAM, STATUS='OLD', FORM='UNFORMATTED')
C
C.....Anzahl der Proben {ANTI(K)} und Probentiefen {TIEF(K,I)} einlesen
      DO K=1,25
         READ (99) ANTI(K), (TIEF(K,I), I=1,ANTI(K))
         IF (ANTI(K) .NE. 0) READ (99) KPTEXT(K)
      END DO
C
C.....lithologische Grenzen einlesen     
      READ (99) SUMIRD            
      READ (99) TOP, BOT, ANZGR              
C
C.....Sedimentparameter einlesen
  199 CONTINUE
      READ (99, END=177) KTIEF, KENZ, (FELD(KENZ,I), I=1,ANTI(KTIEF))
      KEN(KENZ) = KTIEF
      GOTO 199
  177 CONTINUE
      CLOSE (99)
C==============================================================================
      NZEIT = 0
      WRITE (6,'(/,A)') '$Plot gegen <T>iefe oder <Z>eit ? [T]> '
      READ  (5,'(A)') TZ
      CALL CAPS(TZ)
      IF (TZ .EQ. 'Z') NZEIT = 10
C
  188 CONTINUE
CCC      IF (KEN(284) .NE. 0) THEN
CCC         WRITE (6,'(A)') '$Siltfraktionen           [N] > '
CCC         READ  (5,'(A)') SILTIG
CCC         CALL CAPS(SILTIG)
CCC      END IF
C____________________________________________________________________________
10100 CONTINUE
      DO IX = 1,50
         PF(IX) = 0
         PFZUS(IX) = 0
      END DO
C
C.....Eingabe der Parameter
10200 CONTINUE
      IF (IZ .EQ. 0) WRITE (6,'(/,A)') 
     *                  ' Eingabe der Kennungen (Exit = 99999)'
      WRITE (6,'(/,A)') ' -------------------------------------------'
      WRITE (6,'(A,I4,A)') '$', IZ+1, '. Parameter  => '
      READ  (5,*) PF(IZ+1)
C
      IF (PF(IZ+1) .EQ. 99999) GOTO 20000                     ! Ende der Eingabe
      IF (KEN(PF(IZ+1)) .EQ. 0) THEN
         WRITE (6,'(/,A)') '$keine Daten ! 99999 fuer nicht plotten'
         WRITE (6,'(A)')      '$Min. Abszissenwert => '
         READ  (5,*) AMIN(IZ+1)
         IF (AMIN(IZ+1) .EQ. 99999.) THEN
            AMIN (IZ+1) = 0.
            GOTO 10200
         END IF
         WRITE (6,'(A)')      '$Max. Abszissenwert => '
         READ  (5,*) AMAX(IZ+1)
         IZ = IZ+1
         GOTO 10200
      END IF
C
      IZ = IZ+1
      WRITE (6,'(X,A40)') PARA(PF(IZ))
C
C.....Min und Max bestimmen und anfordern
      DO NIZ = 1,ANTI(KEN(PF(IZ)))
         YY2(NIZ) = FELD(PF(IZ),NIZ)
      END DO
      MMFLAG = 0
      CALL MINMAX (ANTI(KEN(PF(IZ))),YY2,AMIN(IZ),AMAX(IZ))
      GOTO 10200
C____________________________________________________________________________
20000 CONTINUE
      WRITE (6,'(/,A)')                '$2. Parameter plotten? [N] > '
      READ  (5,'(A)') JN
      CALL CAPS(JN)
      IF (JN .EQ. 'J') THEN
         WRITE (6,'(A)') '$1. Parameter >> '
         READ  (5,'(I4)') I1
         WRITE (6,'(A)') '$2. Parameter >> '
         READ  (5,'(I4)') I2
         DO IA = 1,IZ
            IF (PF(IA) .EQ. I1) PFZUS(IA) = I2
         END DO
         GOTO 20000
      END IF
C____________________________________________________________________________
C.....grafische Darstellung 
      WRITE (6,'(A)')                  '$Abszissenlaenge (mm)      > '
      READ  (5,*) YSIZE
      WRITE (6,'(A)')                  '$Marker plotten  [N]       > '
      READ  (5,'(A)') JM
      CALL CAPS(JM)
      IF (TZ .NE. 'Z') WRITE (6,'(A)') '$Masstab                1 :  '
      IF (TZ .EQ. 'Z') WRITE (6,'(A)') '$Laenge der Zeitachse (mm) > '
      READ  (5,*) SMS
      WRITE (6,'(A)')                  '$farbig          [N]       > '
      READ  (5, '(A)') FAR
      CALL CAPS(FAR)
      WRITE (6,'(A)')                  '$UNIPICT-File    [N]       > '
      READ  (5, '(A)') JUP
      CALL CAPS(JUP)
      IF (TZ .EQ. 'Z') THEN
         XSIZE = SMS
         ZBOT  = TIEF(11,ANTI(11))
         WRITE (6,'(A,F8.2,A)') 
     *          ' Basisalter                > ', ZBOT, ' k.y.'
         WRITE (6,'(A)')               '$gewuenschtes Alter (k.y.) > '
         READ  (5,*) ZBOT   
      END IF
C
C.....Groesse und Position des Plots       
      IF (TZ .NE. 'Z') THEN
         ZBOT  = TIEF(KEN(PF(I)),ANTI(KEN(PF(I))))
         IF (KEN(PF(I)) .EQ. 0.) ZBOT = BOT
         XSIZE = (ZBOT-TOP)*1000./SMS
      END IF
C
      CALL LUGRAF (1,IOUT)
      CALL GPRINT(0)
      CALL GOPEN
      IF (JUP .EQ. 'J') CALL GSEGCR(1)
      IF (IOUT .GT. 2) CALL GCHARF('SOFT')
      CALL GCHARF('SHA4')
      IF (IOUT .EQ. 8 .OR. IOUT .EQ. 9 .OR. IOUT .EQ. 10) 
     *    CALL GCHARF('SIMP')
20100 CONTINUE
      POSI = 0.0
C------------------------------------------------------------------------------
C.....Anfang der Grafikschleife
C------------------------------------------------------------------------------
20299 CONTINUE
      IKOL = 0
      DO 20200 I = 1, IZ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      IZTIEF = ANTI(KEN(PF(I))+NZEIT)        ! Anzahl der Datenpaare
      I2TIEF = ANTI(KEN(PFZUS(I))+NZEIT)     
      SUM = 0.
      DO IA = 1, IZTIEF                ! fuer Standardtiefen
         IF (TIEF(KEN(PF(I))+NZEIT,IA) .GT. ZBOT) THEN
            ITIEF = IA-1
            GOTO 20191
         END IF
         XX(IA)  = TIEF(KEN(PF(I))+NZEIT,IA)
         YY(IA)  = FELD(PF(I),IA)
         SUM = SUM + YY(IA)
      END DO
      DO IA = 1, I2TIEF                ! fuer Standardtiefen
         XX2(IA) = TIEF(KEN(PFZUS(I))+NZEIT,IA)
         YY2(IA) = FELD(PFZUS(I),IA)
      END DO
C------------------------------------------------------------------------------
C.....undefinierte Werte rauswerfen
      ITIEF = IZTIEF
20191 CONTINUE
      DO MI = 1, ITIEF
         IF (YY(MI) .EQ. 9999.0) THEN
            DO MJ = MI, IZTIEF-1
               YY(MJ) = YY(MJ+1)
               XX(MJ) = XX(MJ+1)
            END DO
            ITIEF = ITIEF - 1
            GOTO 20191
         END IF
      END DO
C
      IF (PFZUS(I) .NE. 0) THEN
         I2ATIE = I2TIEF 
20193    CONTINUE
         DO MI = 1, I2ATIE
            IF (YY2(MI) .EQ. 9999.0) THEN
               DO MJ = MI, I2TIEF-1
                  YY2(MJ) = YY2(MJ+1)
                  XX2(MJ) = XX2(MJ+1)
               END DO
               I2TIEF = I2TIEF - 1
               GOTO 20193
            END IF
         END DO
      END IF
C==============================================================================
C.....Anfang Grafikanweisungen
20300 CONTINUE
      CALL BGRAF(20.,20.+POSI,XSIZE,YSIZE)
Cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
C.....Achsenbeschriftung und Labels X-Achse
      IF (POSI .EQ. 0.) CALL BAXLAB (3.3,3.,0,0)
      IF (POSI .NE. 0.) CALL BAXLAB (0.,0.,999,999)
C.....Tickmarks fuer X-Achse
      IF (TZ .NE. 'Z') CALL BTICKM(10)
      IF (TZ .EQ. 'Z') CALL BTICKM(5)
C.....Abstand der Labels
                              VSTEP = 1. 		! je 1   Meter
      IF (ZBOT .GT. 50.)      VSTEP = 20.	        ! je 20  Meter
      IF (ZBOT .GT. 1000.)    VSTEP = 250.              ! je 250 Meter
      IF (SMS .LE.  10.)      VSTEP = .1	        ! je 0.1 Meter
C.....Label drehen
      CALL BAXANG(90)
C.....X-Achse zeichnen
      IF (TZ .NE. 'Z') CALL BAXIS
     * (1,TOP,VSTEP,ZBOT,'Depth (m) '//KKEN//KERN//'$')
      IF (TZ .EQ. 'Z') CALL BAXIS
     * (1,.0, 50., ZBOT ,'Time (ka) '//KKEN//KERN//'$')
C.....Gitterlinien zeichnen
      CALL BGRID(1,0)
Cyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy
C.....Achsenbeschriftung und Labels Y-Achse
      SG = YSIZE
      IF (SG .LT. 25.) SG = 25.
      IF (AMAX(I)-AMIN(I) .LT. 3.) THEN
         CALL BAXLAB (SG*0.07,2.5,1,0)
         GOTO 20310
      END IF         
      IF (AMAX(I) .GE. 3.) CALL BAXLAB (SG*0.07,2.5,0,0)
      IF (AMAX(I) .LT. 3.) CALL BAXLAB (SG*0.07,2.5,1,0)
C.....Tickmarks fuer Y-Achse
20310 CONTINUE
      CALL BTICKM(5)
C.....letztes Label unterdruecken
      CALL BAXEND(1)
C.....Label drehen
      CALL BAXANG(90)
C.....Y-Achse zeichnen
      TEXT = '  '//ENGL(PF(I))//'$'
      IF (SUM .EQ. 0.) TEXT = 'no data$'
      CALL BAXIS(2,AMIN(I),0.0,AMAX(I),TEXT)
      IF (SUM .EQ. 0.) GOTO 20199
C.....Markertyp (Symbol,Marker verbinden)
      IF (JM .EQ. 'J') THEN
         CALL BMARK  (20,1)
C.....Markergroesse in mm
         CALL BMARKH(2.)
C.....Markerfarbe
         CALL BMARKC (1)
      END IF
C.....Liniendicke in mm (+x) oder Pixel (-x)
      CALL BLIWDH (.3)
C.....Linienfarbe
CCC      IF (TZ .EQ. 'Z') CALL BLICOL(2)
C.....Flaechenfarbe der Kurve (Farbarray, Anz.Farben)
      FARB(1) = COL(1,PF(I))
      IF (FAR .EQ. 'J') CALL BCOLOR (FARB,1)
C
      IF (PFZUS(I) .EQ. 0) THEN                               ! 1 Kurve plotten
         IF (FAR .EQ. 'J') CALL BLISHD 
     *               (XX,YY,ITIEF,999.999,999.999,0)  
         CALL BLINE  (XX,YY,ITIEF)
      ELSE
         IF (PF(I) .EQ. PFZUS(I)) GOTO 20350
         IF (FAR .EQ. 'J') CALL BLISHD 
     *               (XX,YY,ITIEF,XX2,YY2,I2TIEF)            ! 2 Kurven plotten
         CALL BLINE  (XX2,YY2,I2TIEF)
C
         IF (JM .EQ. 'J') THEN
            IF (FAR .EQ. 'J') THEN
               CALL BMARK  (20,1)
            ELSE
               CALL BMARK  (4,1)
            END IF
         END IF
CCC         CALL BDASH  (4)       
20350    CALL BLINE  (XX,YY,ITIEF)
      END IF
20199 POSI = POSI+YSIZE                             ! neuen Ursprung berechnen
20200 CONTINUE
C------------------------------------------------------------------------------
C.....Ende der Grafikschleife
C------------------------------------------------------------------------------
C.....Siltfraktionen
26000 CONTINUE
      IF (SILTIG .NE. 'J') GOTO 30000
C.....Groesse und Position des Plots       
      CALL BGRAF(20.,20.+POSI,XSIZE,130.)
Cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
C.....Achsenbeschriftung und Labels X-Achse
      IF (POSI .EQ. 0.) CALL BAXLAB (5.,4.,0,0)
      IF (POSI .NE. 0.) CALL BAXLAB (0.,0.,999,999)
C.....Tickmarks fuer X-Achse
      CALL BTICKM(10)
C.....Label drehen
      CALL BAXANG(90)
C.....X-Achse zeichnen
      VSTEP = 1.
      IF (VMAX .GT. 50.) VSTEP = 20.
      IF (SMS .LE.  10.) VSTEP = .1
      CALL BAXIS(1,TOP,VSTEP,ZBOT,XTEXT)
C.....Gitterlinien plotten
      CALL BGRID(1,0)
Cyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy
C.....Achsenbeschriftung und Labels Y-Achse
      CALL BAXLAB (SG * 0.07,0,0,0)
C.....Y-Achse zeichnen
      CALL BTICKM(0)
      CALL BAXIS(2,0.0,2.5,25.0,'Siltfractions$')
C.....Liniendicke in mm (+x) oder Pixel (-x) und Farbe
      CALL BLIWDH (.1)
      CALL BLICOL (1)
C.....Siltfraktionen plotten
      DO I = 284, 333
         DO IA = 1, ANTI(KEN(284))
            XX(IA)  = TIEF(KEN(284),IA)
            YY(IA)  = FELD(I,IA) + 0.44*(I-284.)
         END DO
         CALL BLINE  (XX,YY,ANTI(KEN(284)))
      END DO
      POSI = POSI + 130.
C------------------------------------------------------------------------------
C.....letzte Achse zeichnen
30000 CONTINUE
      CALL GVECT(20.,20.+POSI,0)
      CALL GVECT(20.+XSIZE,20.+POSI,1)
C
C.....Institut, Datum schreiben
      CALL DATE(TAG)
      CALL GCHAR 
     *     ('AWI * SEDAN * '//TAG//'$',20.,21.+POSI,1.5)
      IF (TZ .NE. 'Z') THEN
         CALL GCHAR (' * Scale 1 :$',9999.,9999.,1.5)
         CALL GNUMB (SMS, 9999.,9999.,1.5,0)
      ELSE
         CALL GCHAR (' * TimePlot$',9999.,9999.,1.5)
      END IF       
      IF (JUP .EQ. 'J') CALL GSEGCL(1)
      READ (5,'(A)') JM
      CALL GCLOSE
12345 END      
C******************************************************************************
C.....Min-Max-Bestimmung
      SUBROUTINE MINMAX (NTIEF,Y,AMIN,AMAX)
C
      REAL Y(2000)
      COMMON / MM / MMFLAG
C
      PMIN = 1000000.
      PMAX = -1000000.
      DO I = 1, NTIEF
         IF (Y(I) .LT. PMIN) PMIN = Y(I)
         IF (Y(I) .GT. PMAX) THEN
            IF (Y(I) .NE. 9999.0) PMAX = Y(I)
         END IF
      END DO
      IF (MMFLAG .EQ. 1) THEN
         AMIN = PMIN
         AMAX = PMAX
         GOTO 1234
      END IF
      WRITE (6,'(/,A,F12.3)') '$Minimalwert  =>       ', PMIN
      WRITE (6,'(  A,F12.3)') '$Maximalwert  =>       ', PMAX
      WRITE (6,'(A)')      '$Min. Abszissenwert => '
      READ  (5,*) AMIN
      WRITE (6,'(A)')      '$Max. Abszissenwert => '
      READ  (5,*) AMAX
 1234 END