      SUBROUTINE KORP
C.....Korrelationsplot fuer mehrere (max. 25) Kerne
C
C-----Deklarationen                            
      PARAMETER (NPRO=1600)  ! Anzahl Proben
      PARAMETER (NPAR=400)   ! Anzahl Parameter
      PARAMETER (NTIEF=25)   ! Anzahl Tiefenserien
      CHARACTER*1 M, M1, M2, M3, M4, M2A, M2B, M2C, M2D, SILTIG
      CHARACTER*30 FILIN, FILOUT, FOUT, TDAT, FIRD, FILNAM,
     *          PARA(NPAR)*40, KERN*6, KERN1*6, LLL*70, KKEN*4,
     *          FMT*45, NW*10, INCHAR*3, CVAR*3, CRES*3, AT*4,
     *          FSEDI*30, SSILT(5)*17, GFRAK(5)*17, CIN*4, CLS*10,
     *          KPTEXT(NTIEF)*50, XXTEXT*50, XTEXT*9, TZ*1
      INTEGER   NS, NV, KEN(NPAR), VAROUT(NPAR), KPT, COL(3,150),
     *          REST, KTEST(NPAR), KENZ, IRD(2000), SUMIRD, FARB(2),
     *          ANTI(NTIEF), ANZGR,
     *          PF(50), PFZUS(50), PAR3(3), KOLOR(16), KOL2(2)
      REAL      FELD(NPAR,NPRO), XIN(NPRO,2), XOUT(NPRO*10,2), PT,
     *          TNEW, DUMMY, PINTE, GSF(6), FORM, SEDI(51),
     *          TIEF(NTIEF,NPRO),
     *     SPX(100), SPY(100), Y2(200), PROD(7), F(7), DATEN(15),
     *     GSUMX(101), GSUMY(101), SUMX(51), SUMY(51),
     *     MEAN, SKEW, KURT, SORT,
     *     AMIN(50), AMAX(50), XX(NPRO), YY(NPRO), TT(NPRO), 
     *     MAG(10), XBAR(2000), YBAR(2000), XX2(NPRO), YY2(NPRO)    !
      CHARACTER*2 PHIT(11), PROZ(7), PHI*3, WORT(16)*6, KN*7,
     * ENGL(NPAR)*20, TEXT*25, JN4*5, JUP*1, FAR*1, TAG*9, ZEIT*8   !
      CHARACTER*1 PROP, LITH, IRDR, SSTV, MICK, MAGN, MAGA, JNJ, JM
C
      COMMON / PA / PARA, ENGL, COL
      COMMON /GRAF/ BOT, TOP, SMS
      COMMON /FE/ FELD, TIEF, KPT, KEN, ANTI, KPTEXT, JSN
C 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1111 CONTINUE
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
      WRITE (6,1001)
 1001 FORMAT (//,
     *12X,' ********************************************************'/
     *12X,' ************************ K O R P ***********************'/
     *12X,' ********************************************************'/
     *12X,' grafische Korrelation eines Parameter in mehreren Kernen')
C
      CALL ATKA (IK, TZ)
      IF (IK .EQ. 0) GOTO 12345
      WRITE (FILNAM, '(1A,I3.3,4A)') 'K', IK, '.PSED'
C
C-----externen Datensatz oeffnen
      OPEN (99, FILE=FILNAM, STATUS='OLD', FORM='UNFORMATTED')
C
C.....Anzahl der Proben {ANTI(K)} und Probentiefen {TIEF(K,I)} einlesen
      DO K=1,NTIEF
         READ (99) ANTI(K), (TIEF(K,I), I=1,ANTI(K))
         IF (ANTI(K) .NE. 0) READ (99) KPTEXT(K)
      END DO
      READ (99) SUMIRD            
      READ (99) TOP, BOT, ANZGR              
C
C.....Sedimentparameter einlesen
  199 CONTINUE
      READ (99, END=177) KTIEF, KENZ, (FELD(KENZ,I), I=1,ANTI(KTIEF))
      KEN(KENZ) = KTIEF
      GOTO 199
  177 CONTINUE
      CLOSE (99, STATUS='DELETE')
C==============================================================================
      IZ = 0
10200 CONTINUE
      IF (KEN(IZ+1) .EQ. 0) GOTO 10300
      PF(IZ+1) = IZ+1
      IZ = IZ+1
      GOTO 10200
C
10300 CONTINUE
      WRITE (6,'(/,2A)') ' Minima/Maxima des Parameters ', PARA(IK)
      DO I = 1, IZ
         SUM = 0.
         DO NIZ = 1, ANTI(KEN(PF(I)))
            YY2(NIZ) = FELD(PF(I),NIZ)
            SUM = SUM + YY2(NIZ)
         END DO
         IF (SUM .EQ. 0.) GOTO 10310
C
         AMIN(I) = 10000.
         AMAX(I) = -10000.
         DO IS = 1, ANTI(KEN(I))
            IF (YY2(IS) .LT. AMIN(I)) AMIN(I) = YY2(IS)
            IF (YY2(IS) .GT. AMAX(I)) THEN
               IF (YY2(IS) .NE. 9999.0) AMAX(I) = YY2(IS)
            END IF
         END DO
         WRITE (6,'(X,3A,F8.3,A,F8.3)') 
     *'Kern: ', KPTEXT(I)(1:6), 
     *'      MIN: ', AMIN(I), '     MAX: ', AMAX(I)
10310 END DO
C
      WRITE (6,'(/A)')  '$Min. Abszissenwert      ==> '
      READ  (5,*) AAMIN
      WRITE (6,'(A)')   '$Max. Abszissenwert      ==> '
      READ  (5,*) AAMAX
      DO I = 1, IZ
         AMIN(I) = AAMIN
         AMAX(I) = AAMAX
      END DO
C____________________________________________________________________________
20000 CONTINUE
C.....grafische Darstellung 
      WRITE (6,'(/,A)')                '$Abszissenlaenge  (mm)   ==> '
      READ  (5,*) YSIZE
      IF (TZ .NE. 'Z') WRITE (6,'(A)') '$Masstab                 1 : '
      IF (TZ .EQ. 'Z') WRITE (6,'(A)') '$Zeitachsenlaenge (mm)   ==> '
      READ  (5,*) SMS
      WRITE (6,'(A)')                  '$Marker plotten   [N]    ==> '
      READ  (5,'(A)') JM
      CALL CAPS(JM)
      WRITE (6,'(A)')                  '$farbig plotten   [N]    ==> '
      READ  (5, '(A)') FAR
      CALL CAPS(FAR)
C
      IF (TZ .EQ. 'Z') THEN
         XSIZE = SMS
         WRITE (6,'(/A)') ' Basisalter:'
         DO IA = 1, IZ
            WRITE (6,'(3A,F10.3,A)') 
     *' Kerne: ', KPTEXT(IA)(1:9), 'Alter: ', TIEF(IA,ANTI(IA)), ' k.y.'
         END DO
         WRITE (6,'(/A)') '$gewuenschtes Alter (k.y.) > '
         READ  (5,*) BOT
      END IF
      IF (TZ .EQ. 'T') XSIZE = (BOT-TOP)*1000./SMS
C
Cgggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
      CALL LUGRAF (1,IOUT)
      CALL GPRINT(0)
      CALL GOPEN
      CALL GCHARF('SOFT')
      IF (IOUT .LT. 3) CALL GCHARF('SIMP')
      IF (IOUT .GT. 2) CALL GCHARF('SHA4')
20100 CONTINUE
      POSI = 0.0
C
C.....Anfang der Grafikschleife
20299 CONTINUE
      DO 20200 I = 1, IZ
C.....
      SUM = 0.
      DO IA = 1, ANTI(KEN(PF(I)))
         IF (TIEF(KEN(PF(I)), IA) .GT. BOT) THEN
            ITIEF = IA-1
            GOTO 20191
         END IF
         XX(IA)  = TIEF(KEN(PF(I)),IA)
         YY(IA)  = FELD(PF(I),IA)
         SUM = SUM + YY(IA)
      END DO
C------------------------------------------------------------------------------
C.....undefinierte Werte rauswerfen
      ITIEF = ANTI(KEN(PF(I)))
20191 CONTINUE
      DO MI = 1, ITIEF
         IF (YY(MI) .EQ. 9999.0) THEN
            DO MJ = MI, ANTI(KEN(PF(I)))-1
               YY(MJ) = YY(MJ+1)
               XX(MJ) = XX(MJ+1)
            END DO
            ITIEF = ITIEF - 1
            GOTO 20191
         END IF
      END DO
C
20300 CONTINUE
C.....Groesse und Position des Plots       
      CALL BGRAF(20.,15.+POSI,XSIZE,YSIZE)
C
Cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
C.....Achsenbeschriftung und Labels X-Achse
      IF (POSI .EQ. 0.) CALL BAXLAB (3.,2.8,0,0)
      IF (POSI .NE. 0.) CALL BAXLAB (0.,0.,999,999)
C.....Tickmarks fuer X-Achse
      IF (TZ .EQ. 'T') CALL BTICKM(10)
      IF (TZ .EQ. 'Z') CALL BTICKM(5)
C.....Label drehen
      CALL BAXANG(90)
C.....X-Achse zeichnen
      IF (TZ .EQ. 'T') 
     * CALL BAXIS (1, TOP, 1., BOT, 'Depth (m) * '//ENGL(IK)//'$')
      IF (TZ .EQ. 'Z') 
     * CALL BAXIS (1, TOP, 50., BOT, 'Time (ka) * '//ENGL(IK)//'$')
C.....Gitterlinien zeichnen
      CALL BGRID(1,0)
C
Cyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy
C.....Achsenbeschriftung und Labels Y-Achse
      IF (AMAX(I)-AMIN(I) .LT. 3. .OR. AMAX(I) .LT. 3.) THEN
         CALL BAXLAB (2.5, 1.8, 1, 0)
      ELSE
         CALL BAXLAB (2.5, 1.8, 0, 0)
      END IF         
C.....Tickmarks fuer Y-Achse
      CALL BTICKM(5)
C.....letztes Label unterdruecken
      CALL BAXEND(1)
C.....Label drehen
      CALL BAXANG(90)
C.....Y-Achse zeichnen
      XXTEXT = KPTEXT(I)
      IF (SUM .NE. 0.) XTEXT = 'PS'//XXTEXT(1:4)//'-'//XXTEXT(6:6)//'$'
      IF (SUM .EQ. 0.) XTEXT = 'no data$'
      CALL BAXIS (2, AMIN(I), 0.0, AMAX(I), XTEXT)
C.....pruefen ob Daten vorhanden sind, sonst ans Ende der Schleife springen
      IF (SUM .EQ. 0.) GOTO 20199
C.....Markertyp (Symbol,Marker verbinden)
      IF (JM .EQ. 'J') THEN
         CALL BMARK  (20,1)
C.....Markergroesse in mm
         CALL BMARKH(2.)
C.....Markerfarbe
         CALL BMARKC (1)
      END IF
C.....Liniendicke in mm (+x) oder Pixel (-x)
      CALL BLIWDH (.3)
C.....Flaechenfarbe der Kurve (Farbarray, Anz.Farben)
      IF (FAR .EQ. 'J') THEN
         FARB(1) = COL(1,IK)
         CALL BCOLOR (FARB,1)
         CALL BLISHD(XX,YY,ITIEF,999.999,999.999,0)
      END IF
      CALL BLINE  (XX,YY,ITIEF)
20199 POSI = POSI+YSIZE                             ! neuen Ursprung berechnen
20200 CONTINUE
C.....Ende der Grafikschleife
C------------------------------------------------------------------------------
C
C.....letzte Achse zeichnen
      CALL GVECT(20.,15.+POSI,0)
      CALL GVECT(20.+XSIZE,15.+POSI,1)
C
C.....Institut, Datum schreiben
      CALL DATE(TAG)
      CALL GCHAR 
     *     ('AWI * SEDAN * '//TAG//'$',20.,16.+POSI,1.5)
      IF (TZ .NE. 'Z') THEN
         CALL GCHAR (' * Scale 1 :$',9999.,9999.,1.5)
         CALL GNUMB (SMS, 9999.,9999.,1.5,0)
      ELSE
         CALL GCHAR (' * TimePlot$', 9999.,9999.,1.5)
      END IF
      CALL GCLOSE
      GOTO 1111
12345 END      
C******************************************************************************
      SUBROUTINE ATKA (IKEN,TZ)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
      PARAMETER (NPRO=1600)             ! Anzahl Proben
      PARAMETER (NPAR=400)              ! Anzahl Parameter
      PARAMETER (NTIEF=25)              ! Anzahl Tiefenserien
      PARAMETER (NKERN=25)              ! Anzahl Kerne
      CHARACTER FILOUT*35, FILNAM*45, PARA(NPAR)*40, KERN(NKERN)*6, 
     *          TZ*1, KPTEXT(NTIEF)*50, DDIR*30, KK*6
      INTEGER   KEN(NPAR), ANTI(NTIEF), ANTIK(NTIEF)
      REAL      FELD(NPAR,NPRO), TIEF(NTIEF,NPRO), 
     *          XDAT(NTIEF,NPRO), YDAT(NTIEF,NPRO)
C..............................................................................
      IF (IKEN .NE. 0) GOTO 11
C
      NK = 1
      WRITE (6,'(/,12X,A)') ' Eingabe der Kernnummern | Exit = <Return>'
      WRITE (6,'(  12X,A)') ' -----------------------------------------'
 40   WRITE (6,'(A,12X,I2,A)') '$', NK, '. KERN  -> '
      READ  (5,'(A)') KK
      IF (KK .EQ. ' ') GOTO 10
      KERN(NK) = KK(1:4)//'.'//KK(6:6)
      OPEN (22, FILE = 'SYS$USER:[GEOLOGIE]'//KERN(NK)//'SED',
     *         ERR=50, STATUS='OLD')
      CLOSE (22)
      NK = NK+1
      GOTO 40
 50   WRITE (6,'(/A)') ' Kern nicht vorhanden !'
      CALL SBELL
      GOTO 40
C
 10   CONTINUE
      NK = NK-1
 11   WRITE (6,'(/,A)') '$Kennung des Parameters (0=Exit) ==> '
      READ  (5,*) IKEN
      IF (IKEN .EQ. 0) GOTO 1234
      ITZ = 0
      WRITE (6,'(A)')   '$gegen <T>iefe oder <Z>eit  [T]  ==> '
      READ  (5,'(A)') TZ
      CALL CAPS(TZ)
      IF (TZ .EQ. ' ') TZ = 'T'
      IF (TZ .EQ. 'Z') THEN
         ITZ = 10
      ELSE
         WRITE (6,'(A)')'$max. Kernlaenge  (m)            ==> '
         READ  (5,*) BOTNEU
      END IF
C==============================================================================
      WRITE (6,'(/A)') ' Daten werden gelesen...'
      DO IK = 1, NK 			! fuer jeden im Profil vorhandenen Kern
C==============================================================================
C-----externen Datensatz oeffnen
      FILNAM = 'SYS$USER:[GEOLOGIE]'//KERN(IK)//'SED'
      OPEN (99, FILE=FILNAM, STATUS='OLD', FORM='UNFORMATTED')
      WRITE (6,'(X,I2,2A)') IK, '.Kern:  ', FILNAM
C
C.....Anzahl der Tiefen {ANTI(K)} und Probentiefen {TIEF(K,I)} lesen
      DO K=1,NTIEF
         READ (99) ANTI(K), (TIEF(K,I), I=1,ANTI(K))
         IF (ANTI(K) .NE. 0) READ (99) KPTEXT(K)
      END DO
      READ (99) SUMIRD            
      READ (99) TOP, BOT, ANZGR              
C    
C.....Sedimentparameter lesen
  199 CONTINUE
      READ (99, END=177) KTIEF, KENZ, (FELD(KENZ,I), I=1,ANTI(KTIEF))
      KEN(KENZ) = KTIEF
      IF (KENZ .EQ. IKEN) GOTO 177
      GOTO 199
  177 CONTINUE
      CLOSE (99)
C______________________________________________________________________________
C.....Parameter im entsprechenden Kern an XDAT und YDAT uebergeben
      DO IT = 1, ANTI(KEN(IKEN))
         XDAT(IK,IT) = TIEF(KEN(IKEN)+ITZ,IT)
         YDAT(IK,IT) = FELD(IKEN,IT)
      END DO
      ANTIK(IK) = ANTI(KEN(IKEN))
C
C.....Felder leeren
      DO IL1 = 1, NPAR
         KEN(IL1) = 0
         DO IL2 = 1, NPRO
            FELD(IL1, IL2) = 0
         END DO
      END DO
      DO IL1 = 1, NTIEF
         ANTI(IL1) = 0
         DO IL2 = 1, NPRO
            TIEF (IL1,IL2) = 0
         END DO
      END DO
C==============================================================================
      END DO
C==============================================================================
C.....Daten uebergeben
      DO I = 1, NK
         KEN(I) = I
         ANTI(I) = ANTIK(I)
         KPTEXT(I) = KERN(I)
         DO I2 = 1, ANTI(I)
            TIEF (I,I2) = XDAT (I,I2)
            FELD (I,I2) = YDAT (I,I2)
         END DO
      END DO
C
      SUMIRD = 0.
      TOP = 0.
      IF (TZ .EQ. 'T') BOT = BOTNEU !max. Kerntiefe 
      ANZGR = 0.
C------------------------------------------------------------------------------
C.....Daten speichern
      WRITE (FILNAM,'(1A,I3.3,5A)') 'K', IKEN, '.PSED'
      OPEN (77, FILE=FILNAM, STATUS='NEW', FORM='UNFORMATTED')
C
C..Tiefen......................................................................
      DO I=1, NTIEF
         IF (ANTI(I) .EQ. 0) THEN
            WRITE (77) ANTI(I)
         ELSE
            WRITE (77) ANTI(I), (TIEF(I,K), K=1,ANTI(I))
            WRITE (77) KPTEXT(I)
         END IF
      END DO
C
      WRITE (77) SUMIRD
      WRITE (77) TOP, BOT, ANZGR
C
C..Daten.......................................................................
      DO 9876 I=1,NPAR
         IF (KEN(I) .NE. 0) 
     *      WRITE (77) KEN(I), I, (FELD(I,K), K=1,ANTI(KEN(I)))
 9876 CONTINUE
      CLOSE (77)
 1234 END