      SUBROUTINE MERCRA (LAMMIN,PHIMIN,LAMMAX,PHIMAX,DELLAM,DELPHI,MASS,
     *PHI0,XR,YR,X0,Y0)
C**********************************************************************
C	SUBROUTINE                                                    *
C	                                                              *
C	AUTOR: ALFRED-WEGENER-INSTITUT  BREMERHAVEN                   *
C              FEBRUAR 1985                                           *
C	INPUT:                                                        *
C	SUBR:                                                         *
C       Stand: 16.07.1986
C**********************************************************************
C
      REAL*4 LAMW,LAME,LAMMIN,LAMMAX,LAM,MASS
      CHARACTER ZA(80),ASCALE*30,ALAT1*25,ALAT2*4,C40*40
      LOGICAL S1
      common/mass/fmass
C
      IF (FMASS.LT..2.OR.FMASS.GT.2.) FMASS=1.
      S1=.FALSE.
C
      XR=1.8*FMASS
      YR=7.8*FMASS
C
      B=ABS(PHIMIN/DELPHI-INT(PHIMIN/DELPHI))
      IF (B.LT..001.OR.(1.-B).LT..001) THEN
        PHIS=PHIMIN
       ELSE
        A=0.
        IF (PHIMIN.LT.0.) A=1.
        PHIS=INT(PHIMIN/DELPHI-A)*DELPHI
      END IF
C
      B=ABS(PHIMAX/DELPHI-INT(PHIMAX/DELPHI))
      IF (B.LT..001.OR.(1.-B).LT..001) THEN
        PHIN=PHIMAX
       ELSE
        A=1.
        IF (PHIMAX.LT.0.) A=0.
        PHIN=INT(PHIMAX/DELPHI+A)*DELPHI
      END IF
C
      B=ABS(LAMMIN/DELLAM-INT(LAMMIN/DELLAM))
      IF (B.LT..001.OR.(1.-B).LT..001) THEN
        LAMW=LAMMIN
       ELSE
        A=0.
        IF (LAMMIN.LT.0.) A=1.
        LAMW=INT(LAMMIN/DELLAM-A)*DELLAM
      END IF
C
      B=ABS(LAMMAX/DELLAM-INT(LAMMAX/DELLAM))
      IF (B.LT..001.OR.(1.-B).LT..001) THEN
        LAME=LAMMAX
       ELSE
        A=1.
        IF (LAMMAX.LT.0.) A=0.
        LAME=INT(LAMMAX/DELLAM+A)*DELLAM
      END IF
C
      CALL MERC (LAMW,PHIS,XMIN,YMIN,MASS,PHI0)
      CALL MERC (LAME,PHIN,XMAX,YMAX,MASS,PHI0)
C      TYPE *,LAMW,PHIS,XMIN,YMIN,MASS,PHI0
C      TYPE *,LAME,PHIN,XMAX,YMAX,MASS,PHI0
      DX=XMAX-XMIN      
      DY=YMAX-YMIN
      CALL MERC (LAMMIN,PHIMIN,X,Y,MASS,PHI0)
      X0=XR+X-XMIN
      Y0=YR+Y-YMIN
C
C
      X=0.
      Y=0.
      X1=DX+XR+XR
      Y1=DY+XR+YR
C      WRITE (8,90) X1,Y1
C   90 FORMAT (' YOUR PLOT-SIZE IS ',F5.1,' CM * ',F5.1,' CM')
      CALL DRAW (X,Y,0)
      CALL DRAW (X1,Y,1)
      CALL DRAW (X1,Y1,1)
      CALL DRAW (X,Y1,1)
      CALL DRAW (X,Y,1)
      X=0.025
      Y=0.025
      X1=X1-.025
      Y1=Y1-.025
      CALL DRAW (X,Y,0)
      CALL DRAW (X1,Y,1)
      CALL DRAW (X1,Y1,1)
      CALL DRAW (X,Y1,1)
      CALL DRAW (X,Y,1)
      Y1=YR-XR
      CALL DRAW (X,Y1,0)
      CALL DRAW (X1,Y1,1)
      Y1=YR-XR-.025
      CALL DRAW (X1,Y1,0)
      CALL DRAW (X,Y1,1)
C
      X=DX+XR+XR-6.7*FMASS
      Y=1.3*FMASS
      F=1.8*FMASS
C      CALL NPEN (3)
C......fuer Fahrtbericht ANTVIII/1 geaendert
C
      CALL NPEN (1)
      CALL AWISIG (X,Y,F)
      CALL NPEN (1)
C
      X=DX+XR+XR-5.*FMASS
      Y=.4*FMASS
      H=.2*FMASS
      K=1
      CALL AWITEX (K,X,Y,H)
C
C.....ANGABE DER KARTENPROJEKTION
C
      Y=5.7*FMASS
      X=DX+XR+XR-5.*FMASS
      H=.18*FMASS
      WRITE (C40,'(A)') 'Projection - Mercator$'
      CALL TEXT (X,Y,H,C40,0.,21)
C
C.....mittlere Breite in Grad und Minuten umrechnen
C
      IF (PHI0.LT.0) THEN
         S1=.TRUE.
      END IF
      FLAT=ABS (PHI0)
      FLATG=AINT(FLAT)
      DN=FLAT-FLATG
      FLATM=DN*60.
      IF (S1) THEN
         FLATG=FLATG*-1.
      END IF
      CALL RUND (FLATM,0)
      ILATG=INT (FLATG)
      ILATM=INT (FLATM)
      IMASS=INT (MASS)
C
C......plottbare Charactervariable aus Massstabszahl und Bezugsbreite erstellen
C
      ASCALE='Scale:           1 :'
      WRITE (ASCALE(21:29),'(I9)')IMASS
      ASCALE(30:30)='$'
      ALAT1='at Latitude:       $'
C      ALAT1='at Latitude:        '
C      WRITE (ALAT1(21:24),'(I4)')ILATG       
C      ALAT1(25:25)='$'
C      WRITE (ALAT2(1:2),'(I2)')ILATM       
C      ALAT2(3:3)=''''
C      ALAT2(4:4)='$'
C
C......Massstabsangabe plotten
C
      Y=5.16*FMASS
      CALL TEXT(X,Y,H,ASCALE,0.0,29)
C
C......laengentreue Bezugsbreite plotten
C
      Y=4.8*FMASS
      CALL TEXT(X,Y,H,ALAT1,0.0,19)
      XX=X+3.*FMASS
      CALL RANUM1 (XX,Y,H,PHI0)
C      CALL TEXT(X,Y,H,ALAT1,0.0,24)
C      Y=4.905
C      H=0.15
C      WRITE (C40,'(A)') 'o $'
C      CALL TEXT(999.9,Y,H,C40,0.0,2)
C      Y=4.8
C      H=0.18
C      CALL TEXT(999.9,Y,H,ALAT2,0.0,3)
C
      X=(DX+XR+XR)/2.-5.5
      Y=3.35*FMASS
      CALL SCALE0 (X,Y,MASS,PHI0)
C
C
      DO 10 PHI=PHIS,(PHIN+.01),DELPHI
      CALL MERC (LAMW,PHI,X,Y,MASS,PHI0)
      Y=Y-YMIN+YR
      X=XR
      X1=DX+XR
      H=XR/7.5
      CALL RANUM (X-XR,Y-H/2.,H,PHI)
      CALL DRAW (X,Y,0)
      CALL DRAW (X1,Y,1)
      CALL RANUM (X1,Y-H/2.,H,PHI)
   10 CONTINUE
C
      DO 20 LAM=LAMW,(LAME+.01),DELLAM
      CALL MERC (LAM,PHIS,X,Y,MASS,PHI0)
      X=X-XMIN+XR
      Y=YR
      Y1=DY+YR
      H=XR/7.5
      CALL RANUM (X-XR/2.,Y-H*3.,H,LAM)
      CALL DRAW (X,Y,0)
      CALL DRAW (X,Y1,1)
      CALL RANUM (X-XR/2.,Y1+H*2.,H,LAM)
   20 CONTINUE
C
      RETURN
      END