	PROGRAM SEABC
C
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	CHARACTER*40 FILIN, TEX, CONN*1, C*1
	LOGICAL SWITCH
C
 	COMMON/SEA/TMA,TMI,TSC,XR,YR,DE,AX,DL,STAN,TEX
	DATA A/6378155.D0/,B/6356750.520D0/
	PI=4.D0*DATAN(1.D0)
C
1       FORMAT(A)
2	FORMAT(3E14.8)
3	FORMAT(15E7.0)
4       FORMAT(1X,6(I2,1X),4E12.5,E7.0)
5       FORMAT(/,A,/)
C
	WRITE(5,'(//,A)') ' * S E A B C *'
	WRITE(5,'(/,A)')'$DO YOU WANT TO CHANGE RUN PARAMETERS ? (Y/N) :'
	READ(5,'(A)')C
	IF (C .EQ. 'Y') CALL STEUER
	OPEN(UNIT=1,FILE='SEASTEU.INP',STATUS='OLD')
	READ(1,'(I4,E6.2)')L1,XM1
	READ(1,'(I4,E6.2)')L2,XM2
	IF(L1.LT.0) XM1=XM1*(-1.D0)
        IF(L2.LT.0) XM2=XM2*(-1.D0)
	XLONMI=FLOAT(L1)+XM1/60.D0
        XLONMA=FLOAT(L2)+XM2/60.D0
	READ(1,'(I4,E6.2)')L1,XM1
	READ(1,'(I4,E6.2)')L2,XM2
	IF(L1.LT.0) XM1=XM1*(-1.D0)
	IF(L2.LT.0) XM2=XM2*(-1.D0)	
	PHIMI=FLOAT(L1)+XM1/60.D0
	PHIMA=FLOAT(L2)+XM2/60.D0
C
	READ(1,'(E10.0)')SC         !Masstab
	READ(1,'(I1)')   IOUT       !Ausgabegeraet
C
	TMA=0.D0
	TMI=0.D0
	TSC=0.D0
	DL=0.D0
	AX=0.D0
	XR=2.D0
	YR=3.D0
	SWITCH=.FALSE.
	SWITC=.TRUE.
	N=0
	IF=1
	STR=0.D0
	S800=0.D0
	STG=0.D0
	I=0
	IAB=0
	XMI=0.D0
	XMI2=0.D0
	IANZ=0
C
	READ(1,'(E7.1)') TMI        !Obergrenze  Wassertiefe
	READ(1,'(E7.1)') TMA        !Untergrenze Wassertiefe
	READ(1,'(E5.0)') TSC        !dTiefe
C
	DL=SC
	DE=(TMA-TMI)/TSC
C
	CALL PLTBEG(IOUT)
	CALL NPEN(1)
	READ(1,'(I2)')   NF         !
6	READ(1,'(A)')    FILIN      !Datenfilename
	READ(1,'(I1)')   IFORM      !Typ Datenformat
	READ(1,'(I1)')   IPEN       !Farbe (Pennummer)
	READ(1,'(A)')    TEX        !Text
        CLOSE (1)
C
	M=0
	IK=10
        IMI=IMIN
	STG=0.D0
	ST800=0.D0
C
	IF(IFORM.EQ.1) THEN
          OPEN(UNIT=2,FILE=FILIN,STATUS='OLD',READONLY)
        ELSE IF(IFORM.EQ.2) THEN
	  OPEN(UNIT=2,FILE=FILIN,STATUS='OLD',READONLY)
	ELSE
	  WRITE(5,5)' FILE FORM DOESN''T EXIST , RUN DELETED !'
          GO TO 99999
	END IF
	IF(IF.EQ.1)XRR=XR
7       IF(IF.NE.1) THEN
	  XRR=XOLD
	  SWITCH=.FALSE.
	  GO TO 100
	END IF
C
100     GOTO (200,300)IFORM
C
200     READ(2,4,END=299)IT,IM,IJ,IST,MIN,ISEC,XLAT,XLON,PHI,XLAMB,DEP
C
C
250	IF(PHI.EQ.0.D0.AND.XLAMB.EQ.0.D0.OR.PHI.LT.PHIMI.OR.PHI.GT.
     *  PHIMA.OR.XLAMB.LT.XLONMI.OR.XLAMB.GT.XLONMA.OR.DEP.LT.TMI.
     *  OR.DEP.GT.TMA.OR.DEP.EQ.0.D0) THEN
	  IAB=IAB+1
          GO TO 100
 	END IF	 
C
	XMI=XMI+DEP
	XMI2=XMI2+DEP**2.D0
	IANZ=IANZ+1
C	
	PHI=PHI*PI/180.D0
        XLAMB=XLAMB*PI/180.D0
C
	IF(SWITCH)THEN
         CALL INVIN(A,B,PH,XL,PHI,XLAMB,AL1,AL2,DI)	
       	 DIS=DI/DL
	 IF(DIS.EQ.0.D0)DIS=1.E-5
	 X=X+DIS
	 Y=YR+DE-(DEP-TMI)/TSC
	ELSE
	 X=XRR
	 Y=YR+DE-(DEP-TMI)/TSC
	END IF	
	PH=PHI
	XL=XLAMB
        CALL NPEN(IPEN)
	IF(.NOT.SWITCH) THEN
	  CALL DRAW(X,Y,0)
      	  SWITCH=.TRUE.
        ELSE IF(IAB.GT.5) THEN
	  CALL DRAW(X,Y,0)
	  IAB=0
	ELSE
	  CALL DRAW(X,Y,1)
	END IF
	GO TO 100

299	IF(IF.EQ.1)XOLD=X
	IF(X.GT.XOLD) XOLD=X
2992	IF (IF.GE.NF) THEN
	    GO TO 400
	ELSE
	    IF=IF+1
	    GO TO 6
	END IF
C
300     READ(2,2,END=299)PHI,XLAMB,COUR
	READ(2,3,END=299)D1,D2,D3,D4,D5,D6,D7,DEP,D8,D9,D10,
     *                   D11,D12,D13,D14
	READ(2,3,END=299)W1,W2,W3,W4,W5,W6,W7,W,W8,W9,W10,
     *                   W11,W12,W13,W14
	READ(2,3,END=299)
C
	GO TO 250   
C        
400     IX=INT(XOLD)+1
        AX=FLOAT(IX)
	XMIT=XMI/IANZ
	STAN=DSQRT((XMI2-XMIT*XMI)/(IANZ-1))
        CALL RAHMEN
	CALL PLTEND
	CLOSE(UNIT=1)
	CLOSE(UNIT=2)
	CALL NPEN(1)
99999	END	
C******************************************************************************
 	SUBROUTINE RAHMEN                                           
C
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	CHARACTER TEX*40,CHARA*30,TEXX*5,REX*6, DATUM*9, ZEIT*8
 	COMMON/SEA/TMA,TMI,TSC,XR,YR,DE,AX,DL,STAN, TEX
C
	RL=0.D0
	RH=0.D0
	TM=0.D0
        H = 3.D0*0.35D0    
        RL = AX+H+2.D0*XR
C
	IID=INT(DL/TSC)
	WRITE(CHARA,'(A,I5,A)')'Exeggeration:    1 :',IID,'$'
	CALL TEXT(RL-6.D0,1.7,.18,CHARA,0.,27)
        CALL DATE(DATUM)
        CALL TIME(ZEIT)
	CHARA = 'Grobe * '//DATUM//' * '//ZEIT//'$'
	CALL TEXT(RL-6.D0,1.0,.18,CHARA,0.,29)
C
	DO K1=1,40
        	IF(TEX(K1:K1+2).EQ.'   ') GO TO 51
	END DO
51	TEX(K1:K1)='$'
	IF(K1.NE.0) CALL TEXT(2.0,1.,.4,TEX,0.,K1)
C
C	ACHSENBERECHNUNG :
C       ----------------
	ZAHL=0.D0
	ZA=0.D0
	ZI=3.D0
	X=XR
	Y=YR
58	ZII=10.D0**ZI
        ZA=DL/ZII
	IF(ZA.LE.10.D0) GO TO 59
	ZI=ZI+1.D0
	GO TO 58	
59	CALL DRAW (X,Y,0)
	ABST=1.D0
60	X=X+ABST
	ZAHL=ZAHL+ZA
C	WRITE(5,*)AX,X,ZAHL
	CALL DRAW (X,Y,1)
	YMARK=Y-0.2D0
	CALL DRAW (X,YMARK,1)
	YMARK=Y-0.5D0
	XMARK=X-0.8D0
	WRITE     (REX,'(F5.1,A)') ZAHL, '$'
	CALL TEXT (XMARK,YMARK,0.2D0,REX,0.,7)
	CALL DRAW (X,Y,0)
	IF(X.GT.(AX+XR)) GO TO 70
	GO TO 60
C
70	XB=XR+AX/2.D0-1.D0
	YB=YR-1.D0
	TEXX='10**$'
	ZI=ZI-3.D0
	CALL TEXT (XB,YB,0.2D0,TEXX,0.D0,4)
	XB=XB+4.D0*0.2D0
	CALL NUMB (XB,YB,0.2D0,ZI,0.D0,-1)
	XB=XB+2.D0*0.2D0
	TEXX=' KM $'
	CALL TEXT (XB,YB,0.2D0,TEXX,0.D0,4)
C
	X=XR
	Y=YR
	CALL DRAW (X,Y,0)
	ZAHL=TMA	
	ABST=1.D0
80	Y=Y+ABST
	ZAHL=ZAHL-TSC
	CALL DRAW (X,Y,1)
	XMARK=X-0.2D0
	CALL DRAW (XMARK,Y,1)
	XMARK=X-1.2D0
	YMARK=Y-0.1D0
	CALL NUMB (XMARK,YMARK,0.2D0,ZAHL,0.D0,-1)
	CALL DRAW(X,Y,0)
	IF(ZAHL.LE.TMI)GO TO 90
	GO TO 80
C
90	X=XR
	Y=YR+DE
	CALL DRAW(X,Y,0)
	X=XR+AX
	Y=YR+DE
	CALL DRAW(X,Y,1)
C
	RETURN
	END


      SUBROUTINE INVIN (A,B,PHII,XLONI,PHIJ,XLONJ,AIJ,AJI,SIJ)          
C***********************************************************************
C*                                                                     *
C*       SUBROUTINE INVIN  SOLVES THE INVERSE PROBLEM IN GEODESY, THAT *
C*  IS, GIVEN THE LATITUDE AND LONGTITUDE OF TWO POINTS I AND J,       *
C*  COMPUTE THE FORWARD AND BACKWARD AZIMUTHS AIJ AND AJI AND THE      *
C*  DISTANCE BETWEEN I AND J.                                          *
C*  SOLUTION FOR ANTIPODAL POINTS IS INCLUDED                          *
C*  THE SOLUTION IS ITERATED UNTIL THE CHANGE IS LESS THAN 1.D-12      *
C*   NOTE  THE EQUIVALENT DIRECT PROGRAM IS SUBROUTINE DIVIN           *
C*                                                                     *
C*  REFERENCE  T. VINCENTY - SURVEY REVIEW, APRIL 1975                 *
C*                                                                     *
C*   INPUT DATA                                                        *
C*              A=SEMI-MAJOR AXIS OF REFERENCE ELLIPSOID IN METRES     *
C*              B=SEMI-MINOR AXIS OF REFERENCE ELLIPSOID OR THE        *
C*                RECIPROCAL OF THE FLATTENING IN METRES OR UNITLESS   *
C*              PHII=GEODETIC LATITUDE OF POINT I IN RADIANS           *
C*              XLONI=GEODETIC LONGTITUDE OF POINT I IN RADIANS        *
C*              PHIJ=GEODETIC LATITUDE OF POINT J IN RADIANS           *
C*              XLONJ=GEODETIC LONGTITUDE OF POINT J IN RADIANS        *
C*                                                                     *
C*  OUTPUT DATA                                                        *
C*              AIJ=GEODETIC AZIMUTH FROM I TO J IN RADIANS            *
C*                NOTE  AZIMUTH ON ELLIPSOID                           *
C*              AJI=GEODETIC AZIMUTH FROM J TO I IN RADIANS            *
C*                NOTE  AZIMUTH ON ELLIPSOID                           *
C*              SIJ=DISTANCE FROM I TO J (J TO I) IN METRES            *
C*                NOTE  DISTANCE ON ELLIPSOID                          *
C*                                                                     *
C*                                     INGE NESBO JAN. 1976            *
C*                                                                     *
C***********************************************************************
C                                                                       
C  WORK IN DOUBLE PRECISION                                             
C                                                                       
      IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)            
C                                                                       
C  CHECK IF ELLIPSOID DEFINED BY A + B OR A + 1/F AND COMPUTE           
C  ECCENTRICITY                                                         
C                                                                       
      B1=B                                                              
      IF(B1.LT.1000.0)B1=A-A/B1                                         
C                                                                       
C   COMPUTE SOME CONSTANTS                                              
C                                                                       
      PI=DATAN (1.D00) * 4.D00                                          
      BONA=B1/A                                                         
      F=(A-B1)/A                                                        
      ESQ1=(A*A-B1*B1)/A/A                                              
      ESQ2=(A*A-B1*B1)/B1/B1                                            
C                                                                       
C     TESTVALUE FOR STOP OF ITERATION                                   
      DEL=1.D-12                                                        
C                                                                       
      DLL=XLONJ-XLONI                                                   
      DL=DLL                                                            
      DDL=0.D0                                                          
C                                                                       
      SP1=DSIN(PHII)*BONA                                               
      CP1=DCOS(PHII)                                                    
      SP2=DSIN(PHIJ)*BONA                                               
      CP2=DCOS(PHIJ)                                                    
C  TRIG. FUNCTIONS OF REDUCED LATITUDE                                  
      DIAG=DSQRT(SP1*SP1+CP1*CP1)                                       
      SU1=SP1/DIAG                                                      
      CU1=CP1/DIAG                                                      
      DIAG=DSQRT(SP2*SP2+CP2*CP2)                                       
      SU2=SP2/DIAG                                                      
      CU2=CP2/DIAG                                                      
C  START ITERATION                                                      
 200  CONTINUE                                                          
      EDL=DDL                                                           
      SDL=DSIN(DL)                                                      
      CDL=DCOS(DL)                                                      
      SQSIG=(CU2*SDL)**2+(CU1*SU2-SU1*CU2*CDL)**2                       
      SSIG=DSQRT(SQSIG)                                                 
      IF (SSIG-DEL) 204,204,205                                         
  204 SIJ=0.D0                                                          
      AIJ=0.D0                                                          
      AJI=0.D0                                                          
      GOTO 70                                                           
  205 CSIG=SU1*SU2+CU1*CU2*CDL                                          
      SIG=DATAN2 (SSIG,CSIG)                                             
      SALF=CU1*CU2*SDL/SSIG                                             
      CSQALF=1.D0-SALF*SALF                                             
      IF(CSQALF-DEL) 206,206,210                                        
  206 CDSIGM=CSIG                                                       
      GOTO 220                                                          
 210  CDSIGM=CSIG-2.D0*SU1*SU2/CSQALF                                   
 220  C=CSQALF*(4.D0+F*(4.D0-3.D0*CSQALF))*F/16.D0                      
      DDL=CDSIGM+C*CSIG*(-1.D0+2.D0*CDSIGM*CDSIGM)                      
      DDL=(1.D0-C)*F*SALF*(SIG+C*SSIG*DDL)                              
      DL=DLL+DDL                                                        
      IF(DABS(DL).GT.PI) GOTO 250                                       
      IF (DABS(EDL-DDL).LE.DEL) GOTO 300                                
      GOTO 200                                                          
C ANTIPODAL SOLUTION                                                    
  250 CONTINUE                                                          
      DPIL=PI-DABS(DLL)                                                 
      DPIL=DSIGN(DPIL,DLL)                                              
      DL=0.D0                                                           
      CSQALF=.5D0                                                       
      SALF=DSQRT(CSQALF)                                                
      DPHI=DATAN2 (SU1,CU1)+DATAN2 (SU2,CU2)                              
      SIG=PI-DABS(DPHI)                                                 
      SSIG=DSIN(SIG)                                                    
      CSIG=DCOS(SIG)                                                    
 260  CONTINUE                                                          
      EDL=SALF                                                          
      C=CSQALF*(4.D0+F*(4.D0-3.D0*CSQALF))*F/16.D0                      
      CDSIGM=CSIG-2.D0*SU1*SU2/CSQALF                                   
      D=CDSIGM+C*CSIG*(-1.D0+2.D0*CDSIGM*CDSIGM)                        
      D=(1.D0-C)*F*(SIG+C*SSIG*DDL)                                     
      SALF=(DPIL- DL)/D                                                 
      CSQALF=1.D0-SALF*SALF                                             
      SDL  =SALF*SSIG/(CU1*CU2)                                         
      CDL =-DSQRT(1.D0-SDL*SDL)                                         
      DL=DATAN2 (SDL,-CDL)                                               
      SQSIG=(CU2*SDL)**2+(CU1*SU2-SU1*CU2*CDL)**2                       
      SSIG=DSQRT(SQSIG)                                                 
      CSIG=SU1*SU2+CU1*CU2*CDL                                          
      SIG=DATAN2 (SSIG,CSIG)                                             
      IF(DABS(SALF-EDL).LE.DEL) GOTO 270                                
      GOTO 260                                                          
  270 CONTINUE                                                          
      EC=DSQRT(1.D0+ESQ2*CSQALF)                                        
      FC=(EC-1.D0)/(EC+1.D0)                                            
      AC=(1.D0+.25D0*FC*FC)/(1.D0-FC)                                   
      BC=FC*(1.D0-FC*FC*3.D0/8.D0)                                      
      GOTO 320                                                          
  300 CONTINUE                                                          
C                                                                       
C     DISTANCE COMPUTATION                                              
C                                                                       
      USQ=CSQALF*ESQ2                                                   
      AC=-768.D0+USQ*(320.D0-175.D0*USQ)                                
      AC=1.D0+USQ*(4096.D0+USQ*AC)/16384.D0                             
      BC=-128.D0+USQ*(74.D0-47.D0*USQ)                                  
      BC=USQ*(256.D0+USQ*BC)/1024.D0                                    
      SDL=DSIN(DL)                                                      
      CDL=DCOS(DL)                                                      
 320  DSIG=BC*SSIG*(CDSIGM+BC*(CSIG*(-1.D0+2.D0*CDSIGM*CDSIGM)          
     1-BC*CDSIGM*(-3.D0+4.D0*SQSIG)*(-3.D0+4.D0*CDSIGM*CDSIGM)/6.D0)/   
     24.D0)                                                             
      SIJ=B1*AC*(SIG-DSIG)                                              
C                                                                       
C     AZIMUTH COMPUTATION                                               
C                                                                       
      SANG =CU1*SU2-SU1*CU2*CDL                                         
      IF (CU1.LE.DEL) GOTO 330                                          
      SA=SALF/CU1                                                       
      CA=DSQRT(1.D0-SA*SA)                                              
      CA=DSIGN(CA,SANG)                                                 
      AIJ=DATAN2 (SA,CA)                                                 
      GOTO 340                                                          
 330  AIJ=PI                                                            
 340  SA=SALF                                                           
      CA=-SU1*SSIG+CU1*CSIG*CA                                          
      AJI=DATAN2 (SA,CA)                                                 
  70  CONTINUE                                                          
      RETURN                                                            
      END                                                               
C*****************************************************************************
        SUBROUTINE STEUER
        CHARACTER*1 CHA
        CHARACTER*40 TEXT(4),DATEI(99),DAT
        INTEGER IFORM(99),IPEN(99),IH(99),MIN(99),ISEC(99)
	OPEN(UNIT=3,FILE='SEASTEU.INP',STATUS='OLD')
1	FORMAT(I4,F6.2)
2       FORMAT($1X,A,I4,A)
3       FORMAT($1X,A,F6.2,A)
4       FORMAT(I1)
41      FORMAT($1X,A,I1,A)
42      FORMAT(Q,I1)
43      FORMAT($1X,A,F7.1,A)
44      FORMAT(Q,F7.1)
45      FORMAT(1X,A,22X/$1X,3A)
46      FORMAT(Q,A)
47      FORMAT(A)
48      FORMAT($1X,3A)
7       FORMAT(Q,I4)
8       FORMAT(Q,F6.2)
C
299     READ(3,1)I1,F1
	WRITE(5,2)' LONGITUDE WEST  IS [I4]   (',I1,' grad) :'
	READ(5,7) K,IHILF
	IF(K.NE.0) I1=IHILF
C
	WRITE(5,'(/)')
	WRITE(5,3)' LONGITUDE WEST  IS [6.2] (',F1,' min) :'
	READ(5,8) K,HILF
	IF(K.NE.0) F1=HILF
300     READ(3,1)I2,F2
	WRITE(5,'(/)')
	WRITE(5,2)' LONGITUDE EAST  IS [I4]   (',I2,' grad) :'
	READ(5,7) K,IHILF
	IF(K.NE.0) I2=IHILF
C
	WRITE(5,'(/)')
	WRITE(5,3)' LONGITUDE EAST  IS [6.2] (',F2,' min) :'
	READ(5,8) K,HILF
	IF(K.NE.0) F2=HILF
301     READ(3,1)I3,F3
	WRITE(5,'(/)')
	WRITE(5,2)' LONGITUDE SOUTH IS [I4]   (',I3,' grad) :'
	READ(5,7) K,IHILF
	IF(K.NE.0) I3=IHILF
C
	WRITE(5,'(/)')
	WRITE(5,3)' LONGITUDE SOUTH IS [6.2] (',F3,' min) :'
	READ(5,8) K,HILF
	IF(K.NE.0) F3=HILF
302     READ(3,1)I4,F4
	WRITE(5,'(/)')
	WRITE(5,2)' LONGITUDE NORTH IS [I4]   (',I4,' grad) :'
	READ(5,7) K,IHILF
	IF(K.NE.0) I4=IHILF
C
	WRITE(5,'(/)')
	WRITE(5,3)' LONGITUDE NORTH IS [6.2] (',F4,' min) :'
	READ(5,8) K,HILF
	IF(K.NE.0) F4=HILF
304     READ(3,'(F10.0)')SC
	WRITE(5,'(/)')
	WRITE(5,'($1X,A,F10.0,A)')' SCALE  [10.0]            (',SC,
     *  ') :'
	READ(5,'(Q,F10.0)') K,HILF
	IF(K.NE.0) SC=HILF
305     READ(3,4)IOUT
	WRITE(5,'(/)')
        WRITE(5,41)' OLD OUTPUT MODE  [I1]             (',IOUT,') :'
        READ(5,42)K,IHILF
	IF(K.NE.0) IOUT=IHILF
306     READ(3,'(F7.1)')TMI
	WRITE(5,'(/)')
        WRITE(5,43)' MINIMAL DEPTH  IS [7.1]    (',TMI,'m) :'
        READ(5,44)K,HILF
	IF(K.NE.0) TMI=HILF
307     READ(3,'(F7.1)')TMA
	WRITE(5,'(/)')
        WRITE(5,43)' MAXIMAL DEPTH  IS [7.1]    (',TMA,'m) :'
        READ(5,44)K,HILF
	IF(K.NE.0) TMA=HILF
308     READ(3,'(F7.1)')TSC
	WRITE(5,'(/)')
        WRITE(5,43)' DEPTH SCALE  IS  [7.1]     (',TSC,'m) :'
        READ(5,44)K,HILF
	IF(K.NE.0) TSC=HILF
309     READ(3,'(I2)')NF
        ID=1 
3151    READ(3,'(A)')DATEI(ID)      
	WRITE(5,'(/)')
        WRITE(5,45)' INPUTFILE [A40]', ' (',DATEI(ID),') :'
        READ(5,46)K,DAT
 	IF(K.NE.0)DATEI(ID)=DAT
310     IFOR=0
        READ(3,4)IFORM(ID)
	WRITE(5,'(/)')
        WRITE(5,41)' FILE FORMAT  1=NBS  2=SEAB        (',
     *   IFORM(ID),') :'
        READ(5,42)K,IHILF
	IF(K.NE.0)IFORM(ID)=IHILF
311     IPE=0
        READ(3,4)IPEN(ID)
	WRITE(5,'(/)')
        WRITE(5,41)' COLOUR FOR DEPTH  [I1]            (',IPEN(ID),
     *  ') :'
        READ(5,42)K,IHILF
	IF(K.NE.0)IPEN(ID)=IHILF
600     WRITE(5,'(/)')
	WRITE(5,'($1X,A)')' NEXT INPUT FILE ?   (Y/N)             :'
        READ(5,47)CHA
        IF(CHA.EQ.'Y') THEN
          IF(ID.LT.NF) THEN
            ID=ID+1
            GO TO 3151
          ELSE
            GO TO 602
          END IF
        ELSE IF(CHA.EQ.'N') THEN
          IF(ID.LT.NF) THEN
            DO I=(ID+1),NF
            READ(3,47)DAT
            READ(3,4)IFOR
            READ(3,4)IPE
            END DO
          END IF
	ELSE
	  GO TO 601
        END IF
        GO TO 319
601     WRITE(5,'(/)')
	WRITE(5,'(A)')' PLEASE,ANSWER WITH Y OR N .'
        GO TO 600
602     ID=ID+1
        WRITE(5,'(/)')
        WRITE(5,'($1X,A,30X,A)')' NEW FILE',':'
        READ(5,46)K,DAT
        IF(K.EQ.0)   GO TO 603
        DATEI(ID)=DAT
C
        WRITE(5,'(/)')
        WRITE(5,41)' SIZE     1 = NBS  2 = SEAB            :'
        READ(5,42)K,IHILF
        IF(K.EQ.0) GO TO 603
        IFORM(ID)=IHILF
C
        WRITE(5,'(/)')
        WRITE(5,41)       ' COLOUR                                :'
        READ(5,42)K,IHILF
        IF(K.EQ.0) GO TO 603
        IPEN(ID)=IHILF
        GO TO 600
C
603     WRITE(5,'(/)')
	WRITE(5,47)' BLANKS ARE NOT POSSIBLE HERE,TRY IT AGAIN'
        ID=ID-1
        GO TO 600
319     NF=ID    
        WRITE(5,47)'            !!!        TEXT        !!! '
        WRITE(5,47)'                                   '
        WRITE(5,47)' IF YOU WANT TO CLEAR A LINE,TYPE  * .'
        WRITE(5,47)'                                   '
        READ(3,47)TEXT(1)
      WRITE(5,'(/,2A)')' OLD LINE ONE IS                  : ',TEXT(1)
        WRITE(5,'($1X,A)')     'NEW LINE ONE IS                  : '
        READ(5,46)K,DAT
        IF(DAT(1:1).EQ.'*') THEN
           DO I=1,40
           TEXT(1)(I:I)=' '
           END DO
	GO TO 314
        END IF
        IF(K.NE.0)TEXT(1)=DAT
314     READ(3,47)TEXT(2)
      WRITE(5,'(/,2A)')' OLD LINE TWO IS                  : ',TEXT(2)
        WRITE(5,'($1X,A)')'NEW LINE TWO IS                  : '
        READ(5,46)K,DAT
        IF(DAT(1:1).EQ.'*') THEN
           DO I=1,40
           TEXT(2)(I:I)=' '
           END DO
	GO TO 315
        END IF
        IF(K.NE.0)TEXT(2)=DAT
315     READ(3,47)TEXT(3)
      WRITE(5,'(/,2A)') ' OLD LINE THREE IS                : ',TEXT(3)
        WRITE(5,'($1X,A)') 'NEW LINE THREE IS                : '
        READ(5,46)K,DAT
        IF(DAT(1:1).EQ.'*') THEN
           DO I=1,40
           TEXT(3)(I:I)=' '
           END DO
	GO TO 316
        END IF
	IF(K.NE.0)TEXT(3)=DAT
316     READ(3,47)TEXT(4)
      WRITE(5,'(/,2A)')' OLD LINE FOUR IS                 : ',TEXT(4)
        WRITE(5,'($1X,A)')'NEW LINE FOUR IS                 : '
        READ(5,46)K,DAT
        WRITE(5,'(/)')
        IF(DAT(1:1).EQ.'*') THEN
           DO I=1,40
           TEXT(4)(I:I)=' '
           END DO
	GO TO 323
        END IF
	IF(K.NE.0) TEXT(4)=DAT
323     REWIND 3
        WRITE(3,1)I1,F1
	WRITE(3,1)I2,F2
        WRITE(3,1)I3,F3
        WRITE(3,1)I4,F4
	WRITE(3,'(F10.0)')SC
        WRITE(3,4)IOUT
        WRITE(3,'(F7.1)')TMI
        WRITE(3,'(F7.1)')TMA
        WRITE(3,'(F7.1)')TSC
        WRITE(3,'(I2)')NF
        DO J=1,NF
        WRITE(3,47)DATEI(J)
        WRITE(3,4)IFORM(J)
        WRITE(3,4)IPEN(J)
        END DO
        WRITE(3,47)TEXT(1)
        WRITE(3,47)TEXT(2)
        WRITE(3,47)TEXT(3)
        WRITE(3,47)TEXT(4)
        GO TO 999
500     REWIND 3
        GO TO 299 
999     CLOSE(UNIT=3)
	END  