      PROGRAM SAKAAUS
C
C     Programm zum Einlesen der einzelnen Auswertungsfiles aus der
C     Sandkomponentenanalyse in die Standarddatensaetze
C
C-----Variablen
      CHARACTER GERAET*2,  KERNNR*6,  NFILE*15, SAKAF*15, SFILE*15,
     * BFILE*15, TFILE*15, SAKABEMK*20, SAKAPROT*20, FORM*24, SFGP*20
      CHARACTER*80 SAKA, BEMERK, LINIE
      INTEGER I, J, K, TIEFE(400), Z, ZZ, TIEF
      REAL GEST, MINE, GLAU, MNKN, GLAS, QUAR, ASHE, BIMS, FREE,
     *     PLAN, SBEN, KBEN, RADI, SCHW, DIAT, BRYO, OSTR, MOLL, 
     *     OTHE, BIOG, BIO(5), GEWP(5),
     * H2O(400), KARB(400), CORG(400), SULF(400), OPAL(400), 
     * FRAG(400), FREI(400), GESC(400), FEST(400)
      FORM = '(X,I4,X,10(X,F6.2))'
      LINIE = '------------------------------------------------------
     *-------------------------'
C---------------------------------------------------------------------
      PRINT '(/,2A)', '$KERN-NR. ?      ', KERNNR1
      READ (*,'(A)'), KERNNR
      PRINT '(/,A)', ' GERAETETYP ?      Kastengreifer    KG'
      PRINT '(A)', '                   Schwerelot       SL'
      PRINT '(A)', '                   Kolbenlot        KO'
      PRINT '(A)', '                   Kastenlot        KA'
      READ (*,'(A)'), GERAET
      WRITE (SFILE, '(A4,2A,A2,A4)'), KERNNR(1:4), '.', KERNNR(6:6),
     *GERAET, 'SEDI'
      WRITE (BFILE, '(A4,2A,A2,A4)'), KERNNR(1:4), '.', KERNNR(6:6),
     *GERAET, 'BIOG'
      WRITE (TFILE, '(A4,2A,A2,A4)'), KERNNR(1:4), '.', KERNNR(6:6),
     *GERAET, 'TERR'
      WRITE (SAKABEMK, '(A4,2A,A2,A7)'), KERNNR(1:4), '.', KERNNR(6:6),
     *GERAET, 'SAKABEM'
      WRITE (SAKAPROT, '(A4,2A,A2,A7)'), KERNNR(1:4), '.', KERNNR(6:6),
     *GERAET, 'SAKAPRO'
C
C  SFGP = Sand-Fraktion=Gewichts=Prozent !
C
      WRITE (SFGP, '(A4,2A,A2,A7)'), KERNNR(1:), '.', KERNNR(6:6),
     *GERAET, 'SFGP'
C
C--Einlesen der Daten aus XXXX.XGGSEDI
C
      I = 1
      OPEN (22, FILE=SFILE, ERR=123, STATUS='OLD')
 100  CONTINUE
      READ (22,*,END=111) TIEFE(I), H2O(I), KARB(I), CORG(I), SULF(I),
     * OPAL(I), FRAG(I), FREI(I), FREI(I), GESC(I), FEST(I)
      I = I+1
      GOTO 100
C
 111  CONTINUE
      CLOSE (22)
      I = I-1
      PRINT *, ' ANZAHL DER PROBEN ', I
      OPEN (33, FILE=BFILE, STATUS='NEW')
      OPEN (44, FILE=TFILE, STATUS='NEW')
      OPEN (55, FILE=SAKABEMK, STATUS='NEW')
      OPEN (66, FILE=SAKAPROT, STATUS='NEW')
      OPEN (99, FILE=SFGP, STATUS='NEW')
C-----------------------------------------------------------------------
C--Umformung SAKA-Files in Standardfiles
C-----------------------------------------------------------------------
      Z = -1
      F = 0.0
      SAKA = ' '
      BEMERK = ' '
C--------------------------------------------Anfang Hauptschleife-------
      DO 222 J=1,I
C
C--Erzeugen des SAKA-Filenamen
C
         WRITE (SAKAF, '(I4.4,A4,2A,A2)') TIEFE(J), KERNNR(1:4),
     *                                '.', KERNNR(6:6), GERAET
C
C--Einlesen aller Zeilen in Protokollfile
C
         OPEN (77, FILE=SAKAF, ERR=123, STATUS='OLD')
         DO K = 1,14
            READ (77,'(A80)') SAKA
            WRITE (66, '(A80)') SAKA
         END DO
            WRITE (66, '(A80)') LINIE
         CLOSE (77)
C
C--SAKA-File neu oeffnen, lesen der Summenprozente (6. + 12. Zeile),
C        des Fragmentierungsindex (13. Zeile) und der Bemerkung (14. Zeile),
C        schreiben in die Standardfiles
C
         OPEN (77, FILE=SAKAF, ERR=123, STATUS='OLD')
         BEMERK = ' '
         SAKA = ' '
C
C--terrigene Komponenten
C
         DO L = 1,5
            READ (77, '(F6.2, A70)') GEWP(L), SAKA
         END DO     
         READ (77, *) TIEF, GEST, QUAR, MINE, GLAU, MNKN, GLAS, 
     *                ASHE, BIMS, FREE, OTHE
         WRITE (44, FORM) TIEF, GEST, QUAR, MINE,
     *                GLAU, MNKN, GLAS, ASHE, BIMS, FREE, OTHE
C
C--biogene Komponenten
C
         DO L = 1,5
            READ (77, '(F6.2, A64, F6.2)') GEWP(L), SAKA, BIO(L)
         END DO
         WRITE (99, FORM) TIEF, GEWP(1), GEWP(2), GEWP(3), GEWP(4),
     *             GEWP(5), BIO(1),  BIO(2),  BIO(3),  BIO(4),  BIO(5)
         READ (77, *) TIEF, PLAN, SBEN, KBEN, RADI, SCHW, DIAT,
     *                BRYO, OSTR, MOLL, BIOG
         WRITE (33, FORM) TIEF, PLAN, SBEN, KBEN,
     *                RADI, SCHW, DIAT, BRYO, OSTR, MOLL, BIOG
C
C--Fragmentierungsindex
C
         READ (77, *) FRAG(J)
C
C--Bemerkungen
C
         READ (77, '(A70)') BEMERK
         CLOSE (77)
         IF (BEMERK .EQ. ' ') GOTO 222
         WRITE (55, '(I4,2X,A70)') TIEF, BEMERK
C
 222  CONTINUE
C---------------------------------------------Ende Hauptschleife--------
      CLOSE (33)
      CLOSE (44)
      CLOSE (55)
      CLOSE (66)
      CLOSE (99)
C
C--File XXXX.XGGSEDI neu schreiben
C
      OPEN (22, FILE=SFILE, STATUS='NEW')
      K = I
      DO I = 1,K
      WRITE (22, FORM) TIEFE(I), H2O(I), KARB(I), CORG(I), 
     * SULF(I), OPAL(I), FRAG(I), FREI(I), FREI(I), GESC(I), FEST(I)
      END DO
      GOTO 1234
 123  PRINT *, ' File ', SAKAF, ' existiert nicht !'
 1234 END