      PROGRAM EXPO
C
C-----Deklarationen                            
      PARAMETER (NPRO=1600)             ! Anzahl Proben
      PARAMETER (NPAR=400)              ! Anzahl Parameter
      PARAMETER (NTIEF=25)              ! Anzahl Tiefenserien
C
      CHARACTER*35 FOUT, FILNAM, PARA(NPAR)*40, KERN*6, FMT*45, 
     *          CVAR*3, INCHAR*1, CRES*3, AT*6, JN*1, JJN*1, JNN*1,
     *          KPTEXT(NTIEF)*50, CLS*10, ENGL(NPAR)*20, EXCEL*80, 
     *          EXCELH*1000, MAC*1000, FMT1*45, XYZ*1
C
      INTEGER   KEN(NPAR), VAROUT(NPAR), KPT, REST, KENZ, SUMIRD,
     *          ANTI(NTIEF), ANZGR
C
      REAL      FELD(NPAR,NPRO), TIEF(NTIEF,NPRO)
C
      COMMON /FE/ FELD, TIEF, KPT, KEN, ANTI, KPTEXT
      COMMON /PA/ PARA
C______________________________________________________________________________
C.....sedimentologische Parameterbezeichnungen lesen
      OPEN (88, FILE='SYS$USER:[GROBE]PARA.SEDAN', STATUS='OLD')
      DO I = 1, NPAR
         READ (88, '(A40,A20)') PARA(I), ENGL(I)
      END DO
      CLOSE (88)
C______________________________________________________________________________
C.....externen Datensatz oeffnen
      WRITE (6, '(/,A)') '$Kern ==>> '
      READ  (5, '(A)') KERN
      FILNAM = '[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'SED'
      OPEN (99, FILE=FILNAM, STATUS='OLD', FORM='UNFORMATTED')
C______________________________________________________________________________
C.....Anzahl der Tiefen {ANTI(K)} und Probentiefen {TIEF(K,I)} lesen
      DO K=1,NTIEF
         READ (99) ANTI(K), (TIEF(K,I), I=1,ANTI(K))
         IF (ANTI(K) .NE. 0) READ (99) KPTEXT(K)
      END DO
C
C.....Kernanfang, -ende, Sonderkennungen lesen
      READ (99) SUMIRD            
      READ (99) TOP, BOT, ANZGR
C    
C.....Sedimentparameter lesen
  199 CONTINUE
      READ (99, END=177) KTIEF, KENZ, (FELD(KENZ,I), I=1,ANTI(KTIEF))
      KEN(KENZ) = KTIEF
      GOTO 199
  177 CONTINUE
      CLOSE (99)
C==============================================================================
      WRITE (6, '(/,A)') '$Dezimal-<P>unkt oder -<K>omma > '
      READ  (5, '(A)')  XYZ
      CALL CAPS (XYZ)
      CALL KENT(KPT)
      IKPT = KPT
      IF (KPT .EQ. 0) GOTO 54321
      IF (KPT .GT. 10 .AND. KPT .LE. 20) KPT = KPT-10
C
      NVAR = 1
      WRITE (6,'(/,A)') ' Eingabe der Parameter'
      WRITE (6,'(  A)') ' ====================='
  721 CONTINUE
      WRITE (6,'(A)')' -----------------------------------------------'
      WRITE (6, '(/,X,I3.3,A)') NVAR,'. Parameter '
      CALL PAR (VAROUT(NVAR))
      IF (VAROUT(NVAR) .EQ. 0) GOTO 800
      IF (KPT .NE. KEN(VAROUT(NVAR))) THEN
         CALL SBELL
         WRITE (6,'(/,X,A)')
     *'Tiefenserie stimmt nicht ueberein 
     *oder Parameter nicht vorhanden!'
         GOTO 721
      END IF
      NVAR = NVAR+1
      GOTO 721
C
C.....MAC-Format erzeugen
 800  CONTINUE
      WRITE (CVAR,'(I3)') NVAR
      FMT  = '('//CVAR//'F12.3)'
      FMT1 = '('//CVAR//'I4)'
      IREC = NVAR*12
C
C.....Filennamen erfragen
  790 CONTINUE
      WRITE (6, '(/,A)') '$Name des Ausgabefiles ? [xxxx.xDAT] > '
      READ  (5, '(A)')   FOUT
      IF (FOUT .EQ. ' ') THEN
         FOUT = 'ATK$USER:[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'DAT'
      ELSE
         FOUT = 'ATK$USER:[GEOLOGIE]'//FOUT
      END IF
C
      OPEN (14, FILE=FOUT, RECL=IREC,
     *              CARRIAGECONTROL='LIST', STATUS='NEW')
C
C.....Datensatz schreiben
      DO IDS = 0, ANTI(KPT)
         EXCELH = ' '
         MAC    = ' '
         IF (IDS .EQ. 0) THEN
            WRITE (EXCELH, FMT1) ANTI(KPT), (VAROUT(K), K=1,NVAR-1)
         ELSE
            WRITE (EXCELH, FMT) 
     *           TIEF(IKPT,IDS), (FELD(VAROUT(J),IDS), J=1,NVAR-1)
         END IF
C
C.....Leerzeichen durch TAB ersetzen
      ITAB = 1
      IMAC = 0
      LSTRING = NZEICH(EXCELH)
      DO I = 1, LSTRING
         IF (EXCELH(I:I) .EQ. ' ') THEN
            IF (ITAB .EQ. 0) THEN
               IMAC = IMAC + 1
               MAC(IMAC:IMAC) = '	'
               ITAB = 1
            END IF
         ELSE
            IMAC = IMAC + 1
            MAC (IMAC:IMAC) = EXCELH(I:I)
C
C.....Punkte durch Komma ersetzen
            IF (XYZ .EQ. 'K') THEN
               IF (MAC(IMAC:IMAC) .EQ. '.') MAC(IMAC:IMAC) = ','
            END IF
            ITAB = 0
         END IF
      END DO
      WRITE (14,'(A)') MAC(:IMAC)
      END DO
      CLOSE (14)
      WRITE (6,'(/,2A)') ' Daten stehen in ', FOUT
54321 END