      SUBROUTINE DIANE (IEND, IPART, FILIN, JNN)
C
C-----Deklarationen                            
      CHARACTER*35 FILOUT, JJN*1, CDIR*12, KERN*6,
     *             TAG*9, ZEIT*8, FILIN*70, JNN*1
      REAL Y2(4000), PROD(7), F(7), DATEN(15),
     *     X(4000), Y(4000), Y1(4000), GLATT(17), E(500+1,2)
C
      EXTERNAL UPKAN, UNPKI
      REAL UPKAN, UNPKI
      INTEGER*2 IARR(256)         ! INTEGER ARRAY TO READ FILE RECORDS
      COMMON / GRADE / X, Y2, JJN
      DATA  GLATT / .005, .01, .02, .03, .045, .07, .09, .12, .22,
     *              .12, .09, .07, .045, .03, .02, .01, .005 /
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IF (IEND .GT. 1) GOTO 999
      IF (JNN .EQ. 'A') THEN
         WRITE (6,'(A)') 
     *'$Kaolinit-Berechnung aus Chlorit <2>. oder <4>. Ordnung > '
         READ (5,*) KIORD
         WRITE (6,'(A)') '$Kaolinit-Factor (* 3. Ord.) > '
         READ (5,*) FACT
         WRITE (6,'(A)') '$grafische Darstellung  [N]  > '
         READ  (5,'(A)') JJN
         GOTO 999
      ELSE IF (JNN .EQ. 'P') THEN
         WRITE (6,'(A)') '$<A>lle oder <E>inzeln ?     > '
         READ  (5,'(A)') JN
      END IF
C
  999 CONTINUE
      OPEN (11,FILE=FILIN,TYPE='OLD',ACCESS='DIRECT',RECL=128,ERR=7111)
      IF (JNN .EQ. 'A') WRITE (6,'(X,A,I6,2X,A)') 
     *    'XRD-Auswertung: ', IEND, FILIN
      READ  (11'1 , ERR=1234) ( IARR(I), I=1,256 )
      ANGLOW = UPKAN ( IARR(27) )                ! LOWEST ANGLE IN THE FILE
      ANGHIG = UPKAN ( IARR(28) )                ! HIGHEST ANGLE IN THE FILE
      CNTMAX = UNPKI ( IARR(33) )                ! MAX. COUNT VALUE IN THE FILE
 1200 NREC = 2                                   ! FIRST RECORD TO BE READ 
      NRPRV= 0                                   ! PREVIOUS SCAN NUMBER IS 0  
      IG = 1
      Y1(1) = 100.
C..............................................................................
 1250 READ (11'NREC , ERR=1234 ) ( IARR(I), I=1,256 ) 
      SANG   = UPKAN ( IARR(1) )                 ! STARTING ANGLE IN THIS RECORD
      STSIZE = UPKAN ( IARR(2) )                 ! STEPSIZE
      EANG   = UPKAN ( IARR(4) )                 ! ENDING ANGLE
      NR     = IARR(6) .AND. "377                ! SCAN NUMBER
C
      IF ( NR .NE. NRPRV ) THEN 
         X(IG) = SANG
         Y(IG) = UNPKI(IARR(7))
         IG = IG+1
      END IF
 1255 CONTINUE
      NPOINT = ( EANG - SANG ) / STSIZE + 0.5    ! NUMBER OF DATA POINTS
      ANGLE  = SANG
      DO 1260 , I=1,NPOINT                       ! LIST ALL DATA POINTS 
         ANGLE  = ANGLE + STSIZE
         COUNTS = UNPKI ( IARR(6+I) )
         X(IG) = ANGLE
         Y(IG) = COUNTS
         IG = IG+1
 1260 CONTINUE 
      NREC = NREC + 1                           ! READ NEXT RECORD
      GOTO 1250 
C..............................................................................
 1234 CLOSE (11)
      IG = IG-1
C.....Ausreisser eliminieren
      DO I = 1,IG-2
         ZW = (Y(I) + Y(I+2))/2
         IF (Y(I+1) .GT. ZW+100.) Y(I+1) = ZW
      END DO
C.....glaetten ueber 17 Werte
      DO I = 1,8
         Y1(I) = Y(9)
      END DO
      DO I = 1,IG-8
         Y1(I+8) = 0.0
         DO I2 = 1,17
            Y1(I+8) = Y1(I+8)+Y(I+I2-1)*GLATT(I2)
         END DO
      END DO
      IF (IPART .EQ. 2) THEN
         DO I = 1,IG
            Y2(I) = Y1(I)
         END DO
         GOTO 4457
      END IF
C.....Lage des Quarzpiek suchen
      DMAX = 0.0
      DO I5 = 1,IG
         IF (X(I5) .GT. 30.) THEN
            IF (Y1(I5) .GT. DMAX) DMAX = Y1(I5)
         END IF
         IF (X(I5) .GT. 32.) GOTO 4458
      END DO
 4458 CONTINUE
      DO I5 = 1,IG
         IF (Y1(I5) .EQ. DMAX) GOTO 4456
      END DO
 4456 CONTINUE
C.....Spektrum verschieben, nach Quarzpiek korrigiert
      IDIF = NINT((31.040 - X(I5))/STSIZE)
      IF (IDIF .EQ. 0) THEN
         DO I4 = 1,IG
            Y2(I4) = Y1(I4)
         END DO
      ELSE IF (IDIF .GT. 0) THEN
         DO I4 = IDIF,IG
            Y2(I4) = Y1(I4-IDIF)
         END DO
      ELSE IF (IDIF .LT. 0) THEN
         DO I4 = 1,IG+IDIF
            Y2(I4) = Y1(I4-IDIF)
         END DO
      END IF
      IF (JNN .EQ. 'A') GOTO 1500    ! auswerten
C------------------------------------------------------------------------------
C.....plotten
 4457 CONTINUE
      IF (JN  .EQ. 'E') THEN
         CALL LUGRAF (IEND, IOUT)
         WRITE (6,'(X,2A)') 'XRD-Auswertung: ',FILIN
      ELSE IF (JN  .EQ. 'A') THEN
         IF (IEND .EQ. 1) CALL LUGRAF (IEND, IOUT)
         IF (IOUT .EQ. 0) WRITE (6,'(X,2A)') 'XRD-Auswertung: ',FILIN
         IF (IOUT .GT. 2) WRITE (6,'(X,2A)') 'XRD-Auswertung: ',FILIN
         IF (IEND .NE. 1) GOTO 4455
      END IF
      CALL GPRINT(0)
      CALL GOPEN
C.....X-Achse
      CALL BGRAF(25.,20.,223.,150.)
      CALL BTICKM(4)
      CALL BAXLAB(4.,3.,999,999)
      CALL BAXIS(1,X(1),0.,X(IG),'Degree$')
      CALL BGRID(1,0)
C.....zweite X-Achse plotten
      CALL BAXORI(25.,170.)
      CALL BTICKM(2)
      CALL BAXIS(-1,X(1),0.,X(IG),'$')
C.....Y-Achse
      CALL BTICKM(5)
      CALL BAXLAB(4.,3.,999,999)
      IF (IPART .EQ. 1) CALL BAXIS(2,0., 250., 1000.,'Intensity$')
      IF (IPART .EQ. 2) CALL BAXIS(2,0., 250., 1000.,'Intensity$')
      CALL BGRID(0,1)
C.....Daten plotten
 4455 CONTINUE
      IF (IOUT .NE. 7) CALL BLICOL(2)
      CALL BLINE(X,Y2,IG)
      IF (JN .EQ. 'A') GOTO 1112
C.....Beschriftung
      CALL GCHARF ('COMP')
      PP = 183.
      IF (IOUT .EQ. 1 .OR. IOUT .EQ. 2) PP = 160.
      DO ICH = 15,35
         IF (FILIN(ICH:ICH) .EQ. 'D') GOTO 4460
      END DO
 4460 CONTINUE
      CALL GCHAR ('Core$',25.,PP,4.0)
      CALL GCHAR 
     * (FILIN(ICH-6:ICH-3)//'-'//FILIN(ICH-1:ICH-1)//'$',44.,PP,4.0) 
      CALL GCHAR ('X-ray Diffraction Analysis$',145.,PP,3.5)
      CALL GCHAR ('AWI$',238.,PP,3.5)
      CALL GCHAR ('Sample$',80.,PP,4.0)
      CALL GCHAR ('m$',130.,PP,3.0)
      CALL GCHAR 
     * (FILIN(ICH-11:ICH-9)//'.'//FILIN(ICH-8:ICH-7)//'$',105.,PP,4.0)
C
C.....Institut, Datum schreiben
      CALL DATE(TAG)
      CALL TIME(ZEIT)
      CALL GCHARA(90)
      CALL GCHAR ('SEDAN * Alfred Wegener Institute for
     * Polar and Marine Research$',251.,20.,1.5)
      CALL GCHARA(90)
      CALL GCHAR (' * '//TAG//' * '//ZEIT//'$',251.,81.,1.5)
      CALL GCLOSE
      GOTO 1112
C------------------------------------------------------------------------------
 1500 CONTINUE
C.....Peaks integrieren
C.....Smektit..................................................................
      CALL MIN  (100,160,MIN1SM)
      CALL MIN  (280,360,MIN2SM)
      CALL MAX  (170,239,MAXSME)
      CALL PEAK (MIN1SM,MIN2SM,MIN1SM,MAXSME+10,SMEK)
      IF (SMEK .LE. 0.) SMEK = 1.0
C.....Illit....................................................................
      MIN1IL = MIN2SM
      CALL MIN  (450,550,MIN2IL)
      CALL MAX  (370,450,MAXILL)
      CALL PEAK (MIN1IL,MIN2IL,MAXILL-40,MAXILL,TILL)
      TILL = TILL*2.
      IF (TILL .LE. 0.) TILL = 1.0
C.....Hornblende...............................................................
      CALL MIN  (440,510,MINHB1)
      CALL MIN  (510,560,MINHB2)
      CALL MAX  (MINHB1,MINHB2,MAXHB)
      CALL PEAK (MINHB1,MINHB2,MAXHB-12,MAXHB+12,HORN)
      IF (HORN .LE. 0.) HORN = 1.0
C.....Chlorit 2.Ordnung........................................................
      CALL MIN  (480,600,MIN1C2)
      CALL MIN  (640,700,MIN2C2)
      CALL MAX  (600,650,MAXCH2)
      CALL PEAK (MIN1C2,MIN2C2,MAXCH2,MAXCH2+25,CHLO2)
      CHLO2 = CHLO2*2.
      IF (CHLO2 .LE. 0.) CHLO2 = 1.0
C.....Molybdaensulfid..........................................................
      MIN1MO = MIN2C2
      CALL MIN  (750,820,MIN2MO)
      CALL MAX  (MIN1MO,MIN2MO,MAXMO)
      CALL PEAK (MIN1MO,MIN2MO,MAXMO-20,MAXMO+20,STAND)
C.....Illit 2. Ordnung.........................................................
      CALL MIN  (890,910,MIN1I2)
      CALL MIN  (930,970,MIN2I2)
      CALL MAX  (920,950,MAXIL2)
      CALL PEAK (MIN1I2,MIN2I2,MAXIL2-12,MAXIL2,TILL2)
      TILL2 = TILL2*2.
      IF (TILL2 .LE. 0.) TILL2 = 1.0
C.....Chlorit 3.Ordnung........................................................
      CALL MIN  (845,900,MIN1C3)
      CALL MIN  (1000,1040,MIN2C3)
      CALL MAX  (950,1000,MAXCH3)
      CALL PEAK (MIN1C3,MIN2C3,MAXCH3,MAXCH3+17,CHLO3)
      CHLO3 = CHLO3*2.
      IF (CHLO3 .LE. 0.) CHLO3 = 1.0
C.....Quarz 35 ................................................................
      CALL MIN  (1050,1120,MI1Q35)
      CALL MIN  (1130,1160,MI2Q35)
      CALL MAX  (1110,1140,MAXQ35)
      CALL PEAK (MI1Q35,MI2Q35,MAXQ35-13,MAXQ35,QU35)
      QU35 = QU35*2.
      IF (QU35 .LE. 0.) QU35 = 1.0
C.....Chlorit 4.Ordnung........................................................
      CALL MIN  (1320,1340,MIN1C4)
      CALL MIN  (1370,1415,MIN2C4)
      CALL MAX  (MIN1C4, MIN2C4,MAXC4)
      CALL PEAK (MIN1C4,MIN2C4,MAXC4-20,MAXC4+20,CHLO4)
      IF (CHLO4 .LE. 0.) CHLO4 = 1.0
C.....Quarz....................................................................
      CALL MIN  (1380,1420,MINQU1)
      CALL MIN  (1460,1500,MINQU2)
      CALL MAX  (MINQU1,MINQU2,MAXQU)
      CALL PEAK (MINQU1,MINQU2,MAXQU-30,MAXQU,QUARZ)
      QUARZ = QUARZ*2.
C.....Feldspat.................................................................
      MINFE1 = MINQU2
      CALL MIN  (1530,1560,MINFE2)
      CALL MIN  (1560,1585,MINTAL)
      CALL PEAK (MINFE1,MINTAL,MINFE1,MINFE2-2,FELDS)
      IF (FELDS .LE. 0.) FELDS = 1.0
C.....Talc.....................................................................
      CALL MAX  (MINFE2,MINTAL,MAXTAL)
      CALL PEAK (MINFE1,MINTAL,MAXTAL,MAXTAL+20,TALC)
      IF (TALC .LE. 0.) TALC = 1.0
      TALC = TALC*2.
C.....Chlorit 5.Ordnung........................................................
      CALL MIN  (1700,1730,MIN1C5)
      CALL MIN  (1750,1800,MIN2C5)
      CALL MAX  (1720,1770,MAXCH5)
      CALL PEAK (MIN1C5,MIN2C5,MAXCH5-20,MAXCH5,CHLO5)
      CHLO5 = CHLO5*2.
      IF (CHLO5 .LE. 0.) CHLO5 = 1.0
C------------------------------------------------------------------------------
C.....Kaolinit berechnen
      IF (KIORD .EQ. 2) RKAOL  = CHLO2-(CHLO3*FACT)
      IF (KIORD .EQ. 4) RKAOL  = CHLO4-(CHLO3*FACT)
      IF (RKAOL .LT. 0.0) RKAOL = 0.0
C
C.....Prozente berechnen
      TONSUM  = SMEK + TILL*4. + (CHLO3*5.)*2. + RKAOL*2.
         PSMEK  = 100./TONSUM* SMEK
         PTILL  = 100./TONSUM* TILL*4.
         PCHLO  = 100./TONSUM*(CHLO3*5.)*2.
         PKAOL  = 100./TONSUM* RKAOL*2.
C
      TONSUM  = SMEK + TILL + CHLO3*5. + RKAOL + TALC
         PTALC  = 100./TONSUM*TALC
         IF (PTALC .LE. 0.) PTALC = .01
C
      DETSUM  = HORN + QUARZ + FELDS
         PHORN  = 100./DETSUM*HORN
         PQUARZ = 100./DETSUM*QUARZ
         PFELD  = 100./DETSUM*FELDS
C
C.....Verhaeltnisse berechnen
      VSMCH  = SMEK/CHLO2
      VSMIL  = SMEK/TILL
      VSMIC  = SMEK/(TILL+CHLO2)
      VCHIL  = CHLO2/TILL
      VCHTA  = CHLO2/TALC
      IF (VCHTA .GT. 100.) VCHTA = 100.
      VQUAM  = QUARZ/HORN
      VQUFE  = QUARZ/FELDS
      IF (VQUFE .GT. 9999.) VQUFE = 9999.
C
      VC2C3 = CHLO2/CHLO3
      IF (VC2C3 .GT. 20.) VC2C3 = 20.
      VC2C4 = CHLO2/CHLO4
      IF (VC2C4 .GT. 20.) VC2C4 = 20.
      VC2C5 = CHLO2/CHLO5
      IF (VC2C5 .GT. 20.) VC2C5 = 20.
      VI1I2 = TILL/TILL2
      IF (VI1I2 .GT. 50.) VI1I2 = 50.
C
C.....Rohdaten
      WRITE (6, '(X, 8F8.0)') SMEK, TILL, HORN, CHLO2, STAND, TILL2,
     *                        CHLO3, QU35
      WRITE (6, '(X, 6F8.0)') CHLO4, QUARZ, FELDS, TALC, CHLO5, RKAOL
      WRITE (77,'(X, 8F8.0)') SMEK, TILL, HORN, CHLO2, STAND, TILL2,
     *                        CHLO3, QU35
      WRITE (77,'(X, 6F8.0)') CHLO4, QUARZ, FELDS, TALC, CHLO5, RKAOL
C.....Prozente
      WRITE (6 ,'(X, 8F8.2)') PSMEK, PTILL, PCHLO, PKAOL, PTALC,
     *                        PHORN, PQUARZ, PFELD
      WRITE (77,'(X, 8F8.2)') PSMEK, PTILL, PCHLO, PKAOL, PTALC,
     *                        PHORN, PQUARZ, PFELD
C.....Verhaeltnisse
      WRITE (6 ,'(X,11F8.2)') VSMCH, VSMIL, VSMIC, VCHIL, VCHTA,
     *                        VQUAM, VQUFE, VC2C3, VC2C4, VC2C5, VI1I2
      WRITE (77,'(X,11F8.2)') VSMCH, VSMIL, VSMIC, VCHIL, VCHTA,
     *                        VQUAM, VQUFE, VC2C3, VC2C4, VC2C5, VI1I2
C
 1112 CONTINUE
      IF (JN .EQ. 'A' .AND. IEND .EQ. 99999) THEN
         CALL GCHAR ('Core$',25.,183.,4.0)
         CALL GCHAR 
     * (FILIN(ICH+5:ICH+8)//'-'//FILIN(ICH+10:ICH+10)//'$',44.,183.,4.0) 
         CALL GCHAR ('X-ray Analysis$',160.,183.,3.5)
         CALL GCHAR ('AWI$',250.,183.,3.5)

C
C.....Institut, Datum schreiben
         CALL DATE(TAG)
         CALL TIME(ZEIT)
         CALL GCHARA(90)
         CALL GCHAR ('SEDAN * Alfred Wegener Institute for
     * Polar and Marine Research$',251.,20.,1.5)
         CALL GCHARA(90)
         CALL GCHAR (' * '//TAG//' * '//ZEIT//'$',251.,81.,1.5)
         CALL GCLOSE
      END IF
      GOTO 12345
 7111 WRITE (6,'(X,3A)') 'File ', FILIN, ' nicht vorhanden !'
12345 END
C******************************************************************************
      REAL FUNCTION UPKAN (IPKAN)
C
      INTEGER*2 IPKAN                                    ! PACKED ANGLE VALUE
      UPKAN = 0.005 * IPKAN
      IF (IPKAN .GE. 0) GOTO 9000
      UPKAN = - UPKAN - 0.0025
 9000 END
C******************************************************************************
      REAL FUNCTION UNPKI (IPACK)
C
      INTEGER*2 IPACK                   ! CONTAINS THE INTENSITY TO BE UNPACKED
      REAL R                            ! TEMPORARY VALUE
      IF ( IPACK .LT. -1000 ) GOTO 2000
      IF ( IPACK .EQ. 0 ) IPACK = 1     ! PREVENT THAT UNPKI CAN BE  0
      UNPKI = ( FLOAT(IPACK) /10 )**2 * ISIGN(1,IPACK)
      GOTO 3000
 2000 R = FLOAT( IPACK .AND. "77777 ) + 32768.  
      UNPKI = (R/10.) **2
 3000 END
C******************************************************************************
      SUBROUTINE PEAK (IREG1,IREG2,IFLA1,IFLA2,FLAECH)
C
      CHARACTER JJN*1
      REAL X(4000), Y2(4000), XP(5), A(500,2), B(2,2), C(2)
      COMMON / GRADE / X, Y2, JJN
C
      IF (JJN .NE. 'J') GOTO 10
      CALL GROUTE ('SEL MT41XX;EX')
      CALL GPRINT(0)
      CALL GOPEN
C.....X-Achse
      CALL BGRAF(25.,20.,210.,150.)
      CALL BAXLAB(4.,3.,999,999)
      CALL BAXIS(1,X(IREG1-20),0.,X(IREG2+20),'Degree$')
C.....Y-Achse
      CALL MAX(IREG1,IREG2,NMAX)
      CALL BAXLAB(4.,3.,999,999)
      CALL BAXIS(2,0.,50.,Y2(NMAX)+30.,'Intensity$')
C
   10 CONTINUE
      A(1,1) = X(IREG1)
      A(1,2) = Y2(IREG1)
      A(2,1) = X(IREG2+1)
      A(2,2) = Y2(IREG2+1)
C
      FLAECH = 0.0
      DO 100 I=1,2
         C(I)=0.0
         DO 101 J=1,2
            B(I,J)=0.0
  101     CONTINUE
  100 CONTINUE
C
      DO 102 I=1,2
         XP(1)=1.0
         DO 103 J=2,2
            XP(J)=XP(J-1)*A(I,1)
  103    CONTINUE
         DO 104 J=1,2
            DO 105 K=1,2
               B(J,K)=B(J,K)+XP(J)*XP(K)
  105       CONTINUE   
            C(J)=C(J)+XP(J)*A(I,2)
  104    CONTINUE
  102 CONTINUE
C
      CALL SLE(B,C,2,2,1.0E-06)
C
      IF (JJN .EQ. 'J') THEN
         DO I = IREG1-20, IREG2+20
            CALL BRXYV(X(I),Y2(I),XN,YN)
            CALL GDOT (XN,YN,1)
         END DO       
      END IF
      X1=X(IFLA1)
      DX=X(2)-X(1)
      DO 110 I = IFLA1, IFLA2
         XXP=1.0
         YYP=0.0
         DO 111 J=1,2  ! IORD1
            YYP=YYP+XXP*C(J)    
            XXP=XXP*X1
  111    CONTINUE
         IF (YYP .GT. Y2(I)) YYP = Y2(I)
         FLAECH = FLAECH + (Y2(I)-YYP)
         IF (Y2(I) .EQ. Y2(NMAX)) BCKGR = YYP
         IF (JJN .EQ. 'J') THEN
            CALL BRXYV(X(I),Y2(I),XN,YN)
            CALL BRXYV(X(I),YYP,XN,YNN)
            CALL GWICOL(.1,3)
            CALL GVECT(XN,YN,0)
            CALL GVECT(XN,YNN,1)
         END IF
         X1=X1+DX
  110 CONTINUE
      FLAECH = FLAECH - ((Y2(NMAX) - BCKGR)/2.)
      IF (JJN .NE. 'J') GOTO 12345
      CALL GWICOL(.1,2)
      CALL BRXYV(X(IREG1),Y2(IREG1),XN,YN)
      CALL GVECT(XN,YN,0)
      CALL BRXYV(X(IREG2),Y2(IREG2),XN,YN)
      CALL GVECT(XN,YN,1)      
      CALL GCLOSE
12345 END
C******************************************************************************
      SUBROUTINE MAX (IANF, IEND, IMAX)
C
      REAL X(4000), Y2(4000)
      COMMON / GRADE / X, Y2
      YMAX = 0.0
      DO I = IANF, IEND
         IF (Y2(I) .GT. YMAX) THEN
            YMAX = Y2(I)
            IMAX = I
         END IF
      END DO          
      END
C******************************************************************************
      SUBROUTINE MIN (IANF, IEND, IMIN)
C
      REAL X(4000), Y2(4000)
      COMMON / GRADE / X, Y2
      YMIN = 3000.
      DO I = IANF, IEND
         IF (Y2(I) .LT. YMIN) THEN
            YMIN = Y2(I)
            IMIN = I
         END IF
      END DO          
      END