      PROGRAM EXPORT
C
C-----Deklarationen                            
      PARAMETER (NPRO=1600)             ! Anzahl Proben
      PARAMETER (NPAR=400)              ! Anzahl Parameter
      PARAMETER (NTIEF=25)              ! Anzahl Tiefenserien
C
      CHARACTER*35 FOUT, FILNAM, PARA(NPAR)*40, KERN*6, FMT*45, 
     *          CVAR*3, INCHAR*1, CRES*3, AT*6, JN*1, JJN*1, JNN*1,
     *          KPTEXT(NTIEF)*50, CLS*10, ENGL(NPAR)*20, EXCEL*80, 
     *          EXCELH*1000, MAC*1000, FMT1*45, XYZ*1
C
      INTEGER   KEN(NPAR), VAROUT(NPAR), KPT, REST, KENZ, SUMIRD,
     *          ANTI(NTIEF), ANZGR
C
      REAL      FELD(NPAR,NPRO), TIEF(NTIEF,NPRO)
C
      COMMON /FE/ FELD, TIEF, KPT, KEN, ANTI, KPTEXT
      COMMON /PA/ PARA
C______________________________________________________________________________
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
C
C.....sedimentologische Parameterbezeichnungen lesen
      OPEN (88, FILE='SYS$USER:[GROBE]PARA.SEDIM', STATUS='OLD')
      DO I = 1, NPAR
         READ (88, '(A40,A20)') PARA(I), ENGL(I)
      END DO
      CLOSE (88)
C______________________________________________________________________________
C.....externen Datensatz oeffnen
      WRITE (6, '(/,A,12X,A)') '$', 'Kern  ===>> '
      READ  (5, '(A)') KERN
      FILNAM = KERN(1:4)//'.'//KERN(6:6)//'SED'
      OPEN (99, FILE=FILNAM, STATUS='OLD', FORM='UNFORMATTED')
C
C.....Anzahl der Tiefen {ANTI(K)} und Probentiefen {TIEF(K,I)} lesen
      DO K=1,NTIEF
         READ (99) ANTI(K), (TIEF(K,I), I=1,ANTI(K))
         IF (ANTI(K) .NE. 0) READ (99) KPTEXT(K)
      END DO
C
C.....Kernanfang, -ende, Sonderkennungen lesen
      READ (99) SUMIRD            
      READ (99) TOP, BOT, ANZGR
C    
C.....Sedimentparameter lesen
  199 CONTINUE
      READ (99, END=177) KTIEF, KENZ, (FELD(KENZ,I), I=1,ANTI(KTIEF))
      KEN(KENZ) = KTIEF
      GOTO 199
  177 CONTINUE
      CLOSE (99)
C==============================================================================
  700 TYPE *, CLS
      WRITE (6,701)
  701 FORMAT (//,
     *14X,'              SEDAN-Daten exportieren'/
     *14X,'              ======================='//
     *14X,' nur Tiefe oder Zeit .............................<1>'/
     *14X,' beliebiger Datensatz ............................<2>'/
     *14X,' Daten in Serie ..................................<3>'//
     *14X,' ENDE .......................................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5, '(A)') INCHAR
      IF (INCHAR .EQ. ' ') GOTO 54321
      READ (INCHAR, *) NVAR
      WRITE (6, '(/,A)') '$MAC-Format ? <N>ein, <P>unkt, <K>omma [N] > '
      READ  (5, '(A)')  XYZ
      CALL CAPS (XYZ)
      IF (NVAR .EQ. 1) GOTO 710
      WRITE (6, '(/,A)') '$<T>iefen/<Z>eit in 1. Spalte ?  [<N>ein] > '
      READ  (5, '(A)') JN
      CALL CAPS(JN)
      IF (JN .EQ. ' ') JN = 'N'
      CALL KENT(KPT)
      IF (KPT  .EQ. 0) GOTO 54321
      IF (NVAR .EQ. 2) GOTO 720
      IF (NVAR .EQ. 3) GOTO 730
      GOTO 700
C
C.....Tiefe oder Zeit formatieren
  710 CONTINUE
      CALL KENT(KPT)
      IF (KPT  .EQ. 0) GOTO 700
      WRITE (6, '(/,A)') '$Name des Ausgabefiles ?  [xxxx.xDAT] > '
      READ  (5, '(A)')   FOUT
      IF (FOUT .EQ. ' ') FOUT = KERN(1:4)//'.'//KERN(6:6)//'DAT'
C
      OPEN (13, FILE=FOUT, CARRIAGECONTROL='LIST', STATUS='NEW')
      DO IT = 1, ANTI(KPT)
         WRITE (13, '(X,F10.3)') TIEF(KPT,IT)
      END DO
      CLOSE (13)
      IF (XYZ .EQ. 'P' .OR. XYZ .EQ. 'K') GOTO 791
      CALL RET
      GOTO 700
C
C.....beliebiger Datensatz
  720 CONTINUE
      WRITE (6,'(/,A)') '$Anzahl der Parameter > '
      READ (5,*) NVAR
      DO II = 1, NVAR
  721    CONTINUE
         WRITE (6, '(/,X,I3.3,A)') II,'. Parameter '
         CALL PAR (VAROUT(II))
         IF (VAROUT(II) .EQ. 0) GOTO 700
      END DO
      GOTO 780
C
C.....Daten in Serie
  730 CONTINUE
      WRITE (6,'(/,A)') '$erster  Parameter > '
      READ (5,*) N1
      WRITE (6,'(  A)') '$letzter Parameter > '
      READ (5,*) NL
      WRITE (6,'(  A)') '$nur vorhandene Parameter ?  [N] > '
      READ (5,'(A)') JJN
      NVAR = 0
      KKPT = KPT
      IF (JN .EQ. 'Z') KKPT = KPT-10
      DO II = N1, NL
         IF (JJN .EQ. 'J') THEN
            IF (KEN(II) .EQ. KKPT) THEN
               VAROUT(NVAR+1) = II
               NVAR = NVAR + 1
             END IF
         ELSE
            VAROUT(NVAR+1) = II
            NVAR = NVAR + 1
         END IF
      END DO      
C
C.....MAC-Format erzeugen
 780  CONTINUE
      IF (XYZ .EQ. 'P' .OR. XYZ .EQ. 'K') THEN
         IF (JN .EQ. 'N') IVAR = NVAR
         IF (JN .NE. 'N') IVAR = NVAR + 1
         WRITE (CVAR,'(I3)') IVAR
         FMT = '('//CVAR//'F12.2)'
         IREC = IVAR*12
         GOTO 790
      END IF
C
C.....Format abfragen
      IF (JN .EQ. 'N') WRITE(6,'(/,X,I3.3,A)') NVAR, ' Parameter gesamt'
      IF (JN .NE. 'N') 
     *    WRITE (6,'(/,X,I3.3,A)') NVAR, '  Parameter + Tiefe/Zeit'
      WRITE (6,'(/,A)') '$Format vorgeben  (J/N)  [N] ? '
      READ  (5,'(A)') JNN
      CALL CAPS(JNN)
      IREC = (NVAR+1)*12
      IF (JNN .EQ. 'J') THEN
         WRITE (6,'(A)') '$Format       ==> '
         READ  (5,'(A)') FMT
  782    WRITE (6,'(A)') '$Recordlaenge ==> '
         READ  (5,*) IREC
         GOTO 790
      END IF
C
C.....Format erzeugen
      IF (JN .NE. 'N') NVAR = NVAR + 1
      IF (NVAR .LE. 9) THEN
         WRITE (CVAR,'(I3)') NVAR
         FMT = '('//CVAR//'F8.2)'
      ELSE IF (NVAR .GT. 9 .AND. NVAR .LE. 18) THEN
         NVAR2 = NVAR-9
         WRITE (CVAR,'(I3)') NVAR2
         FMT = '(9F8.2,/,'//CVAR//'F8.2)'
      ELSE IF (NVAR .GT. 18) THEN
         FORM = NVAR/9.
         IFORM = INT(FORM)
         IF (FORM-IFORM .NE. 0) IFORM = IFORM-1
         IF (FORM-IFORM .EQ. 0) IFORM = IFORM-2
         REST = NVAR-(9*(IFORM+1))
         WRITE (CVAR,'(I3)') IFORM
         WRITE (CRES,'(I1)') REST
         FMT ='(9F8.2,/,'//CVAR//'(9F8.2,/),'//CRES//'F8.2)'
      END IF                                                         
      IF (JN .NE. 'N') NVAR = NVAR - 1
C
C-----formatierten multivariaten Datensatz schreiben
  790 CONTINUE
      WRITE (6, '(/,X,2A)') 'Format der Datenmatrix: ', FMT
      WRITE (6, '(/,A)') '$Parameterbez. in die 1. Zeile ?  [N] > '
      READ  (5,'(A)') JNN
      CALL CAPS(JNN)
      WRITE (6, '(/,A)') '$Pfad/Name des Ausgabefiles ? [xxxx.xDAT] > '
      READ  (5, '(A)')   FOUT
      IF (FOUT .EQ. ' ') FOUT = KERN(1:4)//'.'//KERN(6:6)//'DAT'
      OPEN  (13, FILE=FOUT, RECL=IREC, 
     *           CARRIAGECONTROL='LIST', STATUS='NEW')
C
      IF (JNN .EQ. 'J') THEN
         FMT1 = '('//CVAR//'(A4,X))'
         IF (JN .NE. 'N') THEN
            WRITE (13, FMT1) 
     *      'Depth   ', (ENGL(VAROUT(J)), J=1,NVAR)
CCC            WRITE (13, FMT) .0, (FLOAT(VAROUT(J)), J=1,NVAR)
         ELSE
            WRITE (13, FMT1)
     *                  (ENGL(VAROUT(J)), J=1,NVAR)
CCC            WRITE (13, FMT)     (FLOAT(VAROUT(J)), J=1,NVAR)
         END IF
      END IF
C
      DO I = 1, ANTI(KPT)
         IF (JN .NE. 'N') THEN
            WRITE (13, FMT)
     *                  TIEF(KPT,I), (FELD(VAROUT(J),I), J=1,NVAR)
         ELSE 
            WRITE (13, FMT) (FELD(VAROUT(J),I), J=1,NVAR)
         END IF
      END DO
      CLOSE (13)
      IF (XYZ .EQ. ' ' .OR. XYZ .EQ. 'N') GOTO 700
C
C.....MAC-Format schreiben
  791 CONTINUE
      OPEN (13, FILE=FOUT, STATUS ='OLD')
      OPEN (14, FILE=FOUT, RECL=IREC,
     *              CARRIAGECONTROL='LIST', STATUS='NEW')
      EXCELH = ' '
      MAC    = ' '
  792 CONTINUE
      READ (13,'(A)', END = 795) EXCELH
C
C.....Leerzeichen durch TAB ersetzen
      ITAB = 1
      IMAC = 0
      LSTRING = NZEICH(EXCELH)
      DO I = 1, LSTRING
         IF (EXCELH(I:I) .EQ. ' ') THEN
            IF (ITAB .EQ. 0) THEN
               IMAC = IMAC + 1
               MAC(IMAC:IMAC) = '	'
               ITAB = 1
            END IF
         ELSE
            IMAC = IMAC + 1
            MAC (IMAC:IMAC) = EXCELH(I:I)
C
C.....Punkte durch Komma ersetzen
            IF (XYZ .EQ. 'K') THEN
               IF (MAC(IMAC:IMAC) .EQ. '.') MAC(IMAC:IMAC) = ','
            END IF
            ITAB = 0
         END IF
      END DO
      WRITE (14,'(A)') MAC(:IMAC)
      GOTO 792
C
  795 CONTINUE
      CLOSE (13, STATUS='DELETE')
      CLOSE (14)
      WRITE (6,'(/,2A)') ' Daten stehen in ', FOUT
54321 END