      SUBROUTINE READM (A,N,M,N1,M1)   !  4-1
C
      PARAMETER (NPRO=1600)    ! N1  Proben
      PARAMETER (NPAR=400)     ! M1  Variablen
      REAL      A(N1,M1), FELD(NPAR,NPRO), TIEF(25,NPRO)
      INTEGER   KPT, PARI, ANTI(25), KEN(NPAR)
      CHARACTER JN*1, CLS*30
      COMMON    / FE / FELD, TIEF, KPT, KEN, ANTI
      COMMON    / LU / LUW, IP1, IP2
C
      K1 = 1
      M  = M1
      MZ = M1
      INC = 0
      IF (M1 .GT. 2) THEN
         WRITE (6,'(/A)')   '$Anzahl Parameter         -> '
         READ  (5,'(I4)') M
         MZ = M - 1
         WRITE (6,'(A)')    '$folgende Parameter ? [N] -> '
         READ  (5,'(A)') JN
         IF (JN .EQ. 'J') THEN
            WRITE (6,'(A)') '$erste  Kennung           -> '
            READ  (5,*) K1
            MZ = K1 + M - 1
         END IF
      END IF
C
C.....Bestimmung der zu berechnenden Parameter
      DO I = K1, MZ
         INC = INC + 1
C
C........automatische Bestimmung der Kennungen
         IF (JN .EQ. 'J') THEN
            PARI = I
            GOTO 77
         END IF           
C
C........Eingabe der Kennungen von Hand
         IF (M .NE. 1) WRITE (6,'(/,A,I3,A)') '$', I, '.  Parameter'
         CALL PAR(PARI)
         IF (PARI .EQ. 0) THEN     ! geh nach Hause
            M = 0
            GOTO 100
         END IF
         IF (M .EQ. 2 .AND. INC .EQ. 1) IP1 = PARI
         IF (M .EQ. 2 .AND. INC .EQ. 2) IP2 = PARI
C
C........Datenuebergabe an Feld A
   77    CONTINUE
         DO K = 1, ANTI(KEN(PARI))
            A(K,INC) = FELD(PARI,K)
         END DO
      END DO
C
      KPT = KEN(PARI)
      N = ANTI(KEN(PARI))
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
      WRITE (6,'(/A)') ' SEDAN is busy ...'
  100 CONTINUE
      END
C******************************************************************************
      SUBROUTINE PRINTM (A,N,M,N1,M1)   !  4-2
C
      DIMENSION A(N1,M1)                           ! N Zeilen, M Spalten
      COMMON    / LU / LUW
C     PRINT MATRIX OUT IN STRIPS OF 10 COLUMNS
      DO 100 IB=1,M,10
         IE = IB+9
         IF (IE-M) 2,2,1
    1    IE = M
C.....print heading
    2    WRITE (LUW,'(1X,10I12)') (I,I=IB,IE)
         DO 101 J=1,N
C.....write row of matrix
            WRITE (LUW,'(I5,10F12.4)') J,(A(J,K), K=IB, IE)
  101    CONTINUE
  100 CONTINUE
      WRITE (LUW,'(/)') 
      END
C******************************************************************************
      SUBROUTINE MINV(A,B,N,N1,DET)   !  4-8
C
      DIMENSION A(N1,N1),B(N1,N1)
C
      DO 100 I=1,N
         DO 101 J=1,N
            B(I,J)=0.0
  101    CONTINUE
         B(I,I)=1.0
  100 CONTINUE
      DET=1.0
C
      DO 102 I=1,N
         DIV=A(I,I)
         DET=DET*DIV
         DO 103 J=1,N
            A(I,J)=A(I,J)/DIV
            B(I,J)=B(I,J)/DIV
  103    CONTINUE
         DO 104 J=1,N
            IF (I-J) 1,104,1
    1       RATIO=A(J,I)
            DO 105 K=1,N
               A(J,K)=A(J,K)-RATIO*A(I,K)
               B(J,K)=B(J,K)-RATIO*B(I,K)
  105       CONTINUE
  104    CONTINUE
  102 CONTINUE
      END
C******************************************************************************
       SUBROUTINE MMULT(A,B,C,L,N,M,NA,MA,NB,MB,NC,MC)   !  4-7
C
       DIMENSION A(NA,MA),B(NB,MB),C(NC,MC)
       DO 100 I=1,L
          DO 101 J=1,M
             C(I,J)=0.0
             DO 102 K=1,N
                C(I,J)=C(I,J)+A(I,K)*B(K,J)
  102        CONTINUE
  101     CONTINUE 
  100  CONTINUE
       END
C******************************************************************************
       SUBROUTINE SUBM(A,B,C,N,M,N1,M1)   !  4-4
C
       DIMENSION A(N1,M1),B(N1,M1),C(N1,M1)
       DO 100 I=1,N       
          DO 101 J=1,M
             C(I,J)=A(I,J)-B(I,J)
  101     CONTINUE
  100  CONTINUE
       END
C******************************************************************************
      SUBROUTINE VARI   !  3-2
      COMMON    / LU / LUW
C
      REAL XX(400)
      PARAMETER (NPRO = 1600)
      CALL READM(XX,NS,ND,NPRO,1)
      IF (ND .EQ. 0) GOTO 9999
      DO 100 I=1,NS
         SUMX=SUMX+XX(I)
         SUMX2=SUMX2+XX(I)*XX(I)
  100 CONTINUE
C
C.....compute variance
      VAR=(FLOAT(NS)*SUMX2-SUMX*SUMX)/FLOAT(NS*(NS-1))
C
C.....print results
      WRITE (LUW,2000) NS,SUMX,SUMX2,VAR
 2000 FORMAT (9X,20HNUMBER OF SAMPLES = ,I10,/,
     112 X,17HSUM OF SAMPLES = ,F10.3,/, 
     229H SUM OF SQUARES OF SAMPLES = ,F10.3,/,
     37X,22HVARIANCE OF SAMPLES = ,F10.3)
C
C.....compute standard deviation and mean
      STDEV=SQRT(VAR)
      AMEAN=SUMX/FLOAT(NS)
C
C.....print standard deviation and mean
      WRITE (LUW,2001) STDEV,AMEAN
 2001 FORMAT (/,8X,21HSTANDARD DEVIATION = ,F10.3,/,
     111X,18HMEAN OF SAMPLES = ,F10.3)
 9999 END
C******************************************************************************
      SUBROUTINE BICOR      ! 3-4
C
      COMMON    / LU / LUW
      REAL XX(400,2)
C
      CALL READM(XX,NS,NV,350,2)
      IF (NV .EQ. 0) GOTO 9999
      DO 100 I = 1, NS
         SUMX1=SUMX1+XX(I,1)
         SUMX2=SUMX2+XX(I,2)
         SX1SQ=SX1SQ+XX(I,1)*XX(I,1)
         SX2SQ=SX2SQ+XX(I,2)*XX(I,2)
         SX1X2=SX1X2+XX(I,1)*XX(I,2)
  100 CONTINUE
C
C.....print sums
      WRITE (LUW,2000) NS, SUMX1, SX1SQ, SUMX2, SX2SQ, SX1X2
 2000 FORMAT (12X,21H NUMBER OF SAMPLES = ,I10,/,
     121X,12HSUM OF X1 = ,F10.2,/,
     210X,23HSUM OF SQUARES OF X1 = ,F10.2,/,
     321X,12HSUM OF X2 = ,F10.2,/,
     410X,23HSUM OF SQUARES OF X2 = ,F10.2,/,
     5 9X, 24HSUM OF CROSS PRODUCTS = ,F10.2)
C
C.....compute and print mean, variance and standard deviation of X1
      AMEAN=SUMX1/FLOAT(NS)
      VAR=(FLOAT(NS)*SX1SQ-SUMX1*SUMX1)/FLOAT(NS*(NS-1))
      STDEV1=SQRT(VAR)
      WRITE(LUW,2001)AMEAN, VAR, STDEV1
 2001 FORMAT (/,20X,13HMEAN OF X1 = ,F10.2,/,
     116X,17HVARIANCE OF X1 = ,F10.2,/,
     2 6X,27HSTANDARD DEVIATION OF X1 = ,F10.2)
C
C.....compute and print mean, variance and standard deviation of X2
      AMEAN=SUMX2/FLOAT(NS)
      VAR=(FLOAT(NS)*SX2SQ-SUMX2*SUMX2)/FLOAT(NS*(NS-1))
      STDEV2=SQRT(VAR)
      WRITE (LUW,2002) AMEAN, VAR, STDEV2
 2002 FORMAT (/,20X,13HMEAN OF X2 = ,F10.2,/,
     116X,17HVARIANCE OF X2 = ,F10.2,/,
     2 6X,27HSTANDARD DEVIATION OF X2 = ,F10.2)
C
C.....compute and print covariance between X1 and X2
      COV=(FLOAT(NS)*SX1X2-SUMX1*SUMX2)/FLOAT(NS*(NS-1))
      WRITE (LUW,2003) COV
 2003 FORMAT (/,2X,31HCOVARIANCE BETWEEN X1 AND X2 = ,F10.2)
C
C.....compute and print correlation between X1 and X2 
      COR=COV/(STDEV1*STDEV2)
      WRITE (LUW,2004) COR
 2004 FORMAT (/,1X,32HCORRELATION BETWEEN X1 AND X2 = ,F10.4)
 9999 END              
C******************************************************************************
      SUBROUTINE SLE(A,B,N,N1,ZERO)    ! 4-9
C
      DIMENSION A(N1,N1), B(N1)
      COMMON    / LU / LUW
      DO 100 I=1,N
      DIV=A(I,I)
      IF (ABS(DIV)-ZERO) 9999,9999,1
    1 DO 101 J=1,N
      A(I,J)=A(I,J)/DIV
  101 CONTINUE
      B(I)=B(I)/DIV
      DO 102 J=1,N
      IF (I-J) 2,102,2
    2 RATIO=A(J,I)
      DO 103 K=1,N
      A(J,K)=A(J,K)-RATIO*A(I,K)
  103 CONTINUE
      B(J)=B(J)-RATIO*B(I)
  102 CONTINUE
  100 CONTINUE
 9999 END      
C******************************************************************************
      SUBROUTINE EQSPL   ! 5-1
C
      PARAMETER (NPRO = 1600)
      DIMENSION XIN(NPRO,2),XOUT(NPRO*10,2)
      COMMON    / LU / LUW
C
      CALL READM(XIN,NIN,M,NPRO,2)
      IF (M .EQ. 0) GOTO 9999
      CALL PRINTM(XIN,NIN,M,INS,2)
      WRITE(LUW,1001)
C
      WRITE (6,'(/,A)') '$INITIAL POINT ==> '
      READ  (5,*) XB
      WRITE (6,'(/,A)') '$UNITS         ==> '
      READ  (5,*) XI
      WRITE (6,'(/,A)') '$FINAL POINT   ==> '
      READ  (5,*) XL
C   
      IS=0
      JS=1
      X=XB-XI
    1 X=X+XI
C 
      IF (X-XL) 2,2,99
    2 IS=IS+1
      XOUT(IS,1)=X
C     
      IF(X-XIN(1,1))3,3,4
    3 XOUT(IS,2)=XIN(1,2)
      GO TO 1
C
    4 IF (X-XIN(NIN,1))6,5,5
    5 XOUT(IS,2)=XIN(NIN,2)
      GO TO 1
C
    6 IF(X-XIN(JS,1))9,8,7
    7 IF(X-XIN(JS+1,1))8,8,9
    8 XOUT(IS,2)=XIN(JS,2)+(XIN(JS+1,2)-XIN(JS,2))*
     1 (X-XIN(JS,1))/(XIN(JS+1,1)-XIN(JS,1))
      GO TO 1
    9 JS=JS+1
      IF (JS-NIN)6,10,10
   10 JS=JS-1
      GO TO 5
C
   99 CALL PRINTM(XOUT,IS,M,NPRO,2)
      WRITE (LUW,1002)
 1001 FORMAT(/' READING INPUT DATA SEQUENCE')
 1002 FORMAT(/' EQUALLY SPACED DATA POINTS')
 9999 END    
C******************************************************************************
      SUBROUTINE EQSPR   !  5-2
C
      PARAMETER (NPRO = 1600)
      DIMENSION XIN(NPRO,2),XOUT(NPRO*10,2)
      COMMON    / LU / LUW
C
      CALL READM(XIN,NIN,M,NPRO,2)
      IF (M .EQ. 0) GOTO 9999
      WRITE (LUW,1001)
      CALL PRINTM(XIN,NIN,M,NPRO*10,2)
C
      WRITE (6,'(/,A)') '$INITIAL POINT ==> '
      READ  (5,*) XB
      WRITE (6,'(/,A)') '$UNITS         ==> '
      READ  (5,*) XI
      WRITE (6,'(/,A)') '$FINAL POINT   ==> '
      READ  (5,*) XL
      XXB=XB
C
      XXE=XB+XI
      IG=1
      IS=0
      SL=0.0
      DO 100 I=1,NIN
      IF (I-NIN)1,45,45
    1 DX=XIN(I+1,1)-XIN(1,1)
      GO TO (11,12,13),IG
C
   11 IF(XIN(1,1)-XXB) 7,8,3
    3 IF (XIN(1,1)-XXB)6,6,4
    4 IF (XIN(1,1)-XXE)6,5,5
C
    5 IS=IS+1
      XOUT(IS,1)=XXB
      XOUT(IS,2)=0.0
      XXB=XXE
      XXE=XXE+XI
      IF(XXB-XL)3,3,99
C
    6 XXB=XIN(1,1)
      IG=3
      GO TO 13
C 
    7 IG=2
   12 IF(XIN(I+1,1)-XXB)100,8,8
    8 IG=3 
      DX=XIN(I+1,1)-XXB
C
   13 IF((XXB+DX)-XXE)25,21,21
C     
   21 DIF=XXE-XXB
      XXB=XXE
      SL=SL+DIF*XIN(I,2)
      SL=SL/XI
      IS=IS+1
      XOUT(IS,1)=XXE-XI
      XOUT(IS,2)=SL
      DX=DX-DIF
      SL=0.0
      XXE=XXE+XI
      IF((XXE-XI)-XL)13,13,99
C
   25 SL=SL+DX*XIN(1,2)
      XXB=XXB+DX
      GO TO 100
C
   45 DX=1.0E 15
      GO TO 13 
  100 CONTINUE
   99 CONTINUE
      CALL PRINTM(XOUT,IS,M,NPRO,2)
 1001 FORMAT(/,' INPUT DATA SEQUENCE')
 1002 FORMAT(/,' EQUALLY SPACED DATA POINTS')
 9999 END    
C******************************************************************************
      SUBROUTINE LINFIT   !  3-5
C     
      PARAMETER (NPRO = 1600)
      DIMENSION A(NPRO,2),B(2,2),C(2),D(NPRO,4)
      COMMON    / LU / LUW
C
      CALL READM (A,N,M,NPRO,2)
      IF (M .EQ. 0) GOTO 9999
      CALL PRINTM(A,N,M,NPRO,2)
C
      DO 100 I=1,2
      C(I) = 0.0
      DO 101 J=1,2
      B(I,J)=0.0
  101 CONTINUE
  100 CONTINUE
      DO 102 I=1,N
      B(1,1)=B(1,1)+1.0
      B(1,2)=B(1,2)+A(I,1)
      B(2,2)=B(2,2)+A(I,1)*A(I,1)
      C(1)=C(1)+A(I,2)
      C(2)=C(2)+A(I,1)*A(I,2)
  102 CONTINUE
      B(2,1)=B(1,2)
C
      CALL  PRINTM(B,2,2,2,2)
      WRITE (LUW,1001)
      CALL  PRINTM(C,1,2,1,2)
      WRITE (LUW,1002) 
      CALL  SLE(B,C,2,2,1.0E-05)
      CALL  PRINTM(C,1,2,1,2,)
      WRITE (LUW,1003)
      DO 103 I=1,N    
      D(I,1)=A(I,1)
      D(I,2)=A(I,2)
      D(I,3)=C(1)+C(2)*D(I,1)
      D(I,4)=D(I,2)-D(I,3)
  103 CONTINUE
      CALL PRINTM(D,N,4,NPRO,4)
      WRITE (LUW,1004)
C
C...  CALCULATE ERROR MEASURES
C
      SY=0.0
      SY2=0.0
      SYC=0.0
      SYC2=0.0
      DO 104 I=1,N
      SY=SY+D(I,2)
      SY2=SY2+D(I,2)*D(I,2)
      SYC=SYC+D(I,3)
      SYC2=SYC2+D(I,3)*D(I,3)
  104 CONTINUE
      SST=SY2-SY*SY/FLOAT(N) 
      SSR=SYC2-SYC*SYC/FLOAT(N)        
      SSD=SST-SSR
      R2=SSR/SST
      R=SQRT(R2)
      WRITE (LUW,2000) N
      WRITE (LUW,2001) SST
      WRITE (LUW,2002) SSR
      WRITE (LUW,2003) SSD
      WRITE (LUW,2004) R2
      WRITE (LUW,2005) R
      IC1 = NINT(C(1)*100)
      IC2 = NINT(C(2)*100)
ccc      CALL INTCHA(IC1,CC1)
ccc      CALL INTCHA(IC2,CC2)
ccc      WRITE (LUW, '(5A)')
ccc     * ' REGRESSION EQUATION :  Y = ', CC1, '+', CC2, 'X'
 1001 FORMAT (/' COEF. MATRIX OF UNKNOWN PARAMETERS IN NORMAL EQNS')
 1002 FORMAT(' VECTOR OF CROSSPRODUCTS OF X AND Y')
 1003 FORMAT(' PARAMETERS OF THE REGRESSION EQUATION')   
 1004 FORMAT(' COL 1=X VARIABLE' /' COL 2=Y VARIABLE' /
     1' COL 3=Y VALUE BASED ON REGRESSION EQN' /' COL 4=COL 2-COL 3')
 2000 FORMAT (21HONUMBER OF SAMPLES = ,I5)
 2001 FORMAT (25HOTOTAL SUMS OF SQUARES = ,F15.4)
 2002 FORMAT (37HOSUMS OF SQUARES DUE TO REGRESSION = ,F15.4)
 2003 FORMAT (36HOSUMS OF SQUARES DUE TO DEVIATION = ,F15.4)
 2004 FORMAT (19HOGOODNESS OF FIT = ,F15.6)
 2005 FORMAT (27HOCORRELATION COEFFICIENT = ,F15.6) 
 9999 END  
C******************************************************************************
      SUBROUTINE INTCHA (I, CH)
C
      CHARACTER*1 C1, C2, C3, C4, CH*4, C(0:9)*1
      DATA C / '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' /
C
      I1 = I/1000
      I2 = I/100-I1*10
      I3 = I/10-I1*100-I2*10
      I4 = I-I1*1000-I2*100-I3*10
      C1 = C(I1)
      C2 = C(I2)
      C3 = C(I3)
      C4 = C(I4)
      CH  = C1//C2//C3//C4
      IF (C1 .EQ. '0') CH = C2//C3//C4
      IF (C1 .EQ. '0' .AND. C2 .EQ. '0') CH = C3//C4
      IF (C1 .EQ. '0' .AND. C2 .EQ. '0' .AND. C3 .EQ. '0') CH = C4
 9999 END
C******************************************************************************
      SUBROUTINE PLOTER (X1,N1,N3,X2,N2,N4)   !  5-4
C     
      DIMENSION X1(N3,2),X2(N4,2)
      DIMENSION IOUT(101),XX(11)
      DATA IBLNK,II,IPLUS,IXI,IMINUS,ISTAR,IO
     1 /' ','I','+','X','-','*','O'/
      COMMON    / LU / LUW
C     
      XMIN=X1(1,1)
      XMAX=XMIN
      YMIN=X1(1,2)
      YMAX=YMIN
      DO 100 I=1,N1
      IF (X1(I,1) .LT. XMIN) XMIN=X1(I,1)
      IF (X1(I,1) .GT. XMAX) XMAX=X1(I,1)
      IF (X1(I,2) .LT. YMIN) YMIN=X1(I,2)
      IF (X1(I,2) .GT. YMAX) YMAX=X1(I,2)
  100 CONTINUE
      IF (N2 . LE. 0) GO TO 1
      DO 101 I=1,N2
      IF (X2(I,1) .LT. XMIN) XMIN=X2(I,1)
      IF (X2(I,1) .GT. XMAX) XMAX=X2(I,1)
      IF (X2(I,2) .LT. YMIN) YMIN=X2(I,2)
      IF (X2(I,2) .GT. YMAX) YMAX=X2(I,2)
  101 CONTINUE
    1 DX=(XMAX-XMIN)/100.
      DY=(YMAX-YMIN)/60.
C
      Y=YMAX
      DO 102 I=1,61
      IF (MOD(I-1,6) .EQ. 0) GO TO 2
      DO 103 J=1,101
      IOUT(J)=IBLNK
      IF (MOD(J-1,10) .EQ. 0) IOUT(J)=II
  103 CONTINUE
      GO TO 3
    2 DO 104 J=1,101
      IOUT(J)=IMINUS
      IF (MOD(J-1,10) .EQ. 0) IOUT(J)=IPLUS
  104 CONTINUE
C
C...  PLOT DATA SET ONE
C
    3 DO 105 J=1,N1
      IY=IFIX((X1(J,2)-YMIN)/DY+0.005)+1
      IF ((62-I) .NE. IY) GO TO 105
      IX=IFIX((X1(J,1)-XMIN)/DX+0.005)+1
      IOUT(IX)=ISTAR
  105 CONTINUE
C
C...  PLOT DATA SET TWO
C
      IF (N2 .LE. 0) GO TO 10
      DO 106 J=1,N2
      IY=IFIX((X2(J,2)-YMIN)/DY+0.005)+1
      IF((62-I) .NE. IY) GO TO 106
      IX=IFIX((X2(J,1)-XMIN)/DX+0.005)+1
      IF (IX .GT. 100) IX=100
      IF (IOUT(IX) .EQ. IO) GO TO 106
      IF (IOUT(IX) .EQ. ISTAR) GO TO 4
      IOUT(IX)=IXI
      GO TO 106
    4 IOUT(IX)=IO
  106 CONTINUE
C
C...  PRINT LINE OF PLOT
C
   10 IF (MOD(I-1,6) .NE. 0) GO TO 11
      WRITE (LUW,1001) Y,IOUT
      Y=Y-6.0*DY
      GO TO 102
   11 WRITE (LUW,1002) IOUT
  102 CONTINUE
C
C...  PRINT LEGEND ACROSS BOTTOM OF GRAPH
C
      XXX=XMIN
      DO 110 I=1,11
      XX(I)=XXX
      XXX=XXX+10.0*DX
  110 CONTINUE
      WRITE (LUW,1003) (XX(I),I=1,11,2)
      WRITE (LUW,1004) (XX(I),I=2,10,2)
 1001 FORMAT (1X,F10.5,1X,101A1)
 1002 FORMAT (12X,101A1)
 1003 FORMAT (8X,6(F10.5,10X))
 1004 FORMAT (18X,5(F10.5,10X))
 9999 END
C******************************************************************************
      SUBROUTINE POLYD   !  5-5
C
      PARAMETER (NPRO = 1600)
      DIMENSION A(NPRO,2), B(20,20), C(20), D(NPRO,4), E(NPRO+1,2)
      DIMENSION XP(20)
      COMMON    / LU / LUW
C
      WRITE (6, '(/,A)') '$Regression wievielter Ordnung ? '
      READ (5,1000) IORD
      IORD1=IORD + 1
C
      CALL READM(A,N,M,NPRO,2)
      IF (M .EQ. 0) GOTO 9999
      CALL PRINTM(A,N,M,NPRO,2)
      IF (LUW .NE. 117) WRITE (LUW, 1985)
C
      DO 100 I=1,IORD1
      C(I)=0.0
      DO 101 J=1,IORD1
      B(I,J)=0.0
  101 CONTINUE
  100 CONTINUE
      DO 102 I=1,N
         XP(1)=1.0
      DO 103 J=2,IORD1
         XP(J)=XP(J-1)*A(I,1)
  103 CONTINUE
      DO 104 J=1,IORD1
      DO 105 K=1,IORD1
         B(J,K)=B(J,K)+XP(J)*XP(K)
  105 CONTINUE   
      C(J)=C(J)+XP(J)*A(I,2)
  104 CONTINUE
  102 CONTINUE
C
      IF (LUW .NE. 117) CALL PRINTM(B,IORD1,IORD1,20,20)
      IF (LUW .NE. 117) WRITE (LUW,1001)
      CALL SLE(B,C,IORD1,20,1.0E-06)
      IF (LUW .NE. 117) CALL PRINTM (C,1,IORD1,1,20)              
      IF (LUW .NE. 117) WRITE (LUW,1003)
C
C...  CALCULATE PREDICTED VALUES
C
      DO 106 I=1,N
      D(I,1)=A(I,1)
      D(I,2)=A(I,2)
      XXP=1.0
      YYP=0.0
      DO 107 J=1,IORD1
         YYP=YYP+XXP*C(J)
         XXP=XXP*D(I,1)
  107 CONTINUE
      D(I,3)=YYP
      D(I,4)=D(I,2)-YYP
 106  CONTINUE
      IF (LUW .NE. 117) CALL PRINTM(D,N,4,NPRO,4)
      IF (LUW .NE. 117) WRITE (LUW,1004)
C
C...  CALCULATE ERROR MEASURES
      SY=0.0
      SY2=0.0
      SYC=0.0
      SYC2=0.0
      DO 108 I=1,N
      SY=SY+D(I,2)
      SY2=SY2+D(I,2)*D(I,2)
      SYC=SYC+D(I,3)
      SYC2=SYC2+D(I,3)*D(I,3)
  108 CONTINUE
C
C...  CALCULATE POINTS EQUALLY SPACED ALONG REGRESSION LINE
      XMIN=A(1,1)
      XMAX=XMIN
      DO 109 I=1,N
         IF (A(I,1) .LT. XMIN) XMIN=A(I,1)
         IF (A(I,1) .GT. XMAX) XMAX=A(I,1)
  109 CONTINUE
C
      X=XMIN
      DX=(XMAX-XMIN)/100.0
      DO 110 I=1,101
         XXP=1.0
         YYP=0.0
         DO 111 J=1,IORD1
            YYP=YYP+XXP*C(J)    
            XXP=XXP*X
  111    CONTINUE
         E(I,1)=X
         E(I,2)=YYP
         IF (LUW .EQ. 117) WRITE (LUW,'(X,2F10.6)') X, YYP
         X=X+DX
  110 CONTINUE
C
      IF (LUW .NE. 117) CALL PLOTER(A,N,NPRO,E,NPRO+1,NPRO+1)
C
      SST=SY2-SY*SY/FLOAT(N)
      SSR=SYC2-SYC*SYC/FLOAT(N)
      SSD=SST-SSR
      R2=SSR/SST
      R=SQRT(R2)  
      IF (LUW .NE. 117) THEN
         WRITE(LUW,1995) IORD
         WRITE(LUW,2000) N
         WRITE(LUW,2001) SST
         WRITE(LUW,2002) SSR
         WRITE(LUW,2003) SSD
         WRITE(LUW,2004) R2
         WRITE(LUW,2005) R
      ELSE
         WRITE(LUW,'(X,A,F4.2)') 'r = ', R
      END IF
      CLOSE (LUW)
 1000 FORMAT (I2)
 1001 FORMAT(' COEF. MATRIX OF UNKNOWN PARAMETERS IN NORMAL EQNS') 
 1002 FORMAT(' VECTOR OF CROSSPRODUCTS OF X AND Y')
 1003 FORMAT(' THE PARAMETERS OF THE REGRESSION EQUATION')
 1004 FORMAT(' COL 1 = X VARIABLE'/' COL 2 = Y VARIABLE' /
     1' COL 3 = Y VALUE BASED ON REGRESSION EQUATION' /
     2' COL 4 = COL 2 - COL 3')
 1985 FORMAT(' ORIGINAL X AND Y DATA')
 1995 FORMAT (21HORDER OF EQUATION = ,I5)
 2000 FORMAT (21HNUMBER OF SAMPLES = ,I5)
 2001 FORMAT (25HTOTAL SUMS OF SQUARES = ,F15.4)
 2002 FORMAT (37HSUMS OF SQUARES DUE TO REGRESSION = ,F15.4)
 2003 FORMAT (36HSUMS OF SQUARES DUE TO DEVIATION = ,F15.4)
 2004 FORMAT (19HGOODNESS OF FIT = ,F15.6)
 2005 FORMAT (27HCORRELATION COEFFICIENT = ,F15.6)
 9999 END
C******************************************************************************
      SUBROUTINE SMOOTH   !  5-6
C
      PARAMETER (NPRO=1600)
      DIMENSION XIN(NPRO), XOUT(NPRO)
      COMMON    / LU / LUW
C
      WRITE(6,'(A)') '$ANZAHL GLEITENDER MITTELWERTE: '
      READ (5,1000) M
C
      CALL READM  (XIN,NN,NM,NPRO,1)
      IF (NM .EQ. 0) GOTO 9999
      CALL PRINTM (XIN,NM,1,NPRO,1)
      WRITE (LUW,2000)
      N=NN
      IE=N-M+1
      DO 100 I=1,IE
      SUM=0.0
      DO 101 J=1,M
      K=I+J-1
      SUM=SUM+XIN(K)
  101 CONTINUE
      XOUT(I)=SUM/FLOAT(M)
  100 CONTINUE
C     PRINT OUT THE SMOOTHED DATA SEQUENCE.
      CALL PRINTM(XOUT, IE,1,IP,1)
      WRITE (LUW,2001)
      SY=0.0
      SYY=0.0
      DO 102 I=1,N
      SY=SY+XIN(I)
      SYY=SYY+XIN(I)**2
  102 CONTINUE
      SYS=0.0
      SYYS=0.0
      SYC=0.0
      SYYC=0.0
      SSD=0.0
      DO 103 I=1,IE
      J=I+M/2
      SYS=SYS+XIN(J)
      SYYS=SYYS+XIN(J)**2
      SYC=SYC+XOUT(I)
      SYYD=SYYC+XOUT(I)**2
      SSD=SSD+(XIN(J)-XOUT(I))**2
  103 CONTINUE 
      SSO=SYY-SY*SY/FLOAT(N)
      SSOS=SYYS-SYS*SYS/FLOAT(IE)
      SSS=SYYC-SYC*SYC/FLOAT(IE)
      PSS=(SSS/SSOS)*100.0
      WRITE (LUW,1000)
      WRITE (LUW,1001) SSO
      WRITE (LUW,1002) SSOS
      WRITE (LUW,1003) SSS
      WRITE (LUW,1004) SSD
      WRITE (LUW,1005) PSS
 1000 FORMAT (I2)
 1001 FORMAT (36H1SUMS OF SQUARES OF ORIGINAL DATA = ,F20.8)
 1002 FORMAT (37HOSUMS OF SQUARES OF TRUNCATED DATA = ,F20.8)
 1003 FORMAT (36HOSUMS OF SQUARES OF SMOOTHED DATA = ,F20.8)
 1004 FORMAT (36HOSUMS OF SQUARES DUE TO DEVIATION = ,F20.8)
 1005 FORMAT (22HO% GOODNESS OF FIT = ,F20.8)
 2000 FORMAT (/' INPUT DATA SEQUENCE')
 2001 FORMAT (/' SMOOTHED DATA SEQUENCE')
 9999 END
C****************************************************************************** 
      SUBROUTINE TSPLOT(X,N,ITYPE)   !  5-7
C
      DIMENSION X(1),IOUT(61),XX(13)
      DATA II,ISTAR,IBLNK/'I','*',' '/
      COMMON    / LU / LUW
C
      IF (ITYPE .NE. 1) GO TO 11
      XMIN=-1.0
      XMAX=+1.0
      GO TO 12
  11  XMIN=X(1)
      XMIN=XMAX
      DO 100 I=1,N
      IF (X(I) .LT. XMIN) XMIN=X(I)
      IF (X(I) .GT. XMAX) XMAX=X(I)
 100  CONTINUE
      IF (ITYPE  .NE. 3) GO TO 12
      XMIN=ALOG10(XMIN)
      XMAX=ALOG10(XMAX)
  12  DX=XMAX-XMIN
      XXX=XMIN
      DO 101 I=1,13
      XX(I)=XXX
      IF (ITYPE .EQ. 3) XX(I)=10.0**XXX
      XXX=XXX+DX/12.0
 101  CONTINUE
      WRITE (LUW,2000) (XX(I),I=2,12,2)
      WRITE (LUW,2001) (XX(I),I=1,13,2)
      WRITE (LUW,2002)
      DO 102 I=1,N
      DO 103 J=1,61
      IOUT(J)=IBLNK
 103  CONTINUE
      DO 104 J=1,61,10
      IOUT(J)=II
 104  CONTINUE
      XXX=X(I)
      IF (ITYPE .EQ. 3) XXX=ALOG10(XXX)
      IX=IFIX((XXX-XMIN)*60.0/DX)+1
      IOUT(IX)=ISTAR
      WRITE (LUW,2003) X(I),IOUT
 102  CONTINUE
      WRITE (LUW,2002)
      WRITE (LUW,2001) (XX(I),I=1,13,2)
      WRITE (LUW,2000) (XX(I),I=2,12,2)
 2000 FORMAT (11X,6F10.4)
 2001 FORMAT (6X,7F10.4)
 2002 FORMAT (11X,'+',12('----+'))
 2003 FORMAT (1X,F10.4,61A1)
 9999 END
C******************************************************************************
      SUBROUTINE AUTOCR   !  5-8
C
      DIMENSION XIN(500),XOUT(250)
      COMMON    / LU / LUW
C
      CALL READM(XIN,NIN,N1,500,1)
      IF (N1 .EQ. 0) GOTO 9999
      CALL PRINTM(XIN,NIN,N1,500,1)
      WRITE (LUW,2002)
      CALL TSPLOT(XIN,NIN,2)
      WRITE (LUW,1000)
      WRITE (LUW,2000)
C
      AN=NIN
      SY=0.0
      SYY=0.0
      DO 100 I=1,NIN
      SY=SY+XIN(I)
      SYY=SYY+XIN(I)**2
 100  CONTINUE
      VY=(AN*SYY-SY*SY)/(AN*(AN-1.0))
C
      NOT=NIN/4+1
      DO 101 I=1,NOT
      SX=0.0
      SY=0.0
      SXY=0.0
      L=NIN-I+1
      DO 102 J=1,L
      K=J+I-1
      SX=SX+XIN(J)
      SY=SY+XIN(K)
      SXY=SXY+XIN(J)*XIN(K)
 102  CONTINUE
      AL=L
      R=((AL*SXY-SX*SY)/(AL*(AL-1.0)))/VY
      XOUT(I)=R
      I1=I-1
      I2=1
      WRITE (LUW,2001) I1,I2,L,I,NIN,R
      WRITE (LUW,'(//)')
 101  CONTINUE
      CALL TSPLOT(XOUT,NOT,1)
      WRITE (LUW,1001)
2000  FORMAT(8X,'LAG',10X,'TERMS THAT ARE BEING CORRELATED',4X,
     1 'AUTOCORRELATION'/,6X,'POSITION',6X,'FIRST SET',11X,'SECOND SET'
     2 10X,'COEFFICIENT')
2001  FORMAT(1X,5I10,F15.6)
1000  FORMAT(/' PLOT OF INPUT DATA SEQUENCE'//)
1001  FORMAT(/' PLOT OF AUTOCORRELATION COEFFICIENTS')
2002  FORMAT(' INPUT DATA SEQUENCE'//)
9999  END
C******************************************************************************
      SUBROUTINE CROSCR   ! 5-9
C
      DIMENSION XIN1(500),XIN2(500),XOUT(1000)
      COMMON    / LU / LUW
      CALL READM(XIN1,NIN1,MN,500,1)
      IF (MN .EQ. 0) GOTO 9999
      CALL PRINTM(XIN1,NIN1,MN,500,1)
      WRITE (LUW,2002)
      CALL TSPLOT(XIN1,NIN1,2)
      WRITE (LUW,2004)
      CALL READM(XIN2,NIN2,MN,500,1)
      IF (MN .EQ. 0) GOTO 9999
      CALL PRINTM(XIN2,NIN2,MN,500,1)
      WRITE (LUW,2003)
      CALL TSPLOT(XIN2,NIN2,2)
      WRITE (LUW,2005)
      WRITE (LUW,2000)
      NOT=NIN1+NIN2-5
      IB1=1
      IE1=3
      IB2=NIN2-2
      IE2=NIN2
      LEN1=3
      DO 100 I=1,NOT
      SX=0.0
      SY=0.0
      SXY=0.0
      SXX=0.0
      SYY=0.0
      DO 101 J=1,LEN1
      J1=IB1+J-1
      J2=IB2+J-1
      SX=SX+XIN1(J1)
      SY=SY+XIN2(J2)
      SXY=SXY+XIN1(J1)*XIN2(J2)
      SXX=SXX+XIN1(J1)**2
      SYY=SYY+XIN2(J2)**2
 101  CONTINUE
      AN=LEN1
      R=(AN*SXY-SX*SY)/SQRT((AN*SXX-SX*SX)*(AN*SYY-SY*SY))
      T=R*SQRT((AN-2.0)/(1.0-R*R))
      XOUT(I)=R
      WRITE (LUW,2001) I,IB1,IE1,IB2,IE2,LEN1,R,T
      IE1=IE1+1
      IF (IE1-NIN1) 2,2,1
   1  IB1=IB1+1
      IE1=NIN1
   2  IB2=IB2-1
      IF (IB2) 3,3,4
   3  IB2=1
      IE2=IE2-1
   4  LEN1=IE1-IB1+1
      LEN2=IE2-IB2+1
      IF (LEN1-LEN2) 5,100,6
   5  IB1=1
      IE2=IE2-1
      GO TO 4
   6  IB1=IB1+1
      IE2=NIN2
      GO TO 4
 100  CONTINUE
      CALL TSPLOT(XOUT,NOT,1)
      WRITE (LUW,2006)
2000  FORMAT(14X,'TERMS WHICH ARE MATCHED',7X,'NUMBER'/
     1 4X,'MATCH',8X,'FIRST',9X,'SECOND',6X,'OF TERMS',
     2 3X,'CORRELATION',7X,'T'/3X,'POSITION',4X,'DATA SET',6X,
     3 2X,'DATA SET',6X'MATCHED',2X,'COEFFICIENT',5X,'VALUE'/)
2001  FORMAT(1X,6I8,2F14.6)
2002  FORMAT(/' FIRST INPUT DATA SEQUENCE - XIN1')
2003  FORMAT(/' SECOND INPUT DATA SEQUENCE - XIN2')
2004  FORMAT(/' PLOT OF XIN1')
2005  FORMAT(/' PLOT OF XIN2')
2006  FORMAT(/' PLOT OF CROSSCORRELATION COEFFICIENTS')
9999  END
C******************************************************************************
C      SUBROUTINE XASSOC   !  5-10
C      COMMON    / LU / LUW
C
C******************************************************************************
      SUBROUTINE FOURER   !  5-11
C
      DIMENSION XIN(1000),XOUT(1000),XS(1000)
      COMMON    / LU / LUW
      NND = 1000
C
      CALL READM (XIN,NIN,MMM,NND,1)
      IF (MMM .EQ. 0) GOTO 9999
      CALL PRINTM(XIN,NIN,MMM,NND,1)
      WRITE (LUW,2001)
      CALL TSPLOT(XIN,NIN,2)
      WRITE (LUW,2002)
C
      CC=6.2831854/FLOAT(NIN)
      R=2.0/FLOAT(NIN)
      N2=NIN/2+1
C
      WRITE(LUW,2003)
      DO 100 I=1,N2
      SCN=0.0
      SSN=0.0
      DO 101 J=1,NIN
      ARG=FLOAT(I-1)*FLOAT(J-1)*CC
      SCN=SCN+XIN(J)*COS(ARG)
      SSN=SSN+XIN(J)*SIN(ARG)
  101 CONTINUE
      A=SCN*R
      IF (I .EQ. 1) A=A/2.0
      B=SSN*R
      XOUT(I)=S
      I1=I-1
      WRITE (LUW,2004)I1,A,B,S
      XOUT(I)=S
  100 CONTINUE
C
      N3=N2-2
      DO 102 I=1,N3
      XS(I)=XOUT(I)/4.0+XOUT(I+1)/2.0+XOUT(I+2)/4.0
  102 CONTINUE
      CALL TSPLOT(XS,N3,2)
      WRITE (LUW,2007)
      CALL TSPLOT(XS,N3,3)
      WRITE (LUW,2008)
      GOTO 9999
 2001 FORMAT(1HO,5X,'INPUT DATA MATRIX')
 2002 FORMAT(1HO,5X,'PLOT OF INPUT DATA')
 2003 FORMAT(4X,'HARMONIC',3X,'A COEF',7X,'B COEF',12X,'POWER'
     1/5X,'NUMBER',33X,'SPECTRUM')
 2004 FORMAT (1X,I6,3F15.5)
 2005 FORMAT(1HO,5X,'PLOT OF POWER SPECTRUM')
 2006 FORMAT(1HO,5X,'LOGRITHMIC PLOT OF POWER SPECTRUM')
 2007 FORMAT(1HO,5X,'PLOT OF SMOOTHED POWER SPECTRUM')
 2008 FORMAT(1HO,5X,'LOGRITHMIC PLOT OF SMOOTHED POWER SPECTRUM')
 9999 END
C******************************************************************************
      SUBROUTINE MULTR   !7.1
      DIMENSION X(100,20),D(100,3)       
      DIMENSION A(20,20),B(20)
      COMMON    / LU / LUW
      ND=100
      MD=20
      MM=20
C
      CALL READM(X,N,M,ND,MD)
      IF (M .EQ. 0) GOTO 9999
      CALL PRINTM(X,N,M,ND,MD)
      WRITE (LUW,2005)
C
      DO 100 I=1,M
      B(I)=0.0
      DO 100 J=1,M
      A(I,J)=0.0
  100 CONTINUE
C
      DO 101 I=1,N
      Y=X(I,1)
      X(I,1)=1.0
      DO 102 J=1,M
      DO 102 K=1,M
      A(J,K)=A(J,K)+X(I,J)*X(I,K)
  102 CONTINUE
      X(I,1)=Y
  101 CONTINUE
C
      CALL SLE (A,B,M,MM,1.0E-08)
C
      DO 103 I=1,N
      D(I,1)=X(I,1)
      D(I,2)=B(1)
      DO 104 J=2,M
      D(I,2)=D(I,2)+B(J)*X(I,J)
  104 CONTINUE
      D(I,3)=D(I,1)-D(I,2)
  103 CONTINUE
C
      CALL PRINTM(D,N,3,ND,3)
      WRITE (LUW,2006)
C
      CALL PRINTM(B,M,1,MM,1)
      WRITE (LUW,2007)
C
      SY=0.0
      SYY=0.0 
      SYC=0.0
      SYYC=0.0
      DO 105 I=1,N
      SY=SY+D(I,1)
      SYY=SYY+D(I,1)**2
      SYC=SYC+D(I,2)
      SYYC=SYYC+D(I,2)**2
  105 CONTINUE
      SST=SYY-SY*SY/FLOAT(N)
      SSR=SYYC-SYC*SYC/FLOAT(N)
      SSD=SST-SSR
      NDF1=M-1
      AMSR=SSR/FLOAT(NDF1)
      NDF2=N-M
      AMSD=SSD/FLOAT(NDF2)
      R2=SSR/SST
      R=SQRT(R2)
      F=AMSR/AMSD
      NDF3=N-1
C
      WRITE (LUW,2000)  
      WRITE (LUW,2001) SSR,NDF1,AMSR,F
      WRITE (LUW,2002) SSD,NDF2 AMSD
      WRITE (LUW,2003) SST,NDF3
      WRITE (LUW,2004) R2,R
      CALL EXIT
 2000 FORMAT (10H1SOURCE OF,13X,25HSUM OF  DEGREES OF   MEAN,/,
     110H VARIATION,13X,37HSQUARES   FREEDOM   SQUARES    F-TEST,/,
     2 1X,60(1H-))
 2001 FORMAT (11H REGRESSION,10X,F10.2,I8,2X,F10.2,/,51X,F10.4)
 2002 FORMAT (10H DEVIATION,11X,F10.2,I8,2X,F10.2)
 2003 FORMAT (16HOTOTAL VARIATION,5X,F10.2,I8)
 2004 FORMAT(' GOODNESS OF FIT = ',F10.4,/,
     1 '0CORRELATION COEFFICIENT = ',F10.4)
 2005 FORMAT (1HO,4X,'INPUT DATA MATRIX -',1X,
     1 'COLUMNS = VARIABLES, ROWS = OBSERVATIONS')
 2006 FORMAT (1HO,4X,'COLUMN 1 = Y, COLUMN 2 = ESTIMATED Y,',1X,
     1 'COLUMN 3 = DEVIATION')
 2007 FORMAT (1HO,4X,'REGRESSION COEFFICIENTS',3X,
     1 '1 = CONSTANT TERM')
 9999 END
C******************************************************************************
      SUBROUTINE RMULT   !  7-2  
C
      DIMENSION X(100,20),XM(100,10),D(100,3)
      DIMENSION A(20,20),B(20),C(20)
      COMMON    / LU / LUW
      ND=100
      MD=20
      MM=20
C
      CALL READM(X,N,M,ND,MD)
      IF (M .EQ. 0) GOTO 9999
      WRITE (LUW,2005)
      CALL PRINTM(X,N,M,ND,MD)
C
      DO 201 I=1,N
      DO 201 J=1,M
      XM(I,J)=X(I,J)
  201 CONTINUE
      CALL STAND(XM,N,M,ND,MD)
      WRITE (LUW,2006)
      CALL PRINTM(XM,N,M,ND,MD)
C
      CALL RCOEF(XM,N,M,ND,MD,A,MM)
      WRITE (LUW,2007)
      CALL PRINTM(A,M,M,MM,MM)
C
      DO 100 I=2,M
      C(I-1)=A(I,1)
      DO 100 J=2,M
      A(I-1,J-1)=A(I,J)
  100 CONTINUE
C
      CALL SLE(A,C,M-1,MM,1.0E-08)
C
      DO 101 I=1,M
      A(1,I)=0.0
      A(2,I)=0.0
      DO 101 J=1,N
      A(1,I)=A(1,I)*X(J,I)
      A(2,I)=A(2,I)*X(J,I)**2
  101 CONTINUE
      AA=N
      AB=N-1
      AC=SQRT((A(2,1)-A(1,1)*A(1,1)/AA)/AB)
      B(1)=A(1,1)/AA
      DO 102 I=2,M
      B(I)=C(I-1)*AC/SQRT((A(2,I)-A(1,I)*A(1,I)/AA)/AB)
      B(1)=B(1)-B(I)*A(1,I)/AA
  102 CONTINUE
C
      DO 103 I=1,N
      D(I,2)=B(1)
      DO 104 J=2,M
      D(I,2)=D(I,2)+B(J)*X(I,J)
  104 CONTINUE
      D(I,3)=D(I,1)-D(I,2)
  103 CONTINUE
C
      WRITE (LUW,2008)
      CALL PRINTM(D,N,3,ND,3)
C
      WRITE (LUW,2010)
      CALL PRINTM(C,M-1,1,MM,1)
C
      SY=0.0
      SYY=0.0
      SYC=0.0
      SYYC=0.0
      DO 105 I=1,N
      SY=SY+D(I,1)
      SYY=SYY+D(I,1)**2
      SYC=SYC+D(I,2)
      SYYC=SYYC+D(I,2)**2
  105 CONTINUE
      SST=SYY-SY*SY/FLOAT(N)
      SSR=SYYC-SYC*SYC/FLOAT(N)
      SSD=SST-SSR
      NDF1=N-M
      AMSR=SSR/FLOAT(NDF1)
      NDF2=N-M
      AMSD=SSD/FLOAT(NDF2)
      R2=SSR/SST
      R=SQRT(R2)
      F=AMSR/AMSD
      NDF3=N-1
C
      WRITE (LUW,2000)
      WRITE (LUW,2001) SSR,NDF1,AMSR,F
      WRITE (LUW,2002) SSD,NDF2,AMSD
      WRITE (LUW,2003) SST,NDF3
      WRITE (LUW,2004) R2,R
      GOTO 9999
 2000 FORMAT (10H1SOURCE OF,13X,25HSUM OF  DEGREES OF  MEAN,/,
     11 0H VARIATION,13X,37HSQUARES  FREEDOM SQUARES      F-TEST,/,
     2  1X,60(1H-))
 2001 FORMAT (11H REGRESSION,10X,F10.2,I8,2X,F10.2,/,51X,F10.4)
 2002 FORMAT (10H DEVIATION,11X,F10.2,I8,2X,F10.2)
 2003 FORMAT(16HOTOTAL VARIATION,5X,F10.2,I8)
 2004 FORMAT ('0GOODNESS OF FIT = ',F10.4,/,
     1  '0CORRELATION COEFFICIENT = ',F10.4)
 2005 FORMAT (1HO,4X,'INPUT DATA MATRIX -',1X,
     1  'COLUMNS = VARIABLES, ROWS = OBSERVATIONS')
 2006 FORMAT (1HO,4X,'STANDARDIZED INPUT DATA MATRIX -',1X,
     1  'COLUMNS = VARIABLES, ROWS = OBSERVATIONS')
 2007 FORMAT (1HO,4X,'CORRELATION MATRIX.  VARIABLE 1 IS Y')
 2008 FORMAT (1HO,4X,'COLUMN 1 = Y, COLUMN 2 = ESTIMATED Y,',1X,
     1  'COLUMN 3 = DEVIATION')
 2009 FORMAT (1HO,4X,'REGRESSION COEFFICIENTS',3X,
     1  '1 = CONSTANT TERM')
 2010 FORMAT (1HO,4X,'STANDARDIZED PARTIAL REGRESSION',1X,
     1  'COEFFICIENTS   CONSTANT TERM = 0.0')
 9999 END
C******************************************************************************
      SUBROUTINE RCOEF(X,N,M,N1,M1,A,M2)   !  7-3  
C
      REAL X(N1,M1),A(M2,M2)
      COMMON    / LU / LUW
      AN=N
C
      DO 100 I=1,M
       DO 100 J=I,M
C
         SX1=0.0
         SX2=0.0
         SX1X1=0.0
         SX2X2=0.0
         SX1X2=0.0
C
         DO 101 K=1,N
            SX1=SX1+X(K,I)
            SX2=SX2+X(K,J)
            SX1X1=SX1X1+X(K,I)**2
            SX2X2=SX2X2+X(K,J)**2
            SX1X2=SX1X2+X(K,I)*X(K,J)
  101    CONTINUE
C
         R=(SX1X2-SX1*SX2/AN)/
     1     SQRT((SX1X1-SX1*SX1/AN)*(SX2X2-SX2*SX2/AN))
         A(I,J)=R
         A(J,I)=R
  100 CONTINUE
 9999 END     
C****************************************************************************** 
      SUBROUTINE STAND(X,N,M,N1,M1)   ! 7-4  S.427
C
      DIMENSION X(N1,M1)
      COMMON    / LU / LUW
C
      DO 100 I=1,M
C
      SX=0.0
      SXX=0.0
      DO 101 J=1,N
      SX=SX+X(J,I)
      SXX=SXX+X(J,I)**2
  101 CONTINUE
      XM=SX/FLOAT(N)
      SD=SQRT((SXX-SX*SX/FLOAT(N))/FLOAT(N-1))
C
      DO 102 J=1,N
      X(J,I)=(X(J,I)-XM)/SD
  102 CONTINUE
  100 CONTINUE
 9999 END
C****************************************************************************** 
      SUBROUTINE DISCRM   !  7-5
C     
      DIMENSION X(100,20,2),A(20,20),B(20),C(2,20),NS(2)
      COMMON    / LU / LUW
      ND=100
      MD=20
      MM=20
C
      DO 100 I=1,MM
      C(1,I)=0.0
      C(2,I)=0.0
      DO 100 J=1,MM
      A(I,J)=0.0
 100  CONTINUE
C
      DO 101 I=1,2
      CALL READM(X(1,1,I),N,M,ND,MD)
      IF (M .EQ. 0) GOTO 9999
      CALL PRINTM(X(1,1,I),N,M,ND,MD)
      WRITE (LUW,2007) I
      NS(I)=N
      DO 102 J=1,N
      DO 102 K=1,M
      C(I,K)=C(I,K)+X(J,K,I)
      DO 102 L=1,M
      A(K,L)=A(K,L)+X(J,K,I)*X(J,L,I)
 102  CONTINUE
 101  CONTINUE
      AN1=NS(1)
      AN2=NS(2)
      AN3=AN1+AN2-2.0
      DO 103 I=1,M
      B(I)=C(1,I)/AN1-C(2,I)/AN2
      DO 103 J=1,M
      A(I,J)=(A(I,J)-C(1,I)*C(1,J)/AN1-C(2,I)*C(2,J)/AN2)/AN3
 103  CONTINUE
C
      CALL SLE(A,B,M,MM,1.0E-07)
C
      RO=0.0
      R1=0.0
      R2=0.0
      D2=0.0
      DO 104 I=1,M
      R0=R0+B(I)*(C(1,I)/AN1+C(2,I)/AN2)/2.0
      R1=R1+B(I)*C(1,I)/AN1
      R2=R2+B(I)*C(2,I)/AN2
      D2=D2+B(I)*(C(1,I)/AN1-C(2,I)/AN2)
 104  CONTINUE
      AM=M
      F=(((AN1+AN2-AM-1.0)*AN1*AN2)/(AN3*AM*(AN1+AN2)))*D2
      ND1=M
      ND2=NS(1)+NS(2)-M-1
      WRITE (LUW,2001) F,ND1,ND2
      WRITE (LUW,2002) D2
      WRITE (LUW,2003) R1,R0,R2
      WRITE (LUW,2004)
      DO 105 I=1,M
      E=(B(I)*(C(1,I)/AN1-C(2,I)/AN2)/D2)*100.0
      WRITE (LUW,2005) I,B(I),E
 105  CONTINUE
      DO 106 I=1,2
      J=NS(I)
      DO 107 K=1,J
      D=0.0
      DO 108 L=1,M
      D=D+B(L)*X(K,L,I)
 108  CONTINUE
      WRITE (LUW,2006) K,D
 107  CONTINUE
      WRITE (LUW,2008) I
 106  CONTINUE
      GOTO 9999
2001  FORMAT (' F = ',F12.4,' WITH ',I3,' AND ',I3,
     1 ' DEGREES OF FREEDOM')
2002  FORMAT ('0MAHALANOBIS D2 = ',F12.2)
2003  FORMAT ('0R1 = ',3X,F15.4,/,' RZERO = ',F15.4,/,'R2 = ',3X,F15.4)
2004  FORMAT (1HO,4X,'VARIABLE',10X,'CONSTANT',9X,'PRCT. ADDED')
2005  FORMAT (6X,I4,2F20.4)
2006  FORMAT (6X,I9,F20.4)
2007  FORMAT (1HO,4X,'INPUT DATA MATRIX FOR GROUP ',I2,3H - ,
     1 'COLUMNS = VARIABLES, ROWS = OBSERVATIONS')
2008  FORMAT (1HO,4X,'DISCRIMINANT SCORES FOR GROUP ',I2)
9999  END
C******************************************************************************
      SUBROUTINE CLUSTR
C
      DIMENSION X(500,500),IPAIR(2,500),XLEV(500),A(500,500)
      CHARACTER CLS*10
      COMMON    / LU / LUW
      MD=500
      ND=500
      MM=500
C
    1 CONTINUE
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
      WRITE (6, '(/,X,A)')  '*** CLUSTER ANALYSIS ***'
      WRITE (6, '(X,A,//)') '************************'
      TYPE 164
 164  FORMAT (
     *' 1 = INPUT A DATA MATRIX'/
     *' 2 = INPUT A DATA MATRIX AND TRANSPOSE IT'/
     *'$3 = INPUT A SIMILARITY MATRIX              ==>  ')
      READ (5, '(I3)') ITYPE
      TYPE 165
 165  FORMAT (//,
     *' 1 = CALCULATE CORRELATION MATRIX'/
     *'$2 = CALCULATE DISTANCE MATRIX              ==>  ')
      READ (5, '(I3)') ISIM
      WRITE (6,'(A)') ' '
C
      IF (ITYPE .NE. 3) GO TO 2
      CALL READM (A,N,M,MM,MM)
      IF (M .EQ. 0) GOTO 9999
      GO TO 4
C
    2 CALL READM (X,N,M,ND,MD)
      IF (M .EQ. 0) GOTO 9999
      IF (LUW .EQ. 77) THEN
         WRITE (LUW,2001)
 2001    FORMAT (1HO,4X,'INPUT DATA MATRIX -',1X,
     1   'COLUMNS = VARIABLES, ROWS = OBSERVATIONS')
         CALL PRINTM (X,N,M,ND,MD)
      END IF
C
      IF (ITYPE .NE. 2) GO TO 3
      MT=M
      IF (N .GT. M) MT=N
      DO 110 I=1,MT
       DO 110 J=I,MT
         XS=X(I,J)
         X(I,J)=X(J,I)
         X(J,I)=XS
  110 CONTINUE 
      MT=M
      M=N
      N=MT
C
    3 IF (ISIM .EQ. 1) CALL RCOEF(X,N,M,ND,MD,A,MM)
      IF (ISIM .EQ. 2) CALL DIST (X,N,M,ND,MD,A,MM)
C
      IF (LUW .EQ. 77) THEN
    4    WRITE (LUW,2002)
 2002    FORMAT (1HO,4X,'SIMILARITY MATRIX')
         CALL PRINTM(A,M,M,MM,MM)
      END IF
      CALL WPGA(A,M,MM,IPAIR,XLEV,ISIM)
      CALL DENDRO(IPAIR,XLEV,M,MM,ISIM)
 9999 END
C******************************************************************************
      SUBROUTINE WPGA(X,M,M1,IPAIR,XLEV,ISIM)   !  7-7
C
      DIMENSION X(M1,M1),IPAIR(2,M1),XLEV(M1)
      DIMENSION I1(100),I2(100),XSIM(100)
      COMMON    / LU / LUW
C
      DO 110 I = 1,M
      I1(I)=I
  110 CONTINUE
      XXXX=-9.0E+35
      IF (ISIM .NE. 1) XXXX=+9.0E+35
      M3=M-1
      IC=0
C
    1 DO 100 I=1,M
      IF (I1(I) .LE. 0) GO TO 100 
      IX=0
      XX=XXXX
      DO 101 J=1,M
      IF (I .EQ. J) GO TO 101
      IF (I1(J) .LE. 0) GO TO 101
      GO TO (11,12),ISIM
   11 IF (X(J,I)-XX) 101,101,13
   12 IF (X(J,I)-XX) 13,101,101
   13 XX=X(J,I)
      IX=J
  101 CONTINUE
      I2(I)=IX
      XSIM(I)=XX
  100 CONTINUE
C
      DO 102 I=1,M3
      IF (I1(I) .LE. 0) GO TO 102
      J=I2(I)
      IF (I1(J) .LE. 0) GO TO 102
      IF (J .LE. I) GO TO 102
      IF (I1(J) .EQ. I) GO TO 14
      IF (ABS(XSIM(I)-XSIM(J)) .GT. 0.00001) GO TO 102
C
   14 IC=IC+1
      IPAIR(1,IC)=I
      IPAIR(2,IC)=J
      XLEV(IC)=XSIM(I)
      WRITE (LUW,2002) I,J,XSIM(I)
      I1(I)=J
      I1(J)=0
C
      DO 103 K=1,M
      X(K,I)=(X(K,I)+X(K,J))/2.0
  103 CONTINUE
  102 CONTINUE
C
      DO 105 I=1,M3
      IF (I1(I) .LE. 0) GO TO 105
      IF (I1(I) .EQ. I) GO TO 105
      J=I1(I)
C
      DO 106 K=1,M
      IF (I1(K) .LE. 0) GO TO 106
      X(I,K)=(X(I,K)+X(J,K))/2.0
  106 CONTINUE
      I1(I)=I
  105 CONTINUE
      IF (IC .LT. M3) GO TO 1
      WRITE (LUW,2003)
 2002 FORMAT (6X,2I5,F15.5)
 2003 FORMAT (1HO,4X,'COLUMNS 1 AND 2 -',1X,
     1 'OBSERVATIONS COMBINED INTO CLUSTERS',/,
     2 5X,'COLUMN 3 - SIMILARITY LEVEL OF CLUSTERING')
 9999 END    
C******************************************************************************
      SUBROUTINE DENDRO(IPAIR,XLEV,M,M1,ISIM)   !  7-8
C     
      DIMENSION IPAIR(2,M1),XLEV(M1)
      DIMENSION I1(100),I2(100)
      DIMENSION IOUT(61),XX(13)
      DATA IBLNK,ICI,ICP,ICM/1H ,1HI,1H.,1H-/
      COMMON    / LU / LUW
C
      M2=M-1
      DO 100 I=1,M
      I1(I)=0
      I2(I)=0
  100 CONTINUE
      DO 101 I=1,M2
      J=I-1
   11 IF (J .LE. 0) GO TO 12
      IF (IPAIR(1,I) .EQ. IPAIR(1,J)) GO TO 13
      J = J-1
      GO TO 11
   12 I2(I)=1
      GO TO 15
   13 K=I1(J)
      IF (K .EQ. 0) GO TO 14
      J=K 
      GO TO 13
   14 I1(J)=I
   15 DO 102 J=1,I
      K=J
      IF (IPAIR(2,I) .EQ. IPAIR(1,J)) GO TO 16
  102 CONTINUE
      GO TO 101
   16 I2(K)=0
      I1(I)=K
  101 CONTINUE
C
      DO 103 I=1,M2
      JS=I
      IF (I2(I) .NE. 0) GO TO 20
  103 CONTINUE
   20 NODE=IPAIR(1,JS)
C
      XMIN=XLEV(1)
      XMAX=XMIN
      DO 104 I=1,M2
      IF (XLEV(I) .LT. XMIN) XMIN=XLEV(I)
      IF (XLEV(I) .GT. XMAX) XMAX=XLEV(I)
  104 CONTINUE
      DX=(XMAX-XMIN)/25.0
      XMIN=XMIN-DX
      XMAX=XMAX+DX
      DX=(XMAX-XMIN)/60.0             
      IF (ISIM .NE. 2) GO TO 21
      DX=-DX
      XMIN=XMAX
C
   21 DO 105 I=1,61
      IOUT(I)=IBLNK
  105 CONTINUE
C
      X=XMIN
      DO 106 I=1,13
      XX(I)=X
      X=X+DX*5.0
  106 CONTINUE
      WRITE (LUW,2005)
      WRITE (LUW,2001) (XX(I),I=2,12,2)
      WRITE (LUW,2002) (XX(I),I=1,13,2)
      WRITE (LUW,2003)
   22 X=XMIN
      IF (JS .NE. 0) X=XLEV(JS)
      IS=IFIX((X-XMIN)/DX)+1
      DO 110 I=IS,61
      IOUT(I)=ICM
  110 CONTINUE
      IOUT(IS)=ICP
      IF (JS .NE. 0) WRITE (LUW,2004) IOUT,NODE,X
      IF (JS .EQ. 0) WRITE (LUW,2004) IOUT,NODE
      IF (JS .EQ. 0) GO TO 31
      DO 111 I=IS,61
      IOUT(I)=IBLNK 
  111 CONTINUE
      IOUT(IS)=ICI
      WRITE (LUW,2004) (IOUT(I),I=1,IS)
      NODE=IPAIR(2,JS)
      JS=I1(JS)
      GO TO 22
   31 WRITE (LUW,2003)
      WRITE (LUW,2002) (XX(I),I=1,13,2)
      WRITE (LUW,2001) (XX(I),I=2,12,2)
 2001 FORMAT (6X,6F10.4)
 2002 FORMAT (1X,7F10.4)
 2003 FORMAT (6X,'+',12('----+'))
 2004 FORMAT (6X,61A1,1X,I3,F10.4)
 2005 FORMAT (1HO,4X,'DENDROGRAM - ',1X,
     1 'VALUES ALONG X-AXIS ARE SIMILARITIES')
 9999 END 
C******************************************************************************
      SUBROUTINE DIST(X,N,M,N1,M1,A,M2)   !  7-9
C
      DIMENSION X(N1,M1),A(M2,M2)
      COMMON    / LU / LUW
      AN=N
C
      DO 100 I=1,M
      DO 100 J=I,M
C
      DISTX=0.0
      DO 101 K=1,N
      DISTX=DISTX+(X(K,I)-X(K,J))**2
  101 CONTINUE
C
      A(I,J)=SQRT(DISTX/AN)
      A(J,I)=A(I,J)
  100 CONTINUE
 9999 END      
C******************************************************************************
      SUBROUTINE PCA   !  7-10
C
      PARAMETER (NPAR = 400)
      DIMENSION X(NPAR,NPAR), 
     *         A1(NPAR,NPAR), A2(NPAR,NPAR), SCORE(NPAR,NPAR)
      CHARACTER CLS*10
      COMMON    / LU / LUW                                              
      MD=NPAR
      ND=NPAR
      MM=NPAR
C
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
      WRITE (6, '(/,X,A)')  '*** PRINCIPAL COMPONENT ANALYSIS ***'
      WRITE (6, '(X,A,//)') '************************************'
      TYPE 164
 164  FORMAT (
     *' 0 = Exit'/
     *' 1 = DO NOT TRANSPOSE INPUT DATA MATRIX'/
     *'$2 = TRANSPOSE INPUT DATA MATRIX            ==>  ')
      READ (5, '(I3)') ITRANS
      IF(ITRANS .LE. 0) GOTO 9999
C
      TYPE 165
 165  FORMAT (//,
     *' 1 = CALCULATE CORRELATION MATRIX'/
     *'$2 = CALCULATE COVARIANCE MATRIX            ==>  ')
      READ (5, '(I3)') ISIM
      WRITE (6,'(A)') ' '
C
      CALL READM(X,N,M,ND,MD)
      IF (M .EQ. 0) GOTO 9999
      IF (LUW .EQ. 77) THEN
         CALL PRINTM(X,N,M,ND,MD)
         WRITE (LUW,2001)
 2001    FORMAT (1HO,4X,'INPUT DATA MATRIX -',1X,
     1   'COLUMNS = VARIABLES, ROWS = OBSERVATIONS')
      END IF
C
      IF (ISIM .NE. 1) GO TO 2
      CALL STAND(X,N,M,ND,MD)
      IF (LUW .EQ. 77) THEN
         CALL PRINTM(X,N,M,ND,MD)
         WRITE (LUW,2006)
 2006    FORMAT (1HO,4X,'STANDARDIZED INPUT DATA MATRIX -',1X,
     1   'COLUMNS = VARIABLES, ROWS = OBSERVATIONS')
      END IF
C
    2 IF (ITRANS .NE. 2) GO TO 3
      MT=M
      IF (N .GT. M) MT=N
      DO 110 I=1,MT
      DO 110 J=I,MT
      XS=X(I,J)
      X(I,J)=X(I,J)
      X(I,J)=XS
  110 CONTINUE
      MT=M
      M=N
      N=MT
C      
    3 IF (ISIM .EQ. 1) CALL RCOEF(X,N,M,ND,MD,A1,MM)
      IF (ISIM .EQ. 2) CALL COV  (X,N,M,ND,MD,A1,MM)
      IF (LUW .EQ. 77) THEN
         CALL PRINTM(A1,M,M,MM,MM)
         WRITE (LUW,2002)
 2002    FORMAT (1HO,4X,'SIMILARITY MATRIX')
      END IF
      CALL EIGENJ(A1,A2,M,MM)
C
      SUME=0.0
      DO 100 I=1,M
      A1(I,1)=A1(I,I)
      SUME=SUME+A1(I,1)
  100 CONTINUE
C
      SUMEE=0.0
      DO 101 I=1,M
      A1(I,2)=A1(I,1)*100.0/SUME
      SUMEE=SUMEE+A1(I,1)
      A1(I,3)=SUMEE*100.0/SUME
  101 CONTINUE
C
      WRITE (LUW,2003)
 2003 FORMAT (1HO,4X,'COLUMN 1 = EIGENVALUES',2X,
     1 'COLUMN 2 = PERCENT OF TRACE',/,
     2 5X,'COLUMN 3 = CUMULATIVE PERCENT OF TRACE')
      CALL PRINTM(A1,M,3,MM,MM)
C
      WRITE (LUW,2004)
 2004 FORMAT (1HO,4X,'PRINCIPAL AXIS MATRIX -',1X,
     1 'COLUMNS = EIGENVECTORS, ROWS = VARIABLES')
      CALL PRINTM(A2,M,M,MM,MM)
C
      CALL MMULT(X,A2,SCORE,N,M,M,ND,MD,MM,MM,ND,MD)
      WRITE (LUW,2005)
 2005 FORMAT (1HO,4X,'PRINCIPAL COMPONENT SCORES -',1X,
     1 'COLUMNS = EIGENVECTORS, ROWS = OBSERVATIONS')
      CALL PRINTM(SCORE,N,M,ND,MD)
 9999 END
C******************************************************************************
      SUBROUTINE FACT   !  7-12  S.519
C
      PARAMETER (NP = 400)
      DIMENSION X(NP,NP),FSCORE(NP,NP)
      DIMENSION A1(NP,NP),A2(NP,NP),A3(NP,NP)
      CHARACTER CLS*10, FMT*10, CVAR*3
      COMMON    / LU / LUW
      MD=NP
      ND=NP
      MM=NP
C
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
      WRITE (6, '(/,X,A)')  '*** FACTOR ANALYSIS ***'
      WRITE (6, '(X,A,//)') '***********************'
      TYPE 164
 164  FORMAT (
     *' 0 = Exit'/
     *' 1 = Do not transpose data matrix'/
     *'$2 = Transpose data matrix                  ==>  ')
      READ (5, '(I3)') ITRAN
      IF (ITRAN .LE. 0) GOTO 9999
C
      TYPE 165
 165  FORMAT (//,
     *' 1 = Calculate correlation matrix'/
     *'$2 = Calculate cosine theta matrix          ==>  ')
      READ (5, '(I3)') ISIM
      WRITE (6,'(/,A)')
     *'$Numbers of factors desired                 ==>  '
      READ (6,'(I3)') L
C
      CALL READM(X,N,M,ND,MD)
      IF (M .EQ. 0) GOTO 9999
      IF (LUW .EQ. 77) THEN
         WRITE (LUW,'(/,4X,A)')
     1   'INPUT DATA MATRIX - Columns = Variables, Rows = Observations'
          CALL PRINTM(X,N,M,ND,MD)
      END IF
C
      IF (ISIM .NE. 1) GO TO 2
      CALL STAND(X,N,M,ND,MD)
      IF (LUW .EQ. 77) THEN
         WRITE (LUW,'(/,4X,A)') 'STANDARDIZED INPUT DATA MATRIX -
     1 Columns = Variables, Rows = Observations'
         CALL PRINTM(X,N,M,ND,MD)
      END IF
C
    2 IF (ITRAN .NE. 2) GO TO 3
      MT=M
      IF (N .GT. M) MT=N
      DO 110 I=1,MT
      DO 110 J=I,MT
      XS=X(I,J)
      X(I,J)=X(J,I)
      X(J,I)=XS
  110 CONTINUE
      MT=M
      M=N
      N=MT
C
    3 IF (ISIM .EQ. 1) CALL RCOEF(X,N,M,ND,MD,A1,MM)
      IF (ISIM .EQ. 2) CALL CTHETA(X,N,M,ND,MD,A1,MM)
      IF (LUW .EQ. 77) THEN
         WRITE (LUW,'(/,4X,A)') 'SIMILARITY MATRIX'
         CALL PRINTM(A1,M,M,MM,MM)
      END IF
C
      IF (ISIM .NE. 1) GO TO 4
      DO 111 I=1,M
      DO 111 J=1,M
      A3(I,J)=A1(I,J)
  111 CONTINUE
C
    4 CALL EIGENJ(A1,A2,M,MM)
C
      SUME=0.0
      DO 100 I=1,M
      A1(I,1)=A1(I,I)
      SUME=SUME+A1(I,1)
  100 CONTINUE
C
      SUMEE=0.0
      DO 101 I=1,M
      A1(I,2)=A1(I,1)*100.0/SUME
      SUMEE=SUMEE+A1(I,1)
      A1(I,3)=SUMEE*100.0/SUME
  101 CONTINUE
C
      WRITE (LUW,'(/,4X,A)') 'Column 1 = EIGENVALUES | Column 2 = 
     1 PERCENT OF TRACE | Column 3 = CUMULATIVE PERCENT OF TRACE'
      CALL PRINTM(A1,M,3,MM,MM)
C
      IF (LUW .EQ. 77) THEN
         WRITE (LUW,'(/,4X,A)') 'PRINCIPAL AXIS MATRIX -
     1 Columns = Eigenvectors, Rows = Variables'
         CALL PRINTM(A2,M,M,MM,MM)
      END IF
C
      DO 102 I=1,M
      DO 102 J=1,L
      A2(I,J)=A2(I,J)*SQRT(A1(J,1))
  102 CONTINUE
C
      IF (LUW .EQ. 77) THEN
         WRITE (LUW,'(/,4X,A)') 'FACTOR LOADINGS -
     1 Columns = Factors, Rows = Variables'
         CALL PRINTM(A2,M,M,MM,MM)
      END IF
C
      IF (ISIM .NE. 1) GO TO 5
      DO 112 I=1,M
      DO 112 J=I,M
      DET=0.0
      DO 113 K=1,L
      DET=DET+A2(I,K)*A2(J,K)
  113 CONTINUE
      A1(I,J)=DET
      A1(J,I)=DET
  112 CONTINUE
C
      IF (LUW .EQ. 77) THEN
         WRITE (LUW,'(/,4X,A)') 'REPRODUCED CORRELATION MATRIX'
         CALL PRINTM(A1,M,M,MM,MM)
C
         CALL SUBM(A3,A1,A3,M,M,MM,MM)
         WRITE (LUW,'(/,4X,A)') 'RESIDUAL CORRELATION MATRIX'
         CALL PRINTM(A3,M,M,MM,MM)
      END IF
C
    5 DO 103 I=1,L
      DO 103 J=I,L
      DET=0.0
      DO 104 K=1,M
      DET=DET+A2(K,I)*A2(K,J)
  104 CONTINUE
      A3(I,J)=DET
      A3(J,I)=DET
  103 CONTINUE
      CALL MINV(A3,A1,L,MM,DET)
      CALL MMULT(A2,A1,A3,M,L,L,MM,MM,MM,MM,MM,MM)
      CALL MMULT(X,A3,FSCORE,N,M,L,ND,MD,MM,MM,ND,MD)
      WRITE (LUW,'(/,4X,A)')
     1  'FACTOR SCORES - Columns = Factors, Rows = Observations'
      CALL PRINTM(FSCORE,N,L,ND,MD)
C
      CALL VARMAX(A2,M,L,MM)
      WRITE (LUW,'(/,4X,A)') 
     1  'ROTATED FACTOR MATRIX - Columns = Factors, Rows = Variables'
      CALL PRINTM(A2,M,L,MM,MM)
C
      DO 105 I=1,L
      DO 105 J=I,L
      DET=0.0
      DO 106 K=1,M
      DET=DET+A2(K,I)*A2(K,J)
  106 CONTINUE
      A3(I,J)=DET
      A3(J,I)=DET
  105 CONTINUE
      CALL MINV(A3,A1,L,MM,DET)
      CALL MMULT(A2,A1,A3,M,L,L,MM,MM,MM,MM,MM,MM)
      CALL MMULT(X,A3,FSCORE,N,M,L,ND,MD,MM,MM,ND,MD)
C
      WRITE (LUW,'(/,4X,A)') 'VARIMAX FACTOR SCORES -
     1 Columns = Factors, Rows = Observations'
      CALL PRINTM(FSCORE,N,L,ND,MD)
 9999 END
C******************************************************************************
      SUBROUTINE VARMAX(F,M,L,M1)   !  7-13  S.522
C
      DIMENSION F(M1,M1), H(400)
      COMMON    / LU / LUW
C
      SQRT2=1.0/SQRT(2.0)
      XM=M
      L1=L-1
      NIT=-1
      NCM=0
C
      DO 100 I=1,M
         SUMH=0.0
         DO 101 J=1,L
            SUMH=SUMH+F(I,J)**2
 101     CONTINUE
         H(I)=SUMH
         DO 102 J=1,L
            F(I,J)=F(I,J)/SQRT(SUMH)
 102     CONTINUE 
 100  CONTINUE
C
      WRITE (LUW,'(/,4X,A)')
     1  'Number of VARIMAX ITERATIONS and VARIANCE at each step'
   1  TVF = 0.0
      DO 103 I=1,L
         SF1=0.0
         SF2=0.0
         DO 104 J=1,M
            SF1=SF1+F(J,I)**2
            SF2=SF2+F(J,I)**4
 104     CONTINUE
         TVF=TVF+(XM*SF2-SF1*SF1)/(XM*XM)
 103  CONTINUE
      IF (NIT .LT. 0) GO TO 2
C
      IF (ABS(TVF-TVI) .GT. 0.000001) GO TO 2
      NCM=NCM+1
      IF (NCM .GE. 5) GO TO 50
   2  NIT=NIT+1
      TVI=TVF
      WRITE (LUW,'(10X,I5,3X,F15.7)') NIT,TVF
C
      DO 105 I=1,L1
         L2=I+1
         DO 106 J=L2,L
C
            A=0.0
            B=0.0
            C=0.0
            D=0.0
            DO 107 K=1,M
               X=F(K,I)
               Y=F(K,J)
               U=(X+Y)*(X-Y)
               V=2.0*X*Y
               A=A+U
               B=B+V
               C=C+(U+V)*(U-V)
               D=D+2.0*U*V
 107        CONTINUE
            XN=D-(2.0*A*B)/XM
            XO=C-(A*A-B*B)/XM
            XR=SQRT(XN*XN+XO*XO)
            IF (XR .LE. 0.001) GOTO 106
            COS4T=XO/XR
            COS2T=SQRT((1.0+COS4T)/2.0)
            COS1T=SQRT((1.0+COS2T)/2.0)
            SIN1T=SQRT(1.0-COS1T*COS1T)
C
            IF (SIN1T .LE. 0.001) GO TO 106
            IF (XN .LT. 0.0) SIN1T=-SIN1T
C
            DO 108 K=1,M
               X=F(K,I)
               Y=F(K,J)
               F(K,I)=X*COS1T+Y*SIN1T
               F(K,J)=Y*COS1T-X*SIN1T
 108        CONTINUE
 106     CONTINUE
 105  CONTINUE
      GO TO 1
  50  CONTINUE
C 
      WRITE (LUW,'(/,4X,A)') 'Column 1 = INITIAL COMMUNALITY | 
     1Column 2 = COMMUNALITY AFTER ROTATION | Column 3 = DIFFERENCE'
      DO 110 I=1,M
         SUMH=0.0
         DO 111 J=1,L
            F(I,J)=F(I,J)*SQRT(H(I))
            SUMH=SUMH+F(I,J)**2
 111     CONTINUE
         D=H(I)-SUMH
         WRITE (LUW,'(1X,I5,3F15.7)') I,H(I),SUMH,D
 110  CONTINUE
 9999 END
C****************************************************************************** 
      SUBROUTINE CTHETA(X,N,M,N1,M1,A,M2)   !  7-14  S.525
C
      DIMENSION X(N1,M1),A(M2,M2)
      COMMON    / LU / LUW
C
      DO 100 I=1,M
      DO 100 J=I,M
C
      SX1X1=0.0
      SX2X2=0.0
      SX1X2=0.0
C
      DO 101 K=1,N
      SX1X1=SX1X1+X(K,I)**2
      SX2X2=SX2X2+X(K,J)**2
      SX1X2=SX1X2+X(K,I)*X(K,J)
  101 CONTINUE
C
      A(I,J)=SX1X2/SQRT(SX1X1*SX2X2)
      A(J,I)=A(I,J)
  100 CONTINUE
 9999 END
C*****************************************************************************
      SUBROUTINE EIGENJ(A,B,N,N1)   !4.10  S.166
      DIMENSION A(N1,N1),B(N1,N1)
      COMMON    / LU / LUW
C
      ANORM=0.0
      DO 100 I=1,N
         DO 101 J=1,N
            IF (I-J) 2,1,2
    1       B(I,J)=1.0
            GO TO 101
    2       B(I,J)=0.0
            ANORM=ANORM+A(I,J)*A(I,J)
  101    CONTINUE
  100 CONTINUE    
      ANORM=SQRT(ANORM)
      FNORM=ANORM*1.0E-09/FLOAT(N)
C
      THR=ANORM
   23 THR=THR/FLOAT(N)
    3 IND=0
C
      DO 102 I=2,N
         I1=I-1
         DO 103 J=1,I1
            IF (ABS(A(J,I))-THR) 103,4,4
    4       IND=1
            AL=-A(J,I)
            AM=(A(J,J)-A(I,I))/2.0
            AO=AL/SQRT(AL*AL+AM*AM)
            IF (AM) 5,6,6
    5       AO=-AO
    6       SINX=AO/SQRT(2.0*(1.0+SQRT(1.0-AO*AO)))
            SINX2=SINX*SINX
            COSX=SQRT(1.0-SINX2)
      COSX2=COSX*COSX
C
            DO 104 K=1,N
               IF (K-J) 7,10,7
    7          IF (K-I) 8,10,8
    8          AT=A(K,J)
               A(K,J)=AT*COSX-A(K,I)*SINX
               A(K,I)=AT*SINX+A(K,I)*COSX
   10          BT=B(K,J)
               B(K,J)=BT*COSX-B(K,I)*SINX
               B(K,I)=BT*SINX+B(K,I)*COSX
  104       CONTINUE
            XT=2.0*A(J,I)*SINX*COSX
            AT=A(J,J)
            BT=A(I,I)
            A(J,J)=AT*COSX2+BT*SINX2-XT
            A(I,I)=AT*SINX2+BT*COSX2+XT
            A(J,I)=(AT-BT)*SINX*COSX+A(J,I)*(COSX2-SINX2)
            A(I,J)=A(J,I)
            DO 105 K=1,N
               A(J,K)=A(K,J)
               A(I,K)=A(K,I)
  105       CONTINUE
  103    CONTINUE
  102 CONTINUE
      IF (IND) 20,20,3 
   20 IF (THR-FNORM) 25,25,23
C
   25 DO 110 I=2,N
         J=I
   29    IF (A(J-1,J-1)-A(J,J)) 30,110,110
   30    AT=A(J-1,J-1)
         A(J-1,J-1)=A(J,J)
         A(J,J)=AT
         DO 111 K=1,N
            AT=B(K,J-1)
            B(K,J-1) = B(K,J)
            B(K,J)=AT   
  111    CONTINUE
         J=J-1
         IF (J-1) 110,110,29
  110 CONTINUE
 9999 END
C*****************************************************************************
      SUBROUTINE COV(X,N,M,N1,M1,A,M2)   !7.11  S.496
      REAL X(N1,M1),A(M2,M2)
      AN=N
      AN1=N-1
C
      DO 100 I=1,M
      DO 100 J=I,M
C
      SX1=0.0
      SX2=0.0
      SX1X2=0.0
C
      DO 101 K=1,N
      SX1=SX1+X(K,I)
      SX2=SX2+X(K,J)
      SX1X2=SX1X2+X(K,I)*X(K,J)
  101 CONTINUE
C
      A(I,J)=(SX1X2-SX1*SX2/AN)/AN1
      A(J,I)=A(I,J)
  100 CONTINUE
 9999 END 